﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Data.Common;
using System.Globalization;
using System.Reflection;
using System.Text;
using Produmex.Foundation;
using Produmex.Foundation.Barcode;
using Produmex.Foundation.Convertors;
using Produmex.Foundation.Data;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.Tables;
using Produmex.Foundation.Data.Sbo.DataObjects;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Data.SqlClient;
using Produmex.Foundation.Diagnostics;
using Produmex.Foundation.GS1;
using Produmex.Foundation.Messages;
using Produmex.Foundation.SlimScreen;
using Produmex.Foundation.SlimScreen.Interfaces;
using Produmex.Foundation.SlimScreen.Interfaces.Definitions;
using Produmex.Foundation.SlimScreen.Interfaces.Definitions.DataObjects;
using Produmex.Foundation.SlimScreen.Interfaces.Definitions.KnownDataSets;
using Produmex.Foundation.SlimScreen.WinGui;
using Produmex.Foundation.Utilities;
using Produmex.Foundation.Workflows;
using Produmex.Foundation.Workflows.Parameters;
using Produmex.Foundation.Wwf.Sbo.DataObjects;
using Produmex.Foundation.Wwf.Sbo.LocalServices;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.Data.DataObjects;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Foundation.Data.DbClient;
using Produmex.Foundation.Collections;

// PmxWorkflowExecutionTypes.SUB_FLOW
namespace Produmex.Sbo.Logex.WorkflowScripts
{
    /// <summary>
    /// Reception
    /// </summary>
    public class WorkflowScript_ReceptionWSBScript : WorkflowInstanceScriptBase
    {
        /// <summary>
        /// Definitions
        /// </summary>
        private static class Definitions
        {
            /// <summary>
            /// The separator for separating strings values
            /// </summary>
            public const string SEPARATOR = ", ";

            /// <summary>
            /// Minimum number of characters when entering reason
            /// </summary>
            public const int MIMIMUM_NUMBER_OF_CHARACTERS_FOR_REASON = 10;

        }


        // Input parameters
        public ReadOnlyBinder<CultureInfo> DefaultCultureInfo;
        public ReadOnlyBinder<PmxOseCompany> PmxOseCompany;
        public ReadOnlyBinder<bool> CrossDocking;

        private CultureInfo current_DefaultCultureInfo
        {
            get { return DefaultCultureInfo.Get(); }
        }

        private PmxOseCompany currentPmxOseCompany
        {
            get { return PmxOseCompany.Get(); }
        }


        //Subflows
        WorkflowInstanceBase m_enterQuantitySubFlow;

        protected bool m_subFlowBackRequested;
        protected Collection<string> m_subFlowListOfSerialNumbers;
        protected double m_subFlowQuantity;


        private WorkflowInstanceBase m_printItemLabelFlow;
        private bool m_printItemLabelFlow_BackRequested = false;

        private string m_printItemLabelFlow_LocationCode;
        private string m_printItemLabelFlow_NeededItemCode;
        private string m_printItemLabelFlow_NeededBatchNumber;
        private string m_printItemLabelFlow_NeededBatchNumber2;
        private DateTime? m_printItemLabelFlow_NeededBestBeforeDate;
        private int? m_printItemLabelFlow_NeededNrOfLabels;
        private double? m_printItemLabelFlow_EnteredQuantity;

        private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);


        #region Constructors

        public WorkflowScript_ReceptionWSBScript(WorkflowInstanceBase parent, WorkflowInstanceFactory factory)
            : base(parent, factory)
        {
            m_enterQuantitySubFlow = this.Create("EnterQuantityScript");

        }

        #endregion

        #region WorkflowInstanceScriptBase Members

        /// <summary>
        /// Executes this instance.
        /// </summary>
        protected override void Execute()
        {
            // Parameters in scope
            Session session = GetScopeParameter("Session") as Session;
            ISboProviderService sboProviderService = GetScopeParameter("<WwfService>ISboService") as ISboProviderService;
            PmxBusinessPartnerInfo businessPartnerInfo = null;

            string initialErrorKey = null;
            string deviceID = session.DeviceInstanceId;
            SboUserInfo userInfo = sboProviderService.GetCurrentUser();
            Message msg = null;
            string query = null;
            PmxOseWarehouseInfo whsInfo = null;
            DataSet dsDocks = null;
            string currentDockCode = null;
            DataSet dsPurchaseOrders = null;
            DataSet dsContainers = null;
            DocumentRef purchaseDocRef = null;
            int? containerDocEntry = null;
            int? purchaseOrderDocNum = null;
            string filterGTIN = null;
            string cardCode = null;
            string filterButtonKey = null;
            DataSet dsSuppliers = null;
            BarcodeContainer barcode = null;
            string supplierPalletNumber = null;
            int batchReceivingNumber = 1;
            List<string> buttonKeys = null;
            string titleKey = null;
            List<string> allowedButtonsForLabelScreen = null;
            string SSCC = null;
            int? luid = null;
            string scannedSSCC = null;
            //BarcodeContainer productBarCode = null;
            string itemCode = null;
            string itemDescription = null;
            PmxItemInfo itemInfo = null;
            string gtin = null;
            DataSet dsItems = null;
            Collection<LogisticUnitGoodsReceipt> purchaseDeliveryNoteList = new Collection<LogisticUnitGoodsReceipt>();
            string logisticCarrierCode = null;
            DataSet dsLogisticCarriers = null;
            double stillToReceive = 0;
            LogisticUnitGoodsReceipt currentLogUnit = null;
            string batchNumber = null;
            string secondBatchNumber = null;
            DateTime? bestBeforeDate = null;
            double quantity = 0;
            GeneratedBatchNumberReception generatedBatch1Info = null;
            GeneratedBatchNumberReception generatedBatch2Info = null;
            string tempBatchNumber = null;
            LogisticUnitItemGoodReceipt currentLogisticCarrier = null;
            DataSet dsExistingBatch = null;
            Collection<ItemTransactionalPackagingTypeInfo> currentListOfTransactionalPackagingTypeInfos;
            Collection<PackagingTypeInfo> listOfPackagingTypeInfosForScreen = null;
            int? numberOfItemLabels = 0;
            double initialQuantity = 0;
            double maxQuantity = 0;
            string supplierRef = null;
            KeyValuePair<Collection<DocumentRef>, Collection<int>> listOfGeneratedDocEntry = new KeyValuePair<Collection<DocumentRef>, Collection<int>>();
            int numberOfReports = 0;
            bool receiveAllItemsOnOnePurchaseDelivery = false;
            double? numberOfItemsInPurchaseUnit = null;
            List<string> allowedButtonsIdentifyProductScreen = null;
            bool goBack = false;
            DataSet dsCheckItems = null;
            DataSet dsItemsNonDistinct = null;
            DataSet dsSSCC = null;
            bool gotoReceiveItem = false;
            ToolBarButtons toolBarButtons = ToolBarButtons.Back;
            Collection<string> listOfSerialNumbers = null;
            bool autoSelectPO = false;
            bool askReprint = false;
            bool isContainer = false;
            string tempGTIN = null;

            GeneratedBestBeforeDateReception generatedBBDInfo = null;

            bool needToEnterSupplierPalletNumber = false;
            bool allowLabelsToBeScannedOnVendor = false;
            bool allowLogisticCarriersOnVendor = false;
            bool allowToChangeGeneratedBBDOnReception = false;

            DataSet dsReasons = null;

            string zoneTypeCode = null;
            string reasonCode = null;
            string reasonName = null;
            string reasonFreeText = null;
            Dictionary<string, bool> reasonsCodesRequiresFreeText = null;

            string reasonCodeForZoneTypeScreen = null;
            string reasonNameForZoneTypeScreen = null;
            string reasonFreeTextForZoneTypeScreen = null;
            Dictionary<string, bool> reasonsCodesRequiresFreeTextForZoneTypeScreen = null;

            DataSet dsZoneTypes = null;
            DataSet dsZoneTypesAndReasons = null;
            PmxDictionary<string, ReasonInfo> listOfReasonsCodesAndZoneTypes = null;

            whsInfo = sboProviderService.InvokeMethodWithDbConnection<PmxOseWarehouseInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxOseWarehouseInfo>(ExecuteGetPmxWarehouseCode), deviceID);

            receiveAllItemsOnOnePurchaseDelivery = sboProviderService.InvokeMethodWithDbConnection<bool>(true, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteGetReceiveAllItemsOnOnePurchaseDelivery));

            bool allowToSelectBatch = sboProviderService.InvokeMethodWithDbConnection<bool>(true, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteGetAllowToSelectBatches));
            bool crossDocking = this.CrossDocking != null && this.CrossDocking.Get();


            bool autoSelectInternalBatch = false;
            bool allowToEnterReason = false;
            bool splitQtyInLogUnitsOfItemDefQtyOnLogUnit = false;

            Collection<string> listOfLocationsForWA = new Collection<string>();


            sboProviderService.InvokeMethodWithDbConnection<object>(false, false, null, null,
             delegate(PmxDbConnection conn, object[] parameters)
             {
                 PmxPurchaseDeliveryNoteProvider prov = new PmxPurchaseDeliveryNoteProvider();
                 Dictionary<string, PmxParameterValue> pdParams = prov.GetParametersPurchaseOrderGenerator(conn);

                 autoSelectInternalBatch = PmxParameterValueProvider.GetParameterValue<bool>(pdParams, PmxExtensionParameterCodes.PURCHASE_DELIVERY_AUTO_SELECT_INTERNAL_BATCH, false);
                 allowToEnterReason = PmxParameterValueProvider.GetParameterValue<bool>(pdParams, PmxExtensionParameterCodes.PURCHASE_DELIVERY_ENTER_REASON_BY_ITEM, false);
                 splitQtyInLogUnitsOfItemDefQtyOnLogUnit = PmxParameterValueProvider.GetParameterValue<bool>(pdParams, PmxExtensionParameterCodes.PURCHASE_DELIVERY_SPLIT_QTY_IN_LOG_UNITS_OF_ITEM_DEF_QTY_ON_LOG_UNIT, false);


                 PmxOseWarehouseAutomationProvider waProv = new PmxOseWarehouseAutomationProvider(conn);
                 listOfLocationsForWA = waProv.GetAllInputLocationsForWA(true);

                 return null;
             });





            //initialize sub flows
            m_printItemLabelFlow = Create("PrintItemLabelScript");
            m_printItemLabelFlow.BindParameters(
                this.DefaultCultureInfo,
                this.PmxOseCompany,
                new ReadOnlyBinder<string>("LocationCode", this, "m_printItemLabelFlow_LocationCode"),
                new ReadOnlyBinder<string>("NeededItemCode", this, "m_printItemLabelFlow_NeededItemCode"),
                new ReadOnlyBinder<string>("NeededBatchNumber", this, "m_printItemLabelFlow_NeededBatchNumber"),
                new ReadOnlyBinder<string>("NeededBatchNumber2", this, "m_printItemLabelFlow_NeededBatchNumber2"),
                new ReadOnlyBinder<DateTime?>("NeededBestBeforeDate", this, "m_printItemLabelFlow_NeededBestBeforeDate"),
                new ReadOnlyBinder<int?>("NeededNrOfLabels", this, "m_printItemLabelFlow_NeededNrOfLabels"),
                new ReadWriteBinder<bool>("BackRequested", this, "m_printItemLabelFlow_BackRequested"),
                new ReadWriteBinder<double?>("EnteredQuantity", this, "m_printItemLabelFlow_EnteredQuantity")
                );


            bool receiveGoodsOnSelectedLocation = false;
            bool showReserveInvoices = false;
            bool allowToExceedOrderedQuantity = true;
            PmxParameterValue crossDockingPickListType = null;

            sboProviderService.InvokeMethodWithDbConnection<object>(true, false, null, null, new DelegateWithPmxDbConnection<object>(
                delegate(PmxDbConnection conn, object[] parameters)
                {
                    PmxPurchaseDeliveryNoteProvider prov = new PmxPurchaseDeliveryNoteProvider((SboConnection)conn);
                    Dictionary<string, PmxParameterValue> parms = prov.GetParametersPurchaseOrderGenerator(conn);

                    receiveGoodsOnSelectedLocation = PmxParameterValueProvider.GetParameterValue<bool>(parms, PmxExtensionParameterCodes.PURCHASE_DELIVERY_RECEIVE_ON_LOCATION, false);
                    showReserveInvoices = PmxParameterValueProvider.GetParameterValue<bool>(parms, PmxExtensionParameterCodes.PURCHASE_DELIVERY_SHOW_RESERVE_INVOICES, false);
                    allowToExceedOrderedQuantity = PmxParameterValueProvider.GetParameterValue<bool>(parms, PmxExtensionParameterCodes.PURCHASE_DELIVERY_ALLOW_TO_EXCEED_ORDERED_QTY, true);
                    if (crossDocking)
                    {
                        parms.TryGetValue(PmxExtensionParameterCodes.PURCHASE_DELIVERY_CROSS_DOCKING_PICKLISTTYPE, out crossDockingPickListType);
                    }

                    return null;
                }));

            Dictionary<string, ReasonInfo> listOfReasonCodeByItem = null;
            bool enterReason = false;



        Step_SelectDock:

            #region SELECT DOCK

            // Get locations
            query = BuildQuery.GetCodeNameDockOrderByName(crossDocking ? true : (bool?)null, true, true, whsInfo.PmxWarehouseCode, deviceID);
            dsDocks = sboProviderService.RunView(false, null, null, query);

            if (//this.GetNumberOfRows(dsDocks) == 1 && 
                !goBack)
            {
                currentDockCode = Convert.ToString(dsDocks.Tables[0].Rows[0][LocationDataSet.Columns.CODE.Name]);
                goto Step_SelectPOFilter;
            }
            goBack = false;

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectLocationScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                "InitialErrorKey", initialErrorKey,
                "TitleKey", "MSG_TITLE_SELECT_LOCATION",
                "LocationDS", dsDocks
                ));
            msg = WaitForMessage();
            initialErrorKey = null;
            if (msg.Name.EndsWith(".LocationSelected"))
            {
                currentDockCode = ExtractParameter<string>(msg.Parameters, "locationCode");
                //reset warehouse info
                whsInfo = sboProviderService.InvokeMethodWithDbConnection<PmxOseWarehouseInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxOseWarehouseInfo>(ExecuteGetPmxWarehouseCode), currentDockCode);

                goto Step_SelectPOFilter;
            }

            if (msg.Name.EndsWith(".RefreshRequested"))
            {
                goto Step_SelectDock;
            }

            //back requested
            return;

            #endregion

        Step_SelectPOFilter:

            #region SELECT PO FILTER

            if (crossDocking)
            {
                if (goBack /*|| !ExecuteCrossDocking( purchaseOrderDocEntry, whsInfo, currentDockCode, session, sboProviderService )*/ )
                {
                    //goBack = true;
                    goto Step_SelectDock;
                }

                // Always select Purchase Order in case of cross-docking
                filterButtonKey = "MSG_BUTTON_PO_FILTER_ORDER";
                goto Step_SelectOrder;
            }

            filterGTIN = null;
            filterButtonKey = null;
            cardCode = null;
            purchaseDocRef = null;
            containerDocEntry = null;
            autoSelectPO = false;
            isContainer = false;

            //AUTO SELECT NO PO
            goto Step_SelectSupplier;

            buttonKeys = new List<string>(new Collection<string>() { "MSG_BUTTON_PO_FILTER_EAN", "MSG_BUTTON_PO_FILTER_ORDER", "MSG_BUTTON_PO_FILTER_NO_PO", "MSG_BUTTON_CONTAINER" });

            toolBarButtons = ToolBarButtons.Stop | ToolBarButtons.Back;

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectButtonScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_SELECT_PO_FILTER",
                    "AllowedButtons", buttonKeys.ToArray(),
                    "EnabledToolBarButtons", toolBarButtons
                    ));
            msg = WaitForMessage();
            initialErrorKey = null;
            if (msg.Name.EndsWith(".ButtonClicked"))
            {
                filterButtonKey = ExtractParameter<string>(msg.Parameters, "buttonKey");

                if (filterButtonKey == "MSG_BUTTON_PO_FILTER_EAN")
                {
                    goto Step_FilterOnEAN;
                }

                if (filterButtonKey == "MSG_BUTTON_PO_FILTER_ORDER")
                {
                    goto Step_SelectOrder;
                }

                if (filterButtonKey == "MSG_BUTTON_CONTAINER")
                {
                    isContainer = true;
                    goto Step_SelectContainer;
                }

                goto Step_SelectSupplier;
            }

            if (msg.Name.EndsWith(".BackRequested"))
            {
                goBack = true;
                goto Step_SelectDock;
            }

            if (msg.Name.EndsWith(".StopRequested"))
            {
                return;
            }

            #endregion

        Step_SelectSupplier:

            #region SELECT SUPPLIER

            cardCode = null;

            query = BuildQuery.GetSuppliersOrderByName();
            dsSuppliers = sboProviderService.RunView(false, null, null, query);

            //Auto select supplier
            if (this.GetNumberOfRows(dsSuppliers) > 0)
            {
                cardCode = dsSuppliers.Tables[0].Rows[0][SupplierDataSet.Columns.SUPPLIER_CODE.Name] as string;

                businessPartnerInfo = sboProviderService.InvokeMethodWithDbConnection<PmxBusinessPartnerInfo>(true, false, null, null, new DelegateWithPmxDbConnection<PmxBusinessPartnerInfo>(ExecuteGetBusinessPartnerInfo), cardCode);

                allowLabelsToBeScannedOnVendor = sboProviderService.InvokeMethodWithDbConnection<bool>(true, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteCheckIfLabelScanningAllowedOnReception), cardCode);
                allowLogisticCarriersOnVendor = sboProviderService.InvokeMethodWithDbConnection<bool>(true, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteCheckIfLogisticCarriersAreAllowedOnReception), cardCode);

                goto Step_EnterSupplierReference;
            }

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Reception.ISelectSupplierScreen),
                 DefaultCultureInfo.Get(), BuildParamCollection(
                 "InitialErrorKey", initialErrorKey,
                 "TitleKey", "MSG_TITLE_SELECT_SUPPLIER",
                 "SupplierDS", dsSuppliers
                 ));

            msg = WaitForMessage();
            initialErrorKey = null;
            if (msg.Name.EndsWith(".SupplierSelected"))
            {
                cardCode = ExtractParameter<string>(msg.Parameters, "supplierCode");

                businessPartnerInfo = sboProviderService.InvokeMethodWithDbConnection<PmxBusinessPartnerInfo>(true, false, null, null, new DelegateWithPmxDbConnection<PmxBusinessPartnerInfo>(ExecuteGetBusinessPartnerInfo), cardCode);

                allowLabelsToBeScannedOnVendor = sboProviderService.InvokeMethodWithDbConnection<bool>(true, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteCheckIfLabelScanningAllowedOnReception), cardCode);
                allowLogisticCarriersOnVendor = sboProviderService.InvokeMethodWithDbConnection<bool>(true, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteCheckIfLogisticCarriersAreAllowedOnReception), cardCode);

                goto Step_EnterSupplierReference;
            }

            goto Step_SelectPOFilter;

            #endregion

        Step_FilterOnEAN:

            #region FILTER ON EAN

            filterGTIN = null;


            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IIdentifyGS1DataScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_SCAN_GS1_LABEL",
                    "ImageType", GS1ImageType.BoxImage));

            msg = WaitForMessage();
            // Reset latest error
            initialErrorKey = null;
            barcode = null;
            filterGTIN = null;

            if (msg.Name.EndsWith(".DataEntered"))
            {
                barcode = ExtractParameter<BarcodeContainer>(msg.Parameters, "data");

                //check if there is a product present
                if (barcode != null &&
                !string.IsNullOrEmpty(BarcodeHelper.GetProductIdentification(barcode)))
                {
                    filterGTIN = BarcodeHelper.GetProductIdentification(barcode);
                    goto Step_SelectOrder;

                }
                else
                {
                    initialErrorKey = "MSG_ERROR_NO_PRODUCT_ON_BARCODE";
                    goto Step_FilterOnEAN;
                }
            }
            else if (msg.Name.EndsWith(".BackRequested"))
            {
                goto Step_SelectPOFilter;
            }

            initialErrorKey = "MSG_ERROR_OPERATION_NOT_SUPPORTED";
            goto Step_FilterOnEAN;


            #endregion

        Step_SelectOrder:

            #region SELECT ORDER

            if (crossDocking)
            {
                if (purchaseDocRef != null && !ExecuteCrossDocking(purchaseDocRef.DocEntry, whsInfo, currentDockCode, crossDockingPickListType, session, sboProviderService))
                {
                    goBack = true;
                    goto Step_SelectDock;
                }
            }

            purchaseDocRef = null;
            containerDocEntry = null;
            purchaseOrderDocNum = null;
            query = BuildQuery.GetPOsOrderByPONumber(/*cardCode*/ null, filterGTIN, crossDocking, showReserveInvoices && !crossDocking, whsInfo.SboWarehouseCode, sboProviderService.GetDbTool());  // Don't show reserve invoices when cross-docking
            dsPurchaseOrders = sboProviderService.RunView(false, null, null, query);

            if (this.GetNumberOfRows(dsPurchaseOrders) == 0)
            {
                initialErrorKey = "MSG_ERROR_NO_PO_FOUND";

                goBack = true;
                goto Step_SelectPOFilter;
            }

            if (this.GetNumberOfRows(dsPurchaseOrders) == 1 &&
                filterButtonKey != "MSG_BUTTON_PO_FILTER_ORDER" &&
                !goBack)
            {
                DataRow row = dsPurchaseOrders.Tables[0].Rows[0];

                //we found just one row, and we do not want to select it manually, so auto-select
                purchaseDocRef = new DocumentRef(Convert.ToString(row[PurchaseOrderDataSet.Columns.DOC_OBJ_TYPE.Name]), Convert.ToInt32(row[PurchaseOrderDataSet.Columns.PO_ID.Name]));
                cardCode = Convert.ToString(row[PurchaseOrderDataSet.Columns.SUPPLIER_CODE.Name]);
                purchaseOrderDocNum = Convertor.ConvertToInt32Nullable(row[PurchaseOrderDataSet.Columns.PO_NUMBER.Name]);
                goto Step_EnterSupplierReference;
            }

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Reception.ISelectPOScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                "InitialErrorKey", initialErrorKey,
                "TitleKey", "MSG_TITLE_SELECT_PO",
                "ButtonKey", crossDocking ? "" : "MSG_BUTTON_PO_FILTER_AUTO_SELECT_ORDER",
                "PODS", dsPurchaseOrders
                ));

            msg = WaitForMessage();
            goBack = false;
            initialErrorKey = null;
            if (msg.Name.EndsWith(".POSelected"))
            {
                purchaseDocRef = new DocumentRef(ExtractParameter<string>(msg.Parameters, "docObjType"), ExtractParameter<int>(msg.Parameters, "docEntry"));

                DataRow[] rows = dsPurchaseOrders.Tables[0].Select(PurchaseOrderDataSet.Columns.DOC_OBJ_TYPE.Name + " = " + purchaseDocRef.DocType
                    + " AND " + PurchaseOrderDataSet.Columns.PO_ID.Name + " = " + purchaseDocRef.DocEntry.ToString());

                if (rows.Length > 0)
                {
                    cardCode = Convert.ToString(rows[0][PurchaseOrderDataSet.Columns.SUPPLIER_CODE.Name]);
                    purchaseOrderDocNum = Convertor.ConvertToInt32Nullable(rows[0][PurchaseOrderDataSet.Columns.PO_NUMBER.Name]);
                }

                goto Step_EnterSupplierReference;
            }

            if (msg.Name.EndsWith(".ButtonClicked"))
            {
                autoSelectPO = true;
                goto Step_SelectSupplier;
            }

            goBack = true;
            goto Step_SelectPOFilter;

            #endregion

        Step_SelectContainer:

            #region SELECT CONTAINER

            purchaseDocRef = null;
            containerDocEntry = null;
            purchaseOrderDocNum = null;
            query = BuildQuery.GetContainers();
            dsContainers = sboProviderService.RunView(false, null, null, query);

            if (this.GetNumberOfRows(dsContainers) == 0)
            {
                initialErrorKey = "MSG_ERROR_NO_CONTAINER_FOUND";

                goBack = true;
                goto Step_SelectPOFilter;
            }


            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectContainerScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                "InitialErrorKey", initialErrorKey,
                "TitleKey", "MSG_TITLE_SELECT_CONTAINER",
                "ContainerDS", dsContainers
                ));

            msg = WaitForMessage();
            goBack = false;
            initialErrorKey = null;
            if (msg.Name.EndsWith(".ContainerSelected"))
            {
                containerDocEntry = ExtractParameter<int>(msg.Parameters, "docEntry");

                DataRow[] rows = dsContainers.Tables[0].Select(ContainerDataSet.Columns.DOC_ENTRY.Name + " = " + containerDocEntry.Value.ToString());

                if (rows.Length > 0)
                {
                    //cardCode = Convert.ToString(rows[0][PurchaseOrderDataSet.Columns.SUPPLIER_CODE.Name]);
                    //purchaseOrderDocNum = Convertor.ConvertToInt32Nullable(rows[0][PurchaseOrderDataSet.Columns.PO_NUMBER.Name]);
                }

                goto Step_EnterSupplierReference;
            }


            goBack = true;
            goto Step_SelectPOFilter;

            #endregion

        Step_EnterSupplierReference:

            #region ENTER SUPPLIER REFERENCE

            purchaseDeliveryNoteList = new Collection<LogisticUnitGoodsReceipt>();
            listOfReasonCodeByItem = new Dictionary<string, ReasonInfo>();

            supplierRef = null;

            if (!isContainer)
            {

                if (PmxOseCompany.Get().GoodsReceiptRequiresSupplierRef)
                {
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterStringValueScreen),
                     DefaultCultureInfo.Get(), BuildParamCollection(
                         "InitialErrorKey", initialErrorKey,
                         "TitleKey", "MSG_TITLE_ENTER_SUPPLIER_REF",
                         "ForceDataEntry", true,
                         "ForceUppercase", true,
                         "AllowToGoBack", true,
                         "Information", "MSG_ENTER_SUPPLIER_REF_FOR_PO_DELIVERY"
                         ));
                    msg = WaitForMessage();

                    // reset error
                    initialErrorKey = null;

                    if (msg.Name.EndsWith(".StringEntered"))
                    {
                        supplierRef = ExtractParameter<string>(msg.Parameters, "stringValue");
                        //goto Step_SelectLogisticCarrier;
                    }
                    else if (msg.Name.EndsWith(".BackRequested"))
                    {
                        if (filterButtonKey == "MSG_BUTTON_PO_FILTER_NO_PO")
                        {
                            goto Step_SelectPOFilter;
                        }
                        else if (filterButtonKey == "MSG_BUTTON_PO_FILTER_EAN")
                        {
                            goto Step_FilterOnEAN;
                        }
                        else
                        {
                            goto Step_SelectOrder;
                        }
                    }
                }

                needToEnterSupplierPalletNumber = sboProviderService.InvokeMethodWithDbConnection<bool>(true, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteNeedToEnterSupplierPalletNumber), cardCode);

                if (!string.IsNullOrEmpty(cardCode))
                {
                    businessPartnerInfo = sboProviderService.InvokeMethodWithDbConnection<PmxBusinessPartnerInfo>(true, false, null, null, new DelegateWithPmxDbConnection<PmxBusinessPartnerInfo>(ExecuteGetBusinessPartnerInfo), cardCode);
                    allowLabelsToBeScannedOnVendor = sboProviderService.InvokeMethodWithDbConnection<bool>(true, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteCheckIfLabelScanningAllowedOnReception), cardCode);
                    allowLogisticCarriersOnVendor = sboProviderService.InvokeMethodWithDbConnection<bool>(true, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteCheckIfLogisticCarriersAreAllowedOnReception), cardCode);
                }

            }
            else
            {
                //supplier not known for container
                needToEnterSupplierPalletNumber = false;
            }


            goto Step_AskBatchReceiving;


            #endregion

        Step_ShowMessageNextLogisticUnit:

            #region SHOW MESSAGE NEXT LOGISTIC UNIT

            // Inform the user the items are received
            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                    "MessageKey", "MSG_ENTER_NEXT_LOGISTIC_UNIT",
                    "ShowButton", true));
            WaitForMessage();

            goto Step_AskBatchReceiving;

            #endregion

        Step_AskBatchReceiving:

            #region ASK BATCH RECEIVING

            enterReason = false;

            batchReceivingNumber = 1;
            barcode = null;
            buttonKeys = new List<string>(new Collection<string> { "MSG_BUTTON_BATCH_RECEIVING", "MSG_BUTTON_NO_BATCH_RECEIVING" });

            //Skip screen
            goto Step_ScanLabelStart;

            if (businessPartnerInfo != null)
            {
                if (needToEnterSupplierPalletNumber ||
                    autoSelectPO || businessPartnerInfo.HasNoIdenticalLogUnitsOnReception)
                {
                    //we need to enter supplier pallet number, so do not ask for batch receiving, because it is not allowed!
                    goto Step_ScanLabelStart;
                }
            }

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectButtonScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_SELECT_TASK",
                    "AllowedButtons", buttonKeys.ToArray(),
                    "ShowStopButton", false
                    ));
            msg = WaitForMessage();
            initialErrorKey = null;
            if (msg.Name.EndsWith(".ButtonClicked"))
            {
                if (ExtractParameter<string>(msg.Parameters, "buttonKey") == "MSG_BUTTON_BATCH_RECEIVING")
                {
                    goto Step_EnterBatchReceiving;
                }
                else
                {
                    goto Step_ScanLabelStart;
                }
            }

            //go back
            goto Step_GoBack;


            #endregion

        Step_EnterBatchReceiving:

            #region ENTER BATCH RECEIVING

            batchReceivingNumber = 1;

            //ask for quantity
            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterQuantityScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_BATCH_RECEIVING",
                    "InitialQuantity", 1,
                    "NumberOfDigitsAfterDecimal", 0,
                    "MaximumQuantity", -1,
                    "UOM", ""
                   ));
            msg = WaitForMessage();

            //clear data
            initialErrorKey = null;

            if (msg.Name.EndsWith(".QuantityEntered"))
            {
                batchReceivingNumber = Convert.ToInt32(ExtractParameter<double>(msg.Parameters, "quantity"));
                goto Step_ScanLabelStart;
            }

            goto Step_AskBatchReceiving;

            #endregion

        Step_ScanLabelStart:

            #region SCAN LABEL START



            barcode = null;
            currentLogUnit = new LogisticUnitGoodsReceipt();



            titleKey = "MSG_TITLE_SCAN_GS1_LABEL";
            allowedButtonsForLabelScreen = new List<string>();
            allowedButtonsForLabelScreen.Add("MSG_BUTTON_NO_LABEL");
            if (!enterReason && allowToEnterReason)
            {
                allowedButtonsForLabelScreen.Add("MSG_BUTTON_ENTER_REASON_RECEPTION");
            }


            barcode = null;
            currentLogUnit = new LogisticUnitGoodsReceipt();

            goto Step_ScanLabel;

            #endregion

        Step_ScanLabel:

            #region SCAN LABEL

            goto Step_CheckSSCC;

            if (!allowLabelsToBeScannedOnVendor)
            {
                goto Step_CheckSSCC;
            }

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IIdentifyGS1DataScreen),
            DefaultCultureInfo.Get(), BuildParamCollection(
                "InitialErrorKey", initialErrorKey,
                "TitleKey", titleKey,
                "ImageType", GS1ImageType.PalletImage,
                "AllowedButtons", allowedButtonsForLabelScreen.ToArray(),
                "GS1DataObject", barcode == null ? null : barcode.GS1DataObject
                ));

            msg = WaitForMessage();
            // Reset latest error
            initialErrorKey = null;

            if (msg.Name.EndsWith(".DataEntered"))
            {
                barcode = ExtractParameter<BarcodeContainer>(msg.Parameters, "data");

                if (this.IsProductOnBarcode(barcode))
                {
                    gtin = BarcodeHelper.GetProductIdentification(barcode);

                    query = BuildQuery.GetCodeNameItemsOrderByName(null, gtin, purchaseDocRef, cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing, true, true, crossDocking, containerDocEntry, sboProviderService.GetDbTool());
                    DataSet dsTempItemsForBarcode = sboProviderService.RunView(true, null, null, query);

                    itemCode = dsTempItemsForBarcode.Tables[0].Rows[0][ProductDataSet.Columns.PRODUCT_CODE.Name] as string;
                    itemInfo = sboProviderService.InvokeMethodWithDbConnection<PmxItemInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxItemInfo>(ExecuteGetItemInfo), itemCode);
                }

                if (
                    this.IsSSCCOnBarcode(barcode.GS1DataObject) && itemInfo != null && (
                     ((itemInfo.HasBatchnumber && this.IsBatchNumberOnBarcode(barcode.GS1DataObject)) || (!itemInfo.HasBatchnumber && !this.IsBatchNumberOnBarcode(barcode.GS1DataObject)))
                    && ((itemInfo.HasBestBeforeDate & this.IsBestBeforeDateOnBarcode(barcode.GS1DataObject)) || (!itemInfo.HasBestBeforeDate & !this.IsBestBeforeDateOnBarcode(barcode.GS1DataObject)))
                    )
                    )
                {
                    goto Step_CheckSSCC;
                }
                //else if (this.IsProductOnBarcode(barcode))
                //{
                //    itemCode = BarcodeHelper.GetProductIdentification(barcode);
                //    itemInfo = sboProviderService.InvokeMethodWithDbConnection<PmxItemInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxItemInfo>(ExecuteGetItemInfo), itemCode);

                //    if (itemInfo.HasBatchnumber && this.IsBatchNumberOnBarcode(barcode.GS1DataObject))
                //    {
                //        batchNumber = barcode.GS1DataObject.LotNumber;
                //    }

                //    if (itemInfo.HasBestBeforeDate && this.IsBestBeforeDateOnBarcode(barcode.GS1DataObject))
                //    {
                //        bestBeforeDate = barcode.GS1DataObject.BestBeforeDate;
                //    }
                //}
                else
                {
                    titleKey = "MSG_TITLE_SCAN_NEXT_GS1_LABEL";

                    allowedButtonsForLabelScreen = new List<string>();
                    allowedButtonsForLabelScreen.Add("MSG_BUTTON_DONE");

                    if (!enterReason && allowToEnterReason)
                    {
                        allowedButtonsForLabelScreen.Add("MSG_BUTTON_ENTER_REASON_RECEPTION");
                    }

                    goto Step_ScanLabel;
                }

            }
            else if (msg.Name.EndsWith(".BackRequested"))
            {
                goto Step_GoBack;
            }
            else if (msg.Name.EndsWith(".ButtonClicked"))
            {
                //get buttonkey
                string btnKey = ExtractParameter<string>(msg.Parameters, "buttonKey");

                if (btnKey == "MSG_BUTTON_ENTER_REASON_RECEPTION")
                {
                    enterReason = true;
                    goto Step_ScanLabelStart;
                }

                goto Step_CheckSSCC;
            }

            initialErrorKey = "MSG_ERROR_OPERATION_NOT_SUPPORTED";
            goto Step_ScanLabel;


            #endregion

        Step_CheckSSCC:

            #region CHECK SSCC

            SSCC = null;
            scannedSSCC = null;
            luid = null;

            if (barcode != null &&
                barcode.GS1DataObject != null &&
                !string.IsNullOrEmpty(barcode.GS1DataObject.Sscc))
            {
                scannedSSCC = barcode.GS1DataObject.Sscc;

                //check if the scanned SSCC is valid
                if (sboProviderService.InvokeMethodWithDbConnection<bool>(false, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteIsSSCCValid), scannedSSCC))
                {
                    SSCC = scannedSSCC;
                    int tempLUID = sboProviderService.InvokeMethodWithDbConnection<int>(false, false, null, null, new DelegateWithPmxDbConnection<int>(ExecuteGetLUIDBySSCC), SSCC);
                    if (tempLUID > 0)
                    {
                        luid = tempLUID;
                    }
                    else
                    {
                        //no luid, so check if scanned sscc already exists in the 'in memory' list
                        foreach (LogisticUnitGoodsReceipt foundLUID in purchaseDeliveryNoteList)
                        {
                            if (foundLUID.SSCC == SSCC)
                            {
                                luid = foundLUID.LogisticUnitId;
                                break;
                            }
                        }
                    }



                    goto Step_SelectLogisticCarrier;
                }
                else
                {
                    //invalid
                    initialErrorKey = "MSG_ERROR_INVALID_SSCC";
                    goto Step_ScanLabelStart;
                }
            }

            goto Step_SelectLogisticCarrier;


            #endregion

        Step_SelectLogisticCarrier:

            #region SELECT LOGISTIC CARRIER


            logisticCarrierCode = null;
            currentLogisticCarrier = null;

            logisticCarrierCode = null;
            goto Step_EnterSupplierPalletNumber;

            //set luid
            currentLogUnit.LogisticUnitId = luid;
            currentLogUnit.SSCC = SSCC;

            PmxItemInfo tempItemInfo = null;

            if (this.IsLUOnBarcode(barcode))
            {
                tempGTIN = BarcodeHelper.GetProductIdentification(barcode);

                query = BuildQuery.GetCodeNameItemsOrderByName(null, tempGTIN, null, null, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing, true, true, false, null, sboProviderService.GetDbTool());
                DataSet ds = sboProviderService.RunView(true, null, null, query);

                if (this.GetNumberOfRows(ds) > 0)
                {
                    //get itemcode of first row
                    string tempItemCode = ds.Tables[0].Rows[0][ProductDataSet.Columns.PRODUCT_CODE.Name] as string;
                    tempItemInfo = sboProviderService.InvokeMethodWithDbConnection<PmxItemInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxItemInfo>(ExecuteGetItemInfo), tempItemCode);

                }


            }

            if (luid > 0 ||
                (this.IsLUOnBarcode(barcode) && tempItemInfo != null && tempItemInfo.IsLogisticUnit) ||
                (currentLogUnit != null && currentLogUnit.ItemsOnLogisticUnit.Count > 0))
            {
                //we do not need to add logistic carrier
                goto Step_EnterSupplierPalletNumber;
            }


            //ask for logistic carrier
            query = BuildQuery.GetLogisticCarriersOrderByName(false, true, sboProviderService.GetDbTool());
            dsLogisticCarriers = sboProviderService.RunView(false, null, null, query);

            if (this.GetNumberOfRows(dsLogisticCarriers) == 0 ||
                !allowLogisticCarriersOnVendor)
            {
                //There are no logistic carriers, so we do not show screen
                logisticCarrierCode = null;
                goto Step_EnterSupplierPalletNumber;
            }


            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectProductScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_SELECT_LOGISTIC_CARRIER",
                    "ProductDS", dsLogisticCarriers,
                    "ButtonKey", "MSG_BUTTON_NO_LOGISTIC_CARRIER"
                    ));
            msg = WaitForMessage();

            //clear data
            initialErrorKey = null;

            if (msg.Name.EndsWith(".ProductSelected"))
            {
                logisticCarrierCode = ExtractParameter<string>(msg.Parameters, "itemCode");

                //add to list

                currentLogisticCarrier = new LogisticUnitItemGoodReceipt();
                currentLogisticCarrier.BatchNumber1 = null;
                currentLogisticCarrier.BatchNumber2 = null;
                currentLogisticCarrier.BestBeforeDate = null;
                currentLogisticCarrier.ItemCode = logisticCarrierCode;
                currentLogisticCarrier.Quantity = 1;
                currentLogisticCarrier.IsLogisticCarrierForLogisticUnit = true;
                currentLogisticCarrier.IsLogisticCarrier = true;

                goto Step_EnterSupplierPalletNumber;
            }

            if (msg.Name.EndsWith(".ButtonClicked"))
            {
                logisticCarrierCode = null;
                goto Step_EnterSupplierPalletNumber;
            }

            //go back
            goto Step_GoBack;



            #endregion

        Step_EnterSupplierPalletNumber:

            #region ENTER SUPPLIER PALLET NUMBER

            supplierPalletNumber = null;

            goto Step_IdentifyProduct;

            if (needToEnterSupplierPalletNumber)
            {
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterStringValueScreen),
                 DefaultCultureInfo.Get(), BuildParamCollection(
                     "InitialErrorKey", initialErrorKey,
                     "TitleKey", "MSG_TITLE_ENTER_SUPPLIER_PALLET_NUMBER",
                     "ForceDataEntry", true,
                     "ForceUppercase", true,
                     "AllowToGoBack", true,
                     "Information", "MSG_ENTER_SUPPLIER_PALLET_NUMBER"
                     ));
                msg = WaitForMessage();

                // reset error
                initialErrorKey = null;

                if (msg.Name.EndsWith(".StringEntered"))
                {
                    supplierPalletNumber = ExtractParameter<string>(msg.Parameters, "stringValue");
                    currentLogUnit.SupplierPalletNumber = supplierPalletNumber;
                    goto Step_IdentifyProduct;
                }
                else if (msg.Name.EndsWith(".BackRequested"))
                {
                    goto Step_GoBack;
                }
            }

            goto Step_IdentifyProduct;


            #endregion

        Step_GoBack:

            #region GO BACK

            //go back
            if ((currentLogUnit != null &&
                currentLogUnit.ItemsOnLogisticUnit.Count > 0))
            {
                //we want to go back, but we have some items in the list
                //ask user what to do
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "TitleKey", "MSG_TITLE_PRODUCTS_ON_LOGISTIC_UNIT_TO_RECEIVE",
                        "MessageKey", "MSG_QUESTION_PRODUCTS_ON_LIST_TO_RECEIVE"));
                msg = WaitForMessage();

                if (msg.Name.EndsWith(".Yes"))
                {
                    //receive the items
                    goto Step_ReceiveItems;
                }
            }

            if ((purchaseDeliveryNoteList != null &&
                purchaseDeliveryNoteList.Count > 0))
            {
                //we want to go back, but we have some items in the list
                //ask user what to do
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "TitleKey", "MSG_TITLE_PRODUCTS_ON_LIST_TO_RECEIVE",
                        "MessageKey", "MSG_QUESTION_PRODUCTS_ON_LIST_TO_RECEIVE"));
                msg = WaitForMessage();

                if (msg.Name.EndsWith(".Yes"))
                {
                    //there are pallets received, but user wants to go back, so we will receive them right now
                    goBack = true;

                    // Inform the user items are receiving
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "MessageKey", "MSG_RECEIVING_ALL_ITEMS",
                            "NoTranslationOfMessageKey", false,
                            "ShowButton", false));

                    goto Step_ReceiveItems;
                }
            }

            //clear data
            cardCode = null;

            if (filterButtonKey == "MSG_BUTTON_PO_FILTER_NO_PO")
            {
                goto Step_SelectPOFilter;
            }
            else if (filterButtonKey == "MSG_BUTTON_PO_FILTER_EAN")
            {
                goto Step_FilterOnEAN;
            }
            else if (isContainer)
            {
                goBack = true;
                goto Step_SelectContainer;
            }
            else
            {
                goBack = true;
                goto Step_SelectOrder;
            }

            #endregion

        Step_ClearDataBeforeNextItem:

            #region CLEAR DATA BEFORE NEXT ITEM


            barcode = null;

            goto Step_IdentifyProduct;

            #endregion

        Step_IdentifyProduct:

            #region IDENTIFY PRODUCT

            itemCode = null;
            itemDescription = null;
            itemInfo = null;
            numberOfItemsInPurchaseUnit = null;

            if (goBack)
            {
                barcode = null;
            }

            tempGTIN = BarcodeHelper.GetProductIdentification(barcode);

            query = BuildQuery.GetCodeNameItemsOrderByName(null, tempGTIN, purchaseDocRef, cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing, true, true, crossDocking, containerDocEntry, sboProviderService.GetDbTool());
            dsItems = sboProviderService.RunView(true, null, null, query);
            query = BuildQuery.GetCodeNameItemsOrderByName(null, tempGTIN, purchaseDocRef, cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing, true, false, crossDocking, containerDocEntry, sboProviderService.GetDbTool());
            dsItemsNonDistinct = sboProviderService.RunView(true, null, null, query);

            RemoveReceivedItems(purchaseDeliveryNoteList, dsItemsNonDistinct, currentLogUnit);

            // If items removed in dsItemsNonDistinct => check dsItems if they also need to be removed
            for (int i = 0; i < dsItems.Tables[0].Rows.Count; i++)
            {
                string productCode = Convert.ToString(dsItems.Tables[0].Rows[i][ProductDataSet.Columns.PRODUCT_CODE.Name]);
                // If there are items in the non distincted dataset, keep the item in the distincted dataset.
                if (dsItemsNonDistinct.Tables[0].Select(ProductDataSet.Columns.PRODUCT_CODE.Name + "= '" + productCode + "'").Length == 0)
                {
                    dsItems.Tables[0].Rows[i].Delete();
                }
            }

            //if (this.GetNumberOfRows(dsItems) == 1 &&
            //    !goBack)
            //{
            //    itemCode = dsItems.Tables[0].Rows[0][ProductDataSet.Columns.PRODUCT_CODE.Name] as string;
            //    itemDescription = dsItems.Tables[0].Rows[0][ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name] as string;

            //    gtin = tempGTIN;

            //    if (dsItems.Tables[0].Columns.Contains(SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME))
            //    {
            //        numberOfItemsInPurchaseUnit = Convert.ToDouble(dsItems.Tables[0].Rows[0][SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME]);
            //    }

            //    goto Step_GetItemInfo;
            //}

            if (this.GetNumberOfRows(dsItems) == 0)
            {
                //product not found
                initialErrorKey = "MSG_ERROR_INCORRECT_PRODUCT";
                goto Step_ScanLabelStart;
            }

            if (!string.IsNullOrEmpty(tempGTIN) &&
                this.GetNumberOfRows(dsItems) == 1)
            {
                if (goBack)
                {
                    goto Step_ScanLabelStart;
                }
                itemCode = dsItems.Tables[0].Rows[0][ProductDataSet.Columns.PRODUCT_CODE.Name] as string;
                itemDescription = dsItems.Tables[0].Rows[0][ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name] as string;

                gtin = tempGTIN;

                if (dsItemsNonDistinct.Tables[0].Columns.Contains(SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME))
                {
                    numberOfItemsInPurchaseUnit = Convert.ToDouble(dsItemsNonDistinct.Tables[0].Rows[0][SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME]);
                }
                goto Step_GetItemInfo;
            }

            allowedButtonsIdentifyProductScreen = new List<string>();

            //if (!PmxOseCompany.Get().DisableItemSelectionInFlows)
            //{
            //    allowedButtonsIdentifyProductScreen.Add("MSG_BUTTON_SELECT_PRODUCT");
            //}

            if ((currentLogUnit != null &&
                currentLogUnit.ItemsOnLogisticUnit.Count > 0))
            {
                //we have data in lists
                allowedButtonsIdentifyProductScreen.Add("MSG_BUTTON_RECEIVE_ITEMS");
            }


            goBack = false;

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IIdentifyGS1DataScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "Scan master product ID",
                    "AllowedButtons", allowedButtonsIdentifyProductScreen.Count > 0 ? allowedButtonsIdentifyProductScreen.ToArray() : null,
                    "ImageType", GS1ImageType.BoxImage
                    ));
            msg = WaitForMessage();
            goBack = false;
            //clear data
            initialErrorKey = null;
            //We need to keep old barcode scanned on logistic unit screen
            //barcode = null;
            gtin = null;
            itemInfo = null;

            if (msg.Name.EndsWith(".DataEntered"))
            {
                BarcodeContainer tempBarcode = ExtractParameter<BarcodeContainer>(msg.Parameters, "data");

                //check if there is a product present
                if (tempBarcode != null &&
                !string.IsNullOrEmpty(BarcodeHelper.GetProductIdentification(tempBarcode)))
                {
                    if (string.IsNullOrEmpty(tempBarcode.FreeBarcode))
                    {
                        //EAN128 barcode scanned, so copy it to global one
                        barcode = tempBarcode;
                    }

                    gtin = BarcodeHelper.GetProductIdentification(tempBarcode);

                    query = BuildQuery.GetCodeNameItemsOrderByName(null, gtin, purchaseDocRef, cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing, true, true, crossDocking, containerDocEntry, sboProviderService.GetDbTool());
                    DataSet dsTempItems = sboProviderService.RunView(true, null, null, query);

                    query = BuildQuery.GetCodeNameItemsOrderByName(null, gtin, purchaseDocRef, cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing, true, false, crossDocking, containerDocEntry, sboProviderService.GetDbTool());
                    DataSet dsTempItemsNonDistinct = sboProviderService.RunView(true, null, null, query);


                    if (GetNumberOfRows(dsTempItems) > 0)
                    {
                        //copy the data
                        itemCode = dsTempItems.Tables[0].Rows[0][ProductDataSet.Columns.PRODUCT_CODE.Name] as string;
                        itemDescription = dsTempItems.Tables[0].Rows[0][ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name] as string;

                        if (dsTempItemsNonDistinct.Tables[0].Columns.Contains(SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME))
                        {
                            numberOfItemsInPurchaseUnit = Convert.ToDouble(dsTempItemsNonDistinct.Tables[0].Rows[0][SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME]);
                        }

                        goto Step_GetItemInfo;
                    }
                    else
                    {
                        //reset data
                        //barcode = null;
                        initialErrorKey = "MSG_ERROR_PRODUCT_NOT_FOUND";
                        goto Step_IdentifyProduct;
                    }

                }
                else
                {
                    //reset data
                    //barcode = null;
                    initialErrorKey = "MSG_ERROR_NO_PRODUCT_ON_BARCODE";
                    goto Step_IdentifyProduct;
                }

            }

            if (msg.Name.EndsWith(".ButtonClicked"))
            {
                string tempButtonKey = ExtractParameter<string>(msg.Parameters, "buttonKey");

                if (tempButtonKey == "MSG_BUTTON_SELECT_PRODUCT")
                {
                    //select the product
                    goto Step_SelectProduct;
                }
                else
                {
                    //receive items
                    // Inform the user items are receiving
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "MessageKey", "MSG_RECEIVING_ALL_ITEMS",
                            "NoTranslationOfMessageKey", false,
                            "ShowButton", false));

                    goto Step_ReceiveItems;
                }
            }

            //go back
            if (currentLogUnit != null &&
                currentLogUnit.ItemsOnLogisticUnit.Count > 0)
            {
                //we want to go back, but we have some items in the list
                //ask user what to do
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "TitleKey", "MSG_TITLE_PRODUCTS_ON_PALLET_TO_RECEIVE",
                        "MessageKey", "MSG_QUESTION_PRODUCTS_ON_PALLET_TO_RECEIVE"));
                msg = WaitForMessage();

                if (msg.Name.EndsWith(".Yes"))
                {
                    goto Step_ScanLabelStart;
                }

                goto Step_IdentifyProduct;

            }
            else
            {
                return;
                if (!allowLabelsToBeScannedOnVendor)
                {
                    goto Step_AskBatchReceiving;
                }
                goto Step_ScanLabelStart;
            }

            #endregion

        Step_SelectProduct:

            #region SELECT PRODUCT

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectProductScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_SELECT_PRODUCT",
                    "ProductDS", dsItems
                    ));
            msg = WaitForMessage();

            //clear data
            initialErrorKey = null;

            if (msg.Name.EndsWith(".ProductSelected"))
            {
                itemCode = ExtractParameter<string>(msg.Parameters, "itemCode");
                //get itemdescription
                DataRow[] rows = dsItems.Tables[0].Select(string.Format("{0} = '{1}'", ProductDataSet.Columns.PRODUCT_CODE.Name, itemCode));
                if (rows.Length > 0)
                {
                    //copy the data
                    itemDescription = rows[0][ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name] as string;
                }

                if (dsItemsNonDistinct.Tables[0].Columns.Contains(SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME))
                {
                    numberOfItemsInPurchaseUnit = Convert.ToDouble(dsItemsNonDistinct.Tables[0].Rows[0][SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME]);
                }

                goto Step_GetItemInfo;
            }

            goto Step_IdentifyProduct;

            #endregion

        Step_GetItemInfo:

            #region GET ITEM INFO

            if (itemInfo == null)
            {
                itemInfo = sboProviderService.InvokeMethodWithDbConnection<PmxItemInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxItemInfo>(ExecuteGetItemInfo), itemCode);
            }

            if (batchReceivingNumber > 1 &&
                (itemInfo.TrackLocationSerialNumber ||
                (itemInfo.HasSAPSerialNumber && itemInfo.ManageMethod == SboItemManageMethod.OnEveryTransaction)))
            {
                initialErrorKey = "MSG_ERROR_BATCH_RECEIVING_NOT_ALLOWED_FOR_SERIAL_NUMBERS";
                goto Step_IdentifyProduct;
            }


            stillToReceive = GetStillToReceive(dsItemsNonDistinct, itemCode);


            if (!numberOfItemsInPurchaseUnit.HasValue)
            {
                //take default
                numberOfItemsInPurchaseUnit = itemInfo.NumberOfItemsPerPurchaseUnit;
            }
            goto Step_AskForReason;

            #endregion

        Step_AskForReason:

            #region ASK FOR REASON

            //this step will only be shown if the user has set that the GS1Label screen for log units is skipped but does want scanner-user to use reasons later on
            if (!allowLabelsToBeScannedOnVendor && allowToEnterReason && !listOfReasonCodeByItem.ContainsKey(itemCode))
            {
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                    this.DefaultCultureInfo, BuildParamCollection(
                  "InitialErrorKey", initialErrorKey,
                  "TitleKey", "MSG_TITLE_ASK_TO_ENTER_REASON_LATER",
                  "MessageKey", "MSG_INFO_ASK_TO_ENTER_REASON_LATER",
                  "Parameters", new object[] { StringHelper.Truncate(string.Format("{0} - {1}", itemCode, itemInfo.Description), 50) }
                  ));
                msg = WaitForMessage();

                enterReason = msg.Name.EndsWith(".Yes") ? true : false;
            }

            if (!listOfReasonCodeByItem.ContainsKey(itemCode) &&
                enterReason &&
                allowToEnterReason)
            {
                //ask for reason
                query = BuildQuery.GetReasons();
                dsReasons = sboProviderService.RunView(false, null, null, query);

                reasonsCodesRequiresFreeText = new Dictionary<string, bool>();
                foreach (DataRow row in dsReasons.Tables[0].Rows)
                {
                    reasonsCodesRequiresFreeText.Add(
                        row[ReasonDataSet.Columns.REASON_CODE.Name].ToString(),
                        (SboBooleanConvertor.ObjectToBooleanOrNull(row[ReasonDataSet.Columns.REASON_REQUIRES_FREE_TEXT.Name]).HasValue ? (SboBooleanConvertor.ObjectToBooleanOrNull(row[PmxReasonTable.Columns.RequiresFreeText.NAME])).Value : false)
                        );
                }

                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectReasonScreen),
                  this.DefaultCultureInfo, BuildParamCollection(
                  "InitialErrorKey", initialErrorKey,
                  "TitleKey", "MSG_TITLE_SELECT_REASON",
                  "MessageKey", "MSG_SELECT_PURCHASE_RECEIPT_REASON",
                  "MessageParams", new object[] { StringHelper.Truncate(string.Format("{0} - {1}", itemCode, itemInfo.Description), 50) },
                  "ReasonDS", dsReasons));
                msg = WaitForMessage();
                initialErrorKey = null;

                if (msg.Name != "Produmex.Foundation.SlimScreen.Interfaces.ISelectReasonScreenReply.ReasonSelected")
                {
                    //go back
                    if (this.GetNumberOfRows(dsItems) == 1)
                    {
                        //go back
                        if (currentLogUnit != null &&
                            currentLogUnit.ItemsOnLogisticUnit.Count > 0)
                        {
                            //we want to go back, but we have some items in the list
                            //ask user what to do
                            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                                DefaultCultureInfo.Get(), BuildParamCollection(
                                    "TitleKey", "MSG_TITLE_PRODUCTS_ON_PALLET_TO_RECEIVE",
                                    "MessageKey", "MSG_QUESTION_PRODUCTS_ON_PALLET_TO_RECEIVE"));
                            msg = WaitForMessage();

                            if (msg.Name.EndsWith(".Yes"))
                            {
                                goto Step_ScanLabelStart;
                            }

                            goto Step_SelectBatchNumber;
                        }
                        goBack = true;
                        goto Step_IdentifyProduct;
                    }

                    goBack = true;
                    //there where more items in the list
                    goto Step_IdentifyProduct;
                }

                reasonCode = ExtractParameter<string>(msg.Parameters, "reasonCode");

                DataRow[] rows = dsReasons.Tables[0].Select(String.Format("{0} = '{1}'", ReasonDataSet.Columns.REASON_CODE.Name, reasonCode));
                if (rows.Length > 0)
                {
                    reasonName = rows[0][ReasonDataSet.Columns.REASON_NAME.Name] as string;
                }

                #region ENTER REASON FREE TEXT

                if (reasonsCodesRequiresFreeText.ContainsKey(reasonCode) &&
                    reasonsCodesRequiresFreeText[reasonCode])
                {


                    // Show screen with list
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterStringValueScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "InitialErrorKey", initialErrorKey,
                            "TitleKey", "MSG_TITLE_ENTER_REASON",
                            "Information", "MSG_ENTER_FREE_REASON_DEFAULT",
                            "Parameters", new object[] { reasonName },
                            "AllowToGoBack", true,
                            "ForceDataEntry", true,
                            "AllowMultiLine", true,
                            "MinimumNumberOfCharacters", Definitions.MIMIMUM_NUMBER_OF_CHARACTERS_FOR_REASON
                            ));

                    msg = WaitForMessage();

                    initialErrorKey = null;

                    if (msg.Name.EndsWith(".StringEntered"))
                    {
                        reasonFreeText = ExtractParameter<string>(msg.Parameters, "stringValue");

                    }
                    else
                    {
                        //go back
                        goto Step_AskForReason;
                    }
                }


                #endregion

                listOfReasonCodeByItem.Add(itemCode, new ReasonInfo(reasonCode, reasonFreeText));

            }


            goto Step_SelectZoneTypeStart;

            #endregion

        Step_SelectZoneTypeStart:
            listOfReasonsCodesAndZoneTypes = new PmxDictionary<string, ReasonInfo>();

            //query = BuildQuery.GetZoneTypesOnItem(itemInfo.ItemCode, current_DefaultCultureInfo);
            query = BuildQuery.GetZoneTypesOnItemCode(itemInfo.ItemCode, current_DefaultCultureInfo);
            dsZoneTypesAndReasons = sboProviderService.RunView(false, null, null, query);

            dsZoneTypesAndReasons.Tables[0].Columns.Add(ZoneTypeDataSet.Columns.REASON_CODE.Name, ZoneTypeDataSet.Columns.REASON_CODE.Types[0]);
            dsZoneTypesAndReasons.Tables[0].Columns.Add(ZoneTypeDataSet.Columns.REASON_NAME.Name, ZoneTypeDataSet.Columns.REASON_NAME.Types[0]);

        Step_SelectZoneType:

            #region SELECT ZONE TYPE

            if (GetNumberOfRows(dsZoneTypesAndReasons) == 0)
            {
                goto Step_CanItemBeStoredOnLocation;
            }

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Reception.ISelectZoneTypeScreen),
               DefaultCultureInfo.Get(), BuildParamCollection(
                   "InitialErrorKey", initialErrorKey,
                   "TitleKey", "MSG_TITLE_SELECT_ZONE_TYPE",
                  "ZoneTypeDS", dsZoneTypesAndReasons,
                   "ButtonKey", "MSG_SELECT_PURCHASE_RECEIPT_REASON_SELECT_ZONETYPE",
                   "ShowStopButton", false
                   ));

            msg = WaitForMessage();
            initialErrorKey = null;
            goBack = false;

            if (msg.Name.EndsWith(".ButtonClicked"))
            {
                zoneTypeCode = ExtractParameter<string>(msg.Parameters, "ZoneTypeCode");

                goto Step_AskForReasonForZoneType;
            }
            else if (msg.Name.EndsWith(".ForwardRequested"))
            {
                goto Step_CanItemBeStoredOnLocation;
            }
            else if (msg.Name.EndsWith("BackRequested"))
            {
                goto Step_GoBack;
            }
            return;

            #endregion

        Step_AskForReasonForZoneType:

            #region ASK FOR REASON FOR ZONE TYPE

            //ask for reason
            query = BuildQuery.GetReasonsForZoneTypes();
            dsReasons = sboProviderService.RunView(false, null, null, query);

            reasonsCodesRequiresFreeTextForZoneTypeScreen = new Dictionary<string, bool>();

            foreach (DataRow row in dsReasons.Tables[0].Rows)
            {
                reasonsCodesRequiresFreeTextForZoneTypeScreen.Add(
                    row[ReasonDataSet.Columns.REASON_CODE.Name].ToString(),
                    (SboBooleanConvertor.ObjectToBooleanOrNull(row[ReasonDataSet.Columns.REASON_REQUIRES_FREE_TEXT.Name]).HasValue ? (SboBooleanConvertor.ObjectToBooleanOrNull(row[PmxReasonTable.Columns.RequiresFreeText.NAME])).Value : false)
                    );
            }

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectReasonScreen),
              this.DefaultCultureInfo, BuildParamCollection(
              "InitialErrorKey", initialErrorKey,
              "TitleKey", "MSG_TITLE_SELECT_REASON",
              "MessageKey", "MSG_SELECT_PURCHASE_RECEIPT_REASON_FOR_ZONE_TYPE",
              "MessageParams", new object[] { zoneTypeCode, StringHelper.Truncate(string.Format("{0} - {1}", itemCode, itemDescription), 50) },
              "ReasonDS", dsReasons));

            msg = WaitForMessage();
            initialErrorKey = null;

            if (msg.Name != "Produmex.Foundation.SlimScreen.Interfaces.ISelectReasonScreenReply.ReasonSelected")
            {
                //go back   
                goBack = true;
                goto Step_SelectZoneType;
            }

            reasonCodeForZoneTypeScreen = ExtractParameter<string>(msg.Parameters, "reasonCode");

            DataRow[] temp_rows = dsReasons.Tables[0].Select(String.Format("{0} = '{1}'", ReasonDataSet.Columns.REASON_CODE.Name, reasonCodeForZoneTypeScreen));
            if (temp_rows.Length > 0)
            {
                reasonNameForZoneTypeScreen = temp_rows[0][ReasonDataSet.Columns.REASON_NAME.Name] as string;
            }

            #region ENTER REASON FREE TEXT

            if (reasonsCodesRequiresFreeTextForZoneTypeScreen.ContainsKey(reasonCodeForZoneTypeScreen) &&
                reasonsCodesRequiresFreeTextForZoneTypeScreen[reasonCodeForZoneTypeScreen])
            {
                // Show screen with list
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterStringValueScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "TitleKey", "MSG_TITLE_ENTER_REASON",
                        "Information", "MSG_ENTER_FREE_REASON_DEFAULT",
                        "Parameters", new object[] { reasonNameForZoneTypeScreen },
                        "AllowToGoBack", true,
                        "ForceDataEntry", true,
                        "AllowMultiLine", true,
                        "MinimumNumberOfCharacters", Definitions.MIMIMUM_NUMBER_OF_CHARACTERS_FOR_REASON
                        ));

                msg = WaitForMessage();

                initialErrorKey = null;

                if (msg.Name.EndsWith(".StringEntered"))
                {
                    reasonFreeTextForZoneTypeScreen = ExtractParameter<string>(msg.Parameters, "stringValue");
                }
                else
                {
                    //goback
                    goto Step_AskForReasonForZoneType;
                }
            }
            #endregion

            if (listOfReasonsCodesAndZoneTypes.ContainsKey(zoneTypeCode))
            {
                listOfReasonsCodesAndZoneTypes[zoneTypeCode] = new ReasonInfo(reasonCodeForZoneTypeScreen, reasonFreeTextForZoneTypeScreen);
            }
            else
            {
                listOfReasonsCodesAndZoneTypes.Add(zoneTypeCode, new ReasonInfo(reasonCodeForZoneTypeScreen, reasonFreeTextForZoneTypeScreen));
            }

            foreach (string zoneTypeCodeItem in listOfReasonsCodesAndZoneTypes.Keys)
            {
                foreach (DataRow row in dsZoneTypesAndReasons.Tables[0].Select(ZoneTypeDataSet.Columns.ZONETYPE_CODE.Name as string + "= '" + zoneTypeCodeItem + "'"))
                {
                    row[ZoneTypeDataSet.Columns.REASON_CODE.Name] = listOfReasonsCodesAndZoneTypes[zoneTypeCodeItem].ReasonCode;
                    row[ZoneTypeDataSet.Columns.REASON_NAME.Name] = reasonNameForZoneTypeScreen;//dsReasons.Tables[0].Select(ReasonDataSet.Columns.REASON_CODE.Name + "= '" + listOfReasonsCodesAndZoneTypes[zoneTypeCodeItem]. + "'")[0][ReasonDataSet.Columns.REASON_NAME.Name];
                }
            }

            goto Step_SelectZoneType;

            #endregion

        Step_CanItemBeStoredOnLocation:

            #region CAN ITEM BE STORED ON LOCATION

            if (!sboProviderService.InvokeMethodWithDbConnection<bool>(false, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteCanItemBeStoredOnStorageLocation), currentDockCode, itemCode))
            {
                initialErrorKey = "MSG_ERROR_STORAGE_LOCATION_NOT_ALLOWED_FOR_ITEM";
                goto Step_IdentifyProduct;
            }


            batchNumber = null;
            secondBatchNumber = null;
            bestBeforeDate = null;
            quantity = 0;



            #endregion

        Step_SelectBatchNumber:

            #region SELECT BATCH NUMBER

            batchNumber = null;

            if (itemInfo.HasBatchnumber)
            {

                generatedBatch1Info = sboProviderService.InvokeMethodWithDbConnection<GeneratedBatchNumberReception>(false, false, null, null, new DelegateWithPmxDbConnection<GeneratedBatchNumberReception>(ExecuteGenerateBatchNumber1ForReception), purchaseDocRef, null, itemCode, cardCode, true);

                tempBatchNumber = null;

                if (barcode != null &&
                    barcode.GS1DataObject != null &&
                    !string.IsNullOrEmpty(barcode.GS1DataObject.LotNumber))
                {
                    tempBatchNumber = barcode.GS1DataObject.LotNumber.ToUpper();
                }

                //If the batchnumber can be overwritten by GS1 batchnumber and it is filled in then
                //we use this batchnumber
                if (generatedBatch1Info.CanBeOverwrittenByGS1BatchNumber && (tempBatchNumber != null) && (tempBatchNumber.Length > 0))
                {
                    if (goBack)
                    {
                        goto Step_IdentifyProduct;
                    }
                    //user cannot change batchnumber
                    batchNumber = tempBatchNumber;
                    goto Step_SecondBatchNumber;
                }
                else
                {
                    tempBatchNumber = generatedBatch1Info.BatchNumber;

                    if (generatedBatch1Info.IsUserAllowedToChange)
                    {
                        DataSet dsBatchToSelect = null;

                        if (allowToSelectBatch)
                        {
                            query = BuildQuery.GetAllBatchesInStock(itemInfo.ItemCode);
                            dsBatchToSelect = sboProviderService.RunView(true, null, null, query);
                        }


                        //no batchnumber provided, so ask for batchnumber
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Reception.IIdentifyBatchNumberScreen),
                         DefaultCultureInfo.Get(), BuildParamCollection(
                             "InitialErrorKey", initialErrorKey,
                             "TitleKey", "MSG_TITLE_IDENTIFY_BATCH_NUMBER",
                             "PONumber", purchaseOrderDocNum.HasValue ? purchaseOrderDocNum.Value : (int?)null,
                             "ItemDescription", itemDescription,
                             "ItemCode", itemInfo.ItemCode,
                             "ItemBarcode", itemInfo.CodeBars,
                             "StillToReceive", stillToReceive,
                             "CurrentSSCC", SSCC,
                             "InitialBatchNumber", tempBatchNumber,
                             "AllowToSelect", (this.GetNumberOfRows(dsBatchToSelect) > 0 && allowToSelectBatch),
                             "BatchDS", dsBatchToSelect,
                             "Uom", string.IsNullOrEmpty(itemInfo.PurchaseUom) ? itemInfo.InventoryUom : itemInfo.PurchaseUom
                            ));

                        msg = WaitForMessage();
                        goBack = false;
                        // reset error
                        initialErrorKey = null;

                        if (msg.Name.EndsWith(".BatchNumberEntered"))
                        {
                            batchNumber = ExtractParameter<string>(msg.Parameters, "batchNumber");
                            goto Step_SecondBatchNumber;
                        }
                        else if (msg.Name.EndsWith(".BackRequested"))
                        {
                            if (this.GetNumberOfRows(dsItems) == 1)
                            {
                                //go back
                                if (currentLogUnit != null &&
                                    currentLogUnit.ItemsOnLogisticUnit.Count > 0)
                                {
                                    //we want to go back, but we have some items in the list
                                    //ask user what to do
                                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                                        DefaultCultureInfo.Get(), BuildParamCollection(
                                            "TitleKey", "MSG_TITLE_PRODUCTS_ON_PALLET_TO_RECEIVE",
                                            "MessageKey", "MSG_QUESTION_PRODUCTS_ON_PALLET_TO_RECEIVE"));
                                    msg = WaitForMessage();

                                    if (msg.Name.EndsWith(".Yes"))
                                    {
                                        goto Step_ScanLabelStart;
                                    }

                                    goto Step_SelectBatchNumber;
                                }
                                goBack = true;
                                goto Step_IdentifyProduct;
                            }

                            goBack = true;
                            //there where more items in the list
                            goto Step_IdentifyProduct;
                        }

                    }
                    else
                    {
                        if (goBack)
                        {
                            goto Step_IdentifyProduct;
                        }
                        batchNumber = tempBatchNumber;
                    }

                    goBack = false;

                    goto Step_SecondBatchNumber;

                }
            }
            else
            {
                //no batchnumber, so we try to get second batch number
                goto Step_SecondBatchNumber;
            }

            #endregion

        Step_SecondBatchNumber:

            #region ENTER SECOND BATCH NUMBER

            secondBatchNumber = null;

            if (itemInfo.HasSecondBatchNumber)
            {
                generatedBatch2Info = sboProviderService.InvokeMethodWithDbConnection<GeneratedBatchNumberReception>(false, false, null, null, new DelegateWithPmxDbConnection<GeneratedBatchNumberReception>(ExecuteGenerateBatchNumber1ForReception), purchaseDocRef, null, itemCode, cardCode, false);

                tempBatchNumber = null;

                if (barcode != null &&
                    barcode.GS1DataObject != null &&
                    !string.IsNullOrEmpty(barcode.GS1DataObject.LotNumber))
                {
                    tempBatchNumber = barcode.GS1DataObject.LotNumber.ToUpper();
                }

                //If the batchnumber can be overwritten by GS1 batchnumber and it is filled in then
                //we use this batchnumber
                if (generatedBatch2Info.CanBeOverwrittenByGS1BatchNumber && (tempBatchNumber != null) && (tempBatchNumber.Length > 0))
                {
                    if (goBack)
                    {
                        goto Step_SelectBatchNumber;
                    }
                    //user cannot change batchnumber
                    secondBatchNumber = tempBatchNumber;
                    goto Step_BestBeforeDate;
                }
                else
                {
                    tempBatchNumber = generatedBatch2Info.BatchNumber;

                    DataSet dsInternalBatchToSelect = null;

                    if (allowToSelectBatch)
                    {
                        query = BuildQuery.GetAllInternalBatchesInStock(itemInfo.ItemCode, batchNumber);
                        dsInternalBatchToSelect = sboProviderService.RunView(true, null, null, query);

                        if (this.GetNumberOfRows(dsInternalBatchToSelect) == 1)
                        {
                            tempBatchNumber = dsInternalBatchToSelect.Tables[0].Rows[0][TextDataSet.Columns.TEXT.Name] as string;
                        }

                    }


                    if (generatedBatch2Info.IsUserAllowedToChange)
                    {
                        //no batchnumber provided, so ask for batchnumber
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Reception.IIdentifyBatchNumberScreen),
                         DefaultCultureInfo.Get(), BuildParamCollection(
                             "InitialErrorKey", initialErrorKey,
                             "TitleKey", "MSG_TITLE_IDENTIFY_BATCH_NUMBER2",
                             "PONumber", purchaseOrderDocNum.HasValue ? purchaseOrderDocNum.Value : (int?)null,
                             "ItemDescription", itemDescription,
                             "ItemCode", itemInfo.ItemCode,
                             "ItemBarcode", itemInfo.CodeBars,
                             "StillToReceive", stillToReceive,
                             "CurrentSSCC", SSCC,
                             "Uom", string.IsNullOrEmpty(itemInfo.PurchaseUom) ? itemInfo.InventoryUom : itemInfo.PurchaseUom,
                             "AllowToSelect", (this.GetNumberOfRows(dsInternalBatchToSelect) > 0 && autoSelectInternalBatch),
                             "BatchDS", dsInternalBatchToSelect,
                             "InitialBatchNumber", tempBatchNumber
                            ));
                        msg = WaitForMessage();

                        // reset error
                        initialErrorKey = null;
                        goBack = false;

                        if (msg.Name.EndsWith(".BatchNumberEntered"))
                        {
                            secondBatchNumber = ExtractParameter<string>(msg.Parameters, "batchNumber");
                            goto Step_BestBeforeDate;
                        }
                        else if (msg.Name.EndsWith(".BackRequested"))
                        {
                            goBack = true;
                            goto Step_SelectBatchNumber;
                        }

                    }
                    else
                    {
                        if (goBack)
                        {
                            goto Step_SelectBatchNumber;
                        }
                        secondBatchNumber = tempBatchNumber;
                    }

                    goBack = false;

                    goto Step_BestBeforeDate;

                }
            }
            else
            {
                //no second batchnumber, so we try to get best before date
                goto Step_BestBeforeDate;
            }

            #endregion

        Step_BestBeforeDate:

            #region PROVIDE BEST BEFORE DATE
            if (itemInfo.HasBestBeforeDate)
            {

                if (goBack)
                {
                    if (itemInfo.HasSecondBatchNumber)
                    {
                        goto Step_SecondBatchNumber;
                    }
                    else if (itemInfo.HasBatchnumber)
                    {
                        goto Step_SelectBatchNumber;
                    }


                    if (this.GetNumberOfRows(dsItems) == 1)
                    {
                        //go back
                        if (currentLogUnit != null &&
                            currentLogUnit.ItemsOnLogisticUnit.Count > 0)
                        {
                            //we want to go back, but we have some items in the list
                            //ask user what to do
                            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                                DefaultCultureInfo.Get(), BuildParamCollection(
                                    "TitleKey", "MSG_TITLE_PRODUCTS_ON_PALLET_TO_RECEIVE",
                                    "MessageKey", "MSG_QUESTION_PRODUCTS_ON_PALLET_TO_RECEIVE"));
                            msg = WaitForMessage();

                            if (msg.Name.EndsWith(".Yes"))
                            {
                                goto Step_ScanLabelStart;
                            }

                            goto Step_BestBeforeDate;
                        }
                    }
                    goto Step_IdentifyProduct;

                }

                if (barcode != null &&
                    barcode.GS1DataObject != null &&
                    barcode.GS1DataObject.BestBeforeDate.HasValue)
                {

                    bestBeforeDate = barcode.GS1DataObject.BestBeforeDate.Value;

                    //check if BBD is valid
                    if (SboHelper.ConvertDateToSboDate(bestBeforeDate.Value) < SboHelper.ConvertDateToSboDate(DateTime.Now.AddDays(itemInfo.ShelfLifeInDaysReception)))
                    {
                        // Inform the user the BBD is incorrect
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "MessageKey", "MSG_ERROR_RECEPTION_BBD_DOES_NOT_MEET_SHELF_LIFE",
                                "MessageAddendum", bestBeforeDate.Value.ToString("dd/MM/yyyy"),
                                "ShowButton", true));
                        WaitForMessage();
                    }

                    //now check if there is an item in stock with later BBD
                    query = BuildQuery.GetStockWithLaterBBD(itemCode, bestBeforeDate.Value);
                    DataSet ds = sboProviderService.RunView(false, null, null, query);

                    if (this.GetNumberOfRows(ds) > 0)
                    {
                        //we found stock with later BBD
                        // Inform the user the BBD is incorrect
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "MessageKey", "MSG_ERROR_RECEPTION_LATER_BBD_FOUND",
                                "MessageAddendum", ((DateTime)ds.Tables[0].Rows[0][PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME]).ToString("dd/MM/yyyy"),
                                "ShowButton", true));
                        WaitForMessage();
                    }
                }
                else
                {
                    generatedBBDInfo = sboProviderService.InvokeMethodWithDbConnection<GeneratedBestBeforeDateReception>(false, false, null, null, new DelegateWithPmxDbConnection<GeneratedBestBeforeDateReception>(ExecuteGenerateBBDForReception), itemCode);

                    bestBeforeDate = generatedBBDInfo.GeneratedDateTime.Value;
                    allowToChangeGeneratedBBDOnReception = generatedBBDInfo.CanUserChangeGeneratedBBD;

                    if (allowToChangeGeneratedBBDOnReception)
                    {
                        goBack = false;

                        //ask for best before date
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Reception.IEnterBestBeforeDateScreen),
                         DefaultCultureInfo.Get(), BuildParamCollection(
                             "InitialErrorKey", initialErrorKey,
                             "TitleKey", "MSG_TITLE_ENTER_BEST_BEFORE_DATE",
                            "DefaultDateTime", bestBeforeDate,
                             "PONumber", purchaseOrderDocNum.HasValue ? purchaseOrderDocNum.Value : (int?)null,
                             "ItemDescription", itemDescription,
                             "ItemCode", itemInfo.ItemCode,
                             "ItemBarcode", itemInfo.CodeBars,
                             "StillToReceive", stillToReceive,
                             "CurrentSSCC", SSCC,
                             "Uom", string.IsNullOrEmpty(itemInfo.PurchaseUom) ? itemInfo.InventoryUom : itemInfo.PurchaseUom,
                             "BatchNumber", batchNumber
                             ));
                        msg = WaitForMessage();

                        // reset error
                        initialErrorKey = null;

                        if (msg.Name.EndsWith(".BestBeforDateEntered"))
                        {
                            bestBeforeDate = ExtractParameter<DateTime?>(msg.Parameters, "bestBeforeDate");

                            //check if BBD is valid
                            if (SboHelper.ConvertDateToSboDate(bestBeforeDate.Value) < SboHelper.ConvertDateToSboDate(DateTime.Now.AddDays(itemInfo.ShelfLifeInDaysReception)))
                            {
                                //ask user what to do
                                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                                    DefaultCultureInfo.Get(), BuildParamCollection(
                                        "TitleKey", "MSG_TITLE_RECEPTION_BBD_DOES_NOT_MEET_SHELF_LIFE",
                                        "MessageKey", "MSG_QUESTION_RECEPTION_BBD_DOES_NOT_MEET_SHELF_LIFE"));
                                msg = WaitForMessage();

                                if (msg.Name.EndsWith(".Yes"))
                                {
                                    goto Step_BestBeforeDate;
                                }
                            }

                            //now check if there is an item in stock with later BBD
                            query = BuildQuery.GetStockWithLaterBBD(itemCode, bestBeforeDate.Value);
                            DataSet ds = sboProviderService.RunView(false, null, null, query);

                            if (this.GetNumberOfRows(ds) > 0)
                            {
                                //we found stock with later BBD
                                //ask user what to do
                                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                                    DefaultCultureInfo.Get(), BuildParamCollection(
                                        "TitleKey", "MSG_TITLE_RECEPTION_LATER_BBD_FOUND",
                                        "MessageKey", "MSG_QUESTION_RECEPTION_LATER_BBD_FOUND",
                                        "Parameters", new object[] { ((DateTime)ds.Tables[0].Rows[0][PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME]).ToString("dd/MM/yyyy") }));
                                msg = WaitForMessage();

                                if (msg.Name.EndsWith(".Yes"))
                                {
                                    goto Step_BestBeforeDate;
                                }
                            }
                            goto Step_EnterPackagingQuantity;

                        }
                        else if (msg.Name.EndsWith(".BackRequested"))
                        {
                            goBack = true;
                            if (itemInfo.HasSecondBatchNumber)
                            {
                                goto Step_SecondBatchNumber;
                            }
                            else if (itemInfo.HasBatchnumber)
                            {
                                goto Step_SelectBatchNumber;
                            }


                            if (this.GetNumberOfRows(dsItems) == 1)
                            {
                                //go back
                                if (currentLogUnit != null &&
                                    currentLogUnit.ItemsOnLogisticUnit.Count > 0)
                                {
                                    //we want to go back, but we have some items in the list
                                    //ask user what to do
                                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                                        DefaultCultureInfo.Get(), BuildParamCollection(
                                            "TitleKey", "MSG_TITLE_PRODUCTS_ON_PALLET_TO_RECEIVE",
                                            "MessageKey", "MSG_QUESTION_PRODUCTS_ON_PALLET_TO_RECEIVE"));
                                    msg = WaitForMessage();

                                    if (msg.Name.EndsWith(".Yes"))
                                    {
                                        goto Step_ScanLabelStart;
                                    }

                                    goto Step_BestBeforeDate;
                                }
                            }

                            //there where more items in the list
                            goto Step_IdentifyProduct;


                        }
                    }

                    goto Step_EnterPackagingQuantity;
                }
            }
            else
            {
                //no best before date
                goto Step_EnterPackagingQuantity;
            }

            #endregion

        Step_EnterPackagingQuantity:

            #region ENTER PACKAGING QUANTITY

            if ((itemInfo.HasBatchnumber || itemInfo.HasSecondBatchNumber || itemInfo.HasBestBeforeDate))
            {
                currentListOfTransactionalPackagingTypeInfos = GetTransactionalPackagingInfo(purchaseDeliveryNoteList, batchNumber, secondBatchNumber, bestBeforeDate, itemCode);

                if (currentListOfTransactionalPackagingTypeInfos == null)
                {
                    query = BuildQuery.GetExistingITRI(itemCode, batchNumber, secondBatchNumber, bestBeforeDate);
                    dsExistingBatch = sboProviderService.RunView(false, null, null, query);

                    if (this.GetNumberOfRows(dsExistingBatch) == 0)
                    {
                        //batch not found, so we need to enter the quantity for the packaging types
                        currentListOfTransactionalPackagingTypeInfos = SetItemTransactionalPackagingTypeInfoList(itemInfo);
                        bool foundAtLeastOnePackagingTypeToShowOnScreen = false;
                        bool isFirst = true;
                        listOfPackagingTypeInfosForScreen = new Collection<PackagingTypeInfo>();
                        foreach (PmxItemPackagingTypeInfo packType in itemInfo.ListOfPackagingTypes)
                        {

                            PackagingTypeInfo info = new PackagingTypeInfo();

                            if (isFirst)
                            {
                                info.NumberOfDecimals = itemInfo.UomDecimals;
                            }

                            info.Quantity = packType.Quantity;
                            info.PackagingTypeCode = packType.PackagingTypeCode;
                            info.PackagingTypeName = packType.PackagingTypeName;

                            info.ShowOnScreen = (packType.AskDuringReception &&
                             !packType.Barcodes.Contains(gtin));

                            listOfPackagingTypeInfosForScreen.Add(info);

                            if (!foundAtLeastOnePackagingTypeToShowOnScreen &&
                                info.ShowOnScreen)
                            {
                                foundAtLeastOnePackagingTypeToShowOnScreen = true;
                            }

                            isFirst = false;
                        }

                        if (foundAtLeastOnePackagingTypeToShowOnScreen)
                        {
                            initialErrorKey = "MSG_ENTER_QUANTITY_OF_ALL_PACKAGING_TYPES";
                            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterPackagingQuantityScreen),
                                DefaultCultureInfo.Get(), BuildParamCollection(
                                "InitialErrorKey", initialErrorKey,
                                "TitleKey", "MSG_TITLE_ENTER_QUANTITY_OF_ALL_PACKAGING_TYPES",
                                "ItemDescription", itemDescription,
                                "ItemCode", itemInfo.ItemCode,
                                "ItemBarcode", itemInfo.CodeBars,
                                "UOM", string.IsNullOrEmpty(itemInfo.PurchaseUom) ? itemInfo.InventoryUom : itemInfo.PurchaseUom,
                                "ListOfPackagingTypeInfos", listOfPackagingTypeInfosForScreen,
                                "IsForEnteringDefaultPackagingQuantity", true,
                                "BatchNumber", batchNumber,
                                "BestBeforeDate", bestBeforeDate,
                                "SSCC", SSCC,
                                "DocNum", Convert.ToString(purchaseOrderDocNum),
                                "InitialErrorKeyIsError", false
                                ));

                            msg = WaitForMessage();

                            // reset error
                            initialErrorKey = null;

                            if (msg.Name.EndsWith(".QuantitiesEntered"))
                            {
                                PackagingTypeInfos screenListOfPackagingTypeInfos = ExtractParameter<PackagingTypeInfos>(msg.Parameters, "listOfPackagingTypeInfos");

                                //build the list of packaging quantities
                                foreach (ItemTransactionalPackagingTypeInfo info in currentListOfTransactionalPackagingTypeInfos)
                                {
                                    //try to get new qty from user
                                    if (screenListOfPackagingTypeInfos.PackagingTypeInfoList.ContainsKey(info.PackagingTypeCode))
                                    {
                                        info.Quantity = screenListOfPackagingTypeInfos.PackagingTypeInfoList[info.PackagingTypeCode].Quantity;
                                    }
                                }

                                goto Step_EnterQuantity;
                            }
                            else if (msg.Name.EndsWith(".BackRequested"))
                            {
                                goBack = true;
                                if (itemInfo.HasBestBeforeDate)
                                {
                                    goto Step_BestBeforeDate;
                                }
                                else if (itemInfo.HasSecondBatchNumber)
                                {
                                    goto Step_SecondBatchNumber;
                                }
                                goto Step_SelectBatchNumber;
                            }

                        }

                    }
                    else
                    {
                        //we found the batch, so now fill in the packaging data from the batch
                        currentListOfTransactionalPackagingTypeInfos = new Collection<ItemTransactionalPackagingTypeInfo>();
                        foreach (DataRow row in dsExistingBatch.Tables[0].Rows)
                        {
                            ItemTransactionalPackagingTypeInfo newPackInfo = new ItemTransactionalPackagingTypeInfo();

                            newPackInfo.PackagingTypeCode = Convert.ToString(row[PmxItemTransactionalPackagingTypeTable.Columns.PackagingTypeCode.NAME]);
                            newPackInfo.Quantity = Convert.ToDouble(row[PmxItemTransactionalPackagingTypeTable.Columns.Quantity.NAME]);
                            newPackInfo.ItriKey = Convert.ToInt32(row[PmxItemTransactionalInfoTable.Columns.InternalKey.NAME]);

                            newPackInfo.ItemCode = itemInfo.ItemCode;

                            currentListOfTransactionalPackagingTypeInfos.Add(newPackInfo);
                        }

                        goto Step_EnterQuantity;
                    }
                }

                goto Step_EnterQuantity;
            }
            else
            {
                //no batch info
                //get the packaging types qty from item
                currentListOfTransactionalPackagingTypeInfos = SetItemTransactionalPackagingTypeInfoList(itemInfo);



                goto Step_EnterQuantity;
            }

            #endregion

        Step_EnterQuantity:

            #region ENTER QUANTITY

            quantity = 0;
            listOfSerialNumbers = null;
            m_subFlowListOfSerialNumbers = null;

            if (IsQuantityOnBarcode(barcode))
            {
                initialQuantity = Convert.ToDouble(barcode.GS1DataObject.Count);
            }
            else
            {
                initialQuantity = 1;
            }

            //if (this.IsLUOnBarcode(barcode))
            //{
            //    maxQuantity = 1;
            //}
            //else 
            if ((purchaseDocRef != null && purchaseDocRef.DocType == SboObjectTypes.PurchaseInvoice) ||
            (purchaseDocRef != null && !allowToExceedOrderedQuantity) ||
            (containerDocEntry.HasValue && !allowToExceedOrderedQuantity))
            {
                maxQuantity = stillToReceive / batchReceivingNumber;
            }
            else
            {
                maxQuantity = -1;
            }

            bool getNormalQuantity = true;

            if ((itemInfo.HasSerialNumber || itemInfo.HasSAPSerialNumber) && batchReceivingNumber == 1)
            {
                #region SERIAL NUMBER








                getNormalQuantity = false;

                ////show screen to ask user what to do.
                //buttonKeys = new List<string>(new Collection<string>() { "MSG_BUTTON_SERIAL_NUMBER", "MSG_BUTTON_SERIAL_NUMBER_RANGE" });

                //if (!(//itemInfo.TrackLocationSerialNumber ||
                //    (itemInfo.HasSAPSerialNumber && itemInfo.ManageMethod == SboItemManageMethod.OnEveryTransaction)))
                //{
                //    buttonKeys.Add("MSG_BUTTON_NO_SERIAL_NUMBER");
                //}


                //toolBarButtons = ToolBarButtons.Back;

                //session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectButtonScreen),
                //        DefaultCultureInfo.Get(), BuildParamCollection(
                //        "InitialErrorKey", initialErrorKey,
                //        "TitleKey", "MSG_TITLE_ENTER_QUANTITY_SERIAL_NUMBER_TASK",
                //        "AllowedButtons", buttonKeys.ToArray(),
                //        "EnabledToolBarButtons", toolBarButtons
                //        ));
                //msg = WaitForMessage();
                //initialErrorKey = null;
                //if (msg.Name.EndsWith(".ButtonClicked"))
                //{
                //    string buttonKeySerial = ExtractParameter<string>(msg.Parameters, "buttonKey");

                //    if (buttonKeySerial == "MSG_BUTTON_SERIAL_NUMBER" ||
                //        buttonKeySerial == "MSG_BUTTON_SERIAL_NUMBER_RANGE")
                //    {
                        #region ENTER SERIAL NUMBERS


                        //get ITRI
                        int? itriKey = null;
                        if (itemInfo.HasBestBeforeDate ||
                            itemInfo.HasSecondBatchNumber ||
                            itemInfo.HasBatchnumber)
                        {
                            itriKey = sboProviderService.InvokeMethodWithDbConnection<int?>(false, false, null, null, new DelegateWithPmxDbConnection<int?>(ExecuteGetCreateItemTransactionalInfoKey), itemCode, batchNumber, secondBatchNumber, bestBeforeDate);
                        }


                        bool isSerialNumberRange = false; //(buttonKeySerial == "MSG_BUTTON_SERIAL_NUMBER_RANGE");

                        m_enterQuantitySubFlow.BindParameters(
                            this.DefaultCultureInfo,
                            this.PmxOseCompany,
                            new ReadOnlyBinder<string>("TitleKey", "MSG_TITLE_ENTER_QUANTITY"),
                            new ReadOnlyBinder<PmxItemInfo>("ItemInfo", itemInfo),
                            new ReadOnlyBinder<string>("BatchNumber", batchNumber),
                            new ReadOnlyBinder<DateTime?>("BestBeforeDate", bestBeforeDate),
                            new ReadOnlyBinder<int?>("ItriKey", itriKey),
                            new ReadOnlyBinder<string>("LocationCode", currentDockCode),
                            new ReadOnlyBinder<string>("SSCC", SSCC),

                            new ReadOnlyBinder<string>("DocNum", Convert.ToString(purchaseOrderDocNum)),
                            new ReadOnlyBinder<bool>("UsePickingInfo", false),

                            new ReadOnlyBinder<bool>("AllowZero", false),
                            new ReadOnlyBinder<double>("InitialQuantity", initialQuantity),
                            new ReadOnlyBinder<string>("MessageKeyStillQuantity", "MSG_LBL_STILL_TO_RECEIVE"),
                            new ReadOnlyBinder<double>("StillToQuantity", stillToReceive),
                            new ReadOnlyBinder<double>("MaximumQuantity", maxQuantity),
                            new ReadOnlyBinder<double>("TotalQuantityToPick", 0),
                            new ReadOnlyBinder<string>("UOM", itemInfo.PurchaseUom),
                            new ReadOnlyBinder<int>("NumberOfDigitsAfterDecimal", (itemInfo != null) ? itemInfo.UomDecimals : 0),

                            new ReadOnlyBinder<double>("InnerQuantity", numberOfItemsInPurchaseUnit.Value),
                            new ReadOnlyBinder<string>("InnerUOM", itemInfo.InventoryUom),
                            new ReadOnlyBinder<bool>("ForceInputSerialNumbers", true),
                            new ReadOnlyBinder<string>("ObjectType", ((int)SboLinkDocumentType.PurchaseOrder).ToString()),
                            new ReadOnlyBinder<int?>("DocEntry", purchaseOrderDocNum),
                            new ReadOnlyBinder<bool>("UseSerialNumberRange", isSerialNumberRange),
                            new ReadOnlyBinder<string>("LocationCode", currentDockCode),

                            new ReadOnlyBinder<int?>("LUID", null),


                            new ReadWriteBinder<double>("QuantityEntered", this, "m_subFlowQuantity"),
                            new ReadWriteBinder<bool>("BackRequested", this, "m_subFlowBackRequested"),
                            new ReadWriteBinder<Collection<string>>("ListOfSerialNumbers", this, "m_subFlowListOfSerialNumbers")

                            );
                        m_subFlowBackRequested = false;
                        this.StartSubFlowAndWait(m_enterQuantitySubFlow, true);

                        if (m_subFlowBackRequested)
                        {
                            goto Step_EnterQuantity;
                        }

                        listOfSerialNumbers = m_subFlowListOfSerialNumbers;

                        quantity = m_subFlowQuantity;

                        goto Step_CheckQuantity;

                        #endregion

                //    }

                //    getNormalQuantity = true;
                //}

                //if (msg.Name.EndsWith(".BackRequested"))
                //{
                //    goBack = true;
                //    goto Step_GoBackOnEnterQuantity;
                //}



                #endregion
            }

            if (getNormalQuantity)
            {
                if (itemInfo.ListOfPackagingTypes != null &&
                    currentListOfTransactionalPackagingTypeInfos.Count > 0)
                {
                    #region QUANTITY WITH PACKAGING TYPE

                    //build list of packaging types

                    listOfPackagingTypeInfosForScreen = new Collection<PackagingTypeInfo>();

                    //add first one for the uom

                    PackagingTypeInfo info = new PackagingTypeInfo();

                    info.Quantity = 1;
                    info.PackagingTypeCode = null;
                    info.PackagingTypeName = itemInfo.InventoryUom == null ? itemInfo.ItemCode : itemInfo.InventoryUom;
                    info.QuantityPerPack = 1;
                    if (!string.IsNullOrEmpty(itemInfo.CodeBars))
                    {
                        info.Barcode.Add(itemInfo.CodeBars);
                    }
                    info.NumberOfDecimals = itemInfo.UomDecimals;
                    if (info.Barcode.Contains(gtin))
                    {
                        info.InitialQuantity = 1;
                    }
                    else
                    {
                        info.InitialQuantity = 0;
                    }
                    listOfPackagingTypeInfosForScreen.Add(info);


                    foreach (ItemTransactionalPackagingTypeInfo packType in currentListOfTransactionalPackagingTypeInfos)
                    {

                        info = new PackagingTypeInfo();

                        info.Quantity = packType.Quantity;
                        info.PackagingTypeCode = packType.PackagingTypeCode;
                        info.PackagingTypeName = GetPackTypeName(packType.PackagingTypeCode, itemInfo.ListOfPackagingTypes);
                        info.Barcode = GetPackBarcode(packType.PackagingTypeCode, itemInfo.ListOfPackagingTypes);
                        info.HideDuringEnteringQuantity = GetHideDuringEnteringQuantity(packType.PackagingTypeCode, itemInfo.ListOfPackagingTypes);

                        if (info.Barcode.Contains(gtin))
                        {
                            info.InitialQuantity = 1;
                        }
                        else
                        {
                            info.InitialQuantity = 0;
                        }

                        info.QuantityPerPack = packType.Quantity;

                        listOfPackagingTypeInfosForScreen.Add(info);
                    }




                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterPackagingQuantityScreen),
                                        DefaultCultureInfo.Get(), BuildParamCollection(
                                        "InitialErrorKey", initialErrorKey,
                                        "TitleKey", "MSG_TITLE_ENTER_QUANTITY",
                                        "ItemDescription", itemDescription,
                                        "ItemCode", itemInfo.ItemCode,
                                        "ItemBarcode", itemInfo.CodeBars,
                                        "UOM", string.IsNullOrEmpty(itemInfo.PurchaseUom) ? itemInfo.InventoryUom : itemInfo.PurchaseUom,
                                        "ListOfPackagingTypeInfos", listOfPackagingTypeInfosForScreen,
                                        "IsForEnteringDefaultPackagingQuantity", false,
                                        "BatchNumber", batchNumber,
                                        "BestBeforeDate", bestBeforeDate,
                                        "SSCC", SSCC,
                                        "DocNum", Convert.ToString(purchaseOrderDocNum),
                                        "StillToQuantity", stillToReceive,
                                        "MaximumQuantity", maxQuantity,
                                        "MessageKeyStillQuantity", "MSG_LBL_STILL_TO_RECEIVE",
                                        "AllowZero", false
                                        ));

                    msg = WaitForMessage();

                    // reset error
                    initialErrorKey = null;

                    if (msg.Name.EndsWith(".QuantitiesEntered"))
                    {
                        PackagingTypeInfos screenListOfPackagingTypeInfos = ExtractParameter<PackagingTypeInfos>(msg.Parameters, "listOfPackagingTypeInfos");

                        //build the list of packaging quantities
                        foreach (PackagingTypeInfo infoForQty in screenListOfPackagingTypeInfos.PackagingTypeInfoList.Values)
                        {
                            quantity += (infoForQty.Quantity * infoForQty.QuantityPerPack);
                        }

                        goto Step_CheckQuantity;
                    }
                    else if (msg.Name.EndsWith(".BackRequested"))
                    {
                        goBack = true;
                        //if (itemInfo.HasBestBeforeDate)
                        //{
                        //    goto Step_BestBeforeDate;
                        //}
                        //else if (itemInfo.HasSecondBatchNumber)
                        //{
                        //    goto Step_SecondBatchNumber;
                        //}
                        //else if (itemInfo.HasBatchnumber)
                        //{
                        //    goto Step_SelectBatchNumber;
                        //}

                        //if (this.GetNumberOfRows(dsItems) == 1)
                        //{
                        //    //go back
                        //    if (currentLogUnit != null &&
                        //        currentLogUnit.ItemsOnLogisticUnit.Count > 0)
                        //    {
                        //        //we want to go back, but we have some items in the list
                        //        //ask user what to do
                        //        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                        //            DefaultCultureInfo.Get(), BuildParamCollection(
                        //                "TitleKey", "MSG_TITLE_PRODUCTS_ON_PALLET_TO_RECEIVE",
                        //                "MessageKey", "MSG_QUESTION_PRODUCTS_ON_PALLET_TO_RECEIVE"));
                        //        msg = WaitForMessage();

                        //        if (msg.Name.EndsWith(".Yes"))
                        //        {
                        //            goto Step_ScanLabelStart;
                        //        }

                        //        goto Step_EnterQuantity;
                        //    }
                        //}

                        //goto Step_IdentifyProduct;
                    }
                    #endregion
                }
                else
                {
                    #region QUANTITY NO PACKAGING TYPE

                    //no packaging types, so enter quantity on 'normal' way



                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterQuantityWithItemInfoScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "TitleKey", "MSG_TITLE_ENTER_QUANTITY",
                        "ItemDescription", itemDescription,
                        "ItemCode", itemInfo.ItemCode,
                        "ItemBarcode", itemInfo.CodeBars,
                        "InitialQuantity", initialQuantity > 1 ? initialQuantity : Math.Max(1.0, itemInfo.DefaultQuantityOnLogisticUnit),
                        "InnerQuantity", numberOfItemsInPurchaseUnit.Value,
                        "MaximumQuantity", maxQuantity,
                        "NumberOfDigitsAfterDecimal", itemInfo.UomDecimals,
                        "InnerUOM", itemInfo.InventoryUom,
                        "UOM", string.IsNullOrEmpty(itemInfo.PurchaseUom) ? itemInfo.InventoryUom : itemInfo.PurchaseUom,
                        "BatchNumber", batchNumber,
                        "BestBeforeDate", bestBeforeDate,
                        "SSCC", SSCC,
                        "DocNum", Convert.ToString(purchaseOrderDocNum),
                        "StillToQuantity", stillToReceive,
                        "MessageKeyStillQuantity", "MSG_LBL_STILL_TO_RECEIVE"
                        ));

                    msg = WaitForMessage();

                    // reset error
                    initialErrorKey = null;

                    if (msg.Name.EndsWith(".QuantityEntered"))
                    {
                        quantity = ExtractParameter<double>(msg.Parameters, "quantity");

                        goto Step_CheckQuantity;
                    }
                    else if (msg.Name.EndsWith(".BackRequested"))
                    {
                        goBack = true;

                        //if (itemInfo.HasBestBeforeDate)
                        //{
                        //    goto Step_BestBeforeDate;
                        //}
                        //else if (itemInfo.HasSecondBatchNumber)
                        //{
                        //    goto Step_SecondBatchNumber;
                        //}
                        //else if (itemInfo.HasBatchnumber)
                        //{
                        //    goto Step_SelectBatchNumber;
                        //}


                        //if (this.GetNumberOfRows(dsItems) == 1)
                        //{
                        //    //go back
                        //    if (currentLogUnit != null &&
                        //        currentLogUnit.ItemsOnLogisticUnit.Count > 0)
                        //    {
                        //        //we want to go back, but we have some items in the list
                        //        //ask user what to do
                        //        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                        //            DefaultCultureInfo.Get(), BuildParamCollection(
                        //                "TitleKey", "MSG_TITLE_PRODUCTS_ON_PALLET_TO_RECEIVE",
                        //                "MessageKey", "MSG_QUESTION_PRODUCTS_ON_PALLET_TO_RECEIVE"));
                        //        msg = WaitForMessage();

                        //        if (msg.Name.EndsWith(".Yes"))
                        //        {
                        //            goto Step_ScanLabelStart;
                        //        }

                        //        goto Step_EnterQuantity;
                        //    }
                        //}

                        ////there where more items in the list
                        //goto Step_IdentifyProduct;

                    }

                    #endregion
                }
            }

        Step_GoBackOnEnterQuantity:

            //go back

            goBack = true;

            if (itemInfo.HasBestBeforeDate)
            {
                goto Step_BestBeforeDate;
            }
            else if (itemInfo.HasSecondBatchNumber)
            {
                goto Step_SecondBatchNumber;
            }
            else if (itemInfo.HasBatchnumber)
            {
                goto Step_SelectBatchNumber;
            }


            if (this.GetNumberOfRows(dsItems) == 1)
            {
                //go back
                if (currentLogUnit != null &&
                    currentLogUnit.ItemsOnLogisticUnit.Count > 0)
                {
                    //we want to go back, but we have some items in the list
                    //ask user what to do
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "TitleKey", "MSG_TITLE_PRODUCTS_ON_PALLET_TO_RECEIVE",
                            "MessageKey", "MSG_QUESTION_PRODUCTS_ON_PALLET_TO_RECEIVE"));
                    msg = WaitForMessage();

                    if (msg.Name.EndsWith(".Yes"))
                    {
                        goto Step_ScanLabelStart;
                    }

                    goto Step_EnterQuantity;
                }
            }

            //there where more items in the list
            goto Step_IdentifyProduct;



            #endregion

        Step_CheckQuantity:

            #region CHECK QUANTITY


            double qtyToCheck = 0;
            if (itemInfo.ListOfPackagingTypes != null &&
                listOfPackagingTypeInfosForScreen != null &&
            listOfPackagingTypeInfosForScreen.Count > 0)
            {
                //if packaging types are entered, the quantity is in inventory uom,
                //so we need to adjust the quantity to receive
                qtyToCheck = (quantity / numberOfItemsInPurchaseUnit.Value);
            }
            else
            {
                qtyToCheck = quantity;
            }

            double fullQuantity = qtyToCheck * batchReceivingNumber;


            if (fullQuantity > stillToReceive &&
                stillToReceive > 0)
            {
                //ask user what to do
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "TitleKey", "MSG_TITLE_RECEIVING_MORE_THAN_ORDERED",
                        "MessageKey", "MSG_QUESTION_RECEIVING_MORE_THAN_ORDERED"));
                msg = WaitForMessage();

                if (msg.Name.EndsWith(".Yes"))
                {
                    //re-enter the quantity
                    goto Step_EnterQuantity;
                }
            }

            goto Step_PrintItemLabel;

            #endregion

        Step_PrintItemLabel:

            #region PRINT ITEM LABEL
            numberOfItemLabels = 0;
            if (itemInfo.PrintItemLabel)
            {
                if (currentPmxOseCompany.GoodsReceiptAutoPrintItemLabels)
                {
                    numberOfItemLabels = Convert.ToInt32(Math.Ceiling(quantity));
                }
                else
                {
                    //ask user if he wants to print item labels
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "TitleKey", "MSG_TITLE_PRINT_ITEM_LABEL",
                            "MessageKey", "MSG_QUESTION_PRINT_ITEM_LABEL"));
                    msg = WaitForMessage();

                    if (msg.Name.EndsWith(".Yes"))
                    {
                        //numberOfItemLabels = Convert.ToInt32(Math.Ceiling(quantity));
                        numberOfItemLabels = null;
                    }
                    else
                    {
                        goto Step_EnterCurrentDataIntoList;
                    }

                }


                // print the labels

                //Set the data into binders
                this.m_printItemLabelFlow_LocationCode = currentDockCode;
                this.m_printItemLabelFlow_NeededBatchNumber = batchNumber;
                this.m_printItemLabelFlow_NeededBatchNumber2 = secondBatchNumber;
                this.m_printItemLabelFlow_NeededBestBeforeDate = bestBeforeDate;
                this.m_printItemLabelFlow_NeededItemCode = itemInfo.ItemCode;
                this.m_printItemLabelFlow_NeededNrOfLabels = numberOfItemLabels;
                this.m_printItemLabelFlow_EnteredQuantity = quantity;

                //call flow
                base.StartSubFlowAndWait(m_printItemLabelFlow, true);

                if (m_printItemLabelFlow_BackRequested)
                {
                    goto Step_EnterQuantity;
                }


                goto Step_EnterCurrentDataIntoList;


            }
            else
            {
                goto Step_EnterCurrentDataIntoList;
            }

            #endregion

        Step_EnterCurrentDataIntoList:

            #region ENTER CURRENT DATA INTO LIST

            if (itemInfo.ListOfPackagingTypes != null
                && listOfPackagingTypeInfosForScreen != null && listOfPackagingTypeInfosForScreen.Count > 0)
            {
                //if packaging types are entered, the quantity is in inventory uom,
                //so we need to adjust the quantity to receive
                quantity /= numberOfItemsInPurchaseUnit.Value;
            }

            //Use the first logistic unit. This because the code at this moment only supports
            //reception of one logistic unit that must be saved as a good receipt.
            LogisticUnitItemGoodReceipt logUnitItem = new LogisticUnitItemGoodReceipt();
            logUnitItem.BatchNumber1 = batchNumber;
            logUnitItem.BatchNumber2 = secondBatchNumber;
            logUnitItem.BestBeforeDate = bestBeforeDate;
            logUnitItem.ItemCode = itemInfo.ItemCode;
            logUnitItem.PurchaseDocRef = purchaseDocRef;
            logUnitItem.IsLogisticCarrierForLogisticUnit = false;
            logUnitItem.IsLogisticCarrier = itemInfo.IsLogisticCarrier;
            logUnitItem.QuantityPerUom = numberOfItemsInPurchaseUnit.Value;
            logUnitItem.Quantity = quantity;

            logUnitItem.ListOfSerialNumbers = listOfSerialNumbers;

            logUnitItem.ListOfReasonsByZoneType = listOfReasonsCodesAndZoneTypes;

            if (listOfReasonCodeByItem.ContainsKey(logUnitItem.ItemCode))
            {
                logUnitItem.ReasonInfo = listOfReasonCodeByItem[logUnitItem.ItemCode];
            }

            if (listOfPackagingTypeInfosForScreen != null && listOfPackagingTypeInfosForScreen.Count > 0)
            {
                //Screen list in in wrong order, so reversing order
                Collection<PackagingTypeInfo> tempList = new Collection<PackagingTypeInfo>();
                for (int iLoop = listOfPackagingTypeInfosForScreen.Count - 1; iLoop >= 0; iLoop--)
                {
                    tempList.Add(listOfPackagingTypeInfosForScreen[iLoop]);
                }

                logUnitItem.FullListOfPackagingTypes = tempList;
            }

            logUnitItem.ListOfPackagingTypes = currentListOfTransactionalPackagingTypeInfos;

            logUnitItem.AutoSelectPO = autoSelectPO;

            if (currentLogisticCarrier != null)
            {
                //add logistic carrier to list when it is set
                LogisticUnitItemGoodReceipt logUnitItemLogCar = new LogisticUnitItemGoodReceipt();

                logUnitItemLogCar.IsLogisticCarrierForLogisticUnit = currentLogisticCarrier.IsLogisticCarrierForLogisticUnit;
                logUnitItemLogCar.IsLogisticCarrier = currentLogisticCarrier.IsLogisticCarrier;
                logUnitItemLogCar.BatchNumber1 = currentLogisticCarrier.BatchNumber1;
                logUnitItemLogCar.BatchNumber2 = currentLogisticCarrier.BatchNumber2;
                logUnitItemLogCar.BestBeforeDate = currentLogisticCarrier.BestBeforeDate;
                logUnitItemLogCar.ItemCode = currentLogisticCarrier.ItemCode;
                logUnitItemLogCar.Quantity = currentLogisticCarrier.Quantity;

                currentLogUnit.ItemsOnLogisticUnit.Add(logUnitItemLogCar);
            }

            currentLogUnit.ItemsOnLogisticUnit.Add(logUnitItem);

            currentLogisticCarrier = null;

            goto Step_AskToAddMore;


            #endregion

        Step_AskToAddMore:

            #region ASK TO ADD MORE

            if (businessPartnerInfo != null)
            {
                if (this.IsLUOnBarcode(barcode) || businessPartnerInfo.HasNoMixedLogUnitsOnReception)
                {
                    //no more items allowed
                    goto Step_EnterDataIntoListToReceive;
                }
            }

            if (purchaseDocRef != null || containerDocEntry.HasValue)
            {
                //check if there are still items to receive
                query = BuildQuery.GetCodeNameItemsOrderByName(null, null, purchaseDocRef, cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing, true, false, crossDocking, containerDocEntry, sboProviderService.GetDbTool());
                dsCheckItems = sboProviderService.RunView(true, null, null, query);

                RemoveReceivedItems(purchaseDeliveryNoteList, dsCheckItems, currentLogUnit);

                if (this.GetNumberOfRows(dsCheckItems) == 0)
                {
                    //no more rows, so add the data
                    goto Step_EnterDataIntoListToReceive;
                }
            }


            //ask user if he wants to add another item to the list
            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                    "TitleKey", "MSG_TITLE_ADD_MORE_PRODUCTS",
                    "MessageKey", "MSG_QUESTION_ADD_MORE_PRODUCTS"));
            msg = WaitForMessage();

            if (msg.Name.EndsWith(".Yes"))
            {
                goto Step_ClearDataBeforeNextItem;
            }

            goto Step_EnterDataIntoListToReceive;

            #endregion

        Step_EnterDataIntoListToReceive:

            #region ENTER DATA INTO LIST TO RECEIVE

            if (receiveGoodsOnSelectedLocation && !crossDocking)
            {

            Step_IdentifyDestinationLocation:

                #region IDENTIFY DESTINATION LOCATION

                string firstItemCode = currentLogUnit.ItemsOnLogisticUnit[0].ItemCode;
                string defaultLocation = itemInfo.DefaultStorageLocationOrZoneCode;

                for (int x = 1; x < currentLogUnit.ItemsOnLogisticUnit.Count; x++)
                {
                    if (firstItemCode != currentLogUnit.ItemsOnLogisticUnit[x].ItemCode)
                    {
                        defaultLocation = null;
                        break;
                    }

                }

                string destinationLocation = null;
                string enteredDestinationLocationCode = null;
                string buttonKeyIdentifyDestinationLocationScreen = null;

                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.MoveOrder.IIdentifyLocationScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_SCAN_DESTINATION_LOCATION",
                    "HideDefaultLocation", defaultLocation == null,
                    "DefaultLocation", defaultLocation,
                    "EnabledToolBarButtons", ToolBarButtons.Forward,
                    "AllowedButtons", new string[] { "MSG_BUTTON_SELECT_LOCATION", "MSG_BUTTON_SELECT_EMPTY_LOCATION" }));
                msg = WaitForMessage();

                if (msg.Name.EndsWith(".ButtonClicked"))
                {
                    buttonKeyIdentifyDestinationLocationScreen = ExtractParameter<string>(msg.Parameters, "buttonKey");
                    goto Step_SelectDestinationLocation;
                }

                if (msg.Name.EndsWith(".LocationEntered"))
                {
                    enteredDestinationLocationCode = ExtractParameter<string>(msg.Parameters, "locationCode");
                    goto Step_SelectDestinationLocation;
                }

                //go back is not allowed
                goto Step_IdentifyDestinationLocation;

                #endregion

            Step_SelectDestinationLocation:

                #region SELECT DESTINATION LOCATION

                //get list of items/quantities
                PmxDictionary<string, PmxStorageLocationCanItemBeStoredInfo> canItemBeStoredInfoPerItemCode = new PmxDictionary<string, PmxStorageLocationCanItemBeStoredInfo>();
                foreach (LogisticUnitItemGoodReceipt info in currentLogUnit.ItemsOnLogisticUnit)
                {
                    PmxStorageLocationCanItemBeStoredInfo entry;
                    if (canItemBeStoredInfoPerItemCode.TryGetValue(info.ItemCode, out entry))
                    {
                        entry.Quantity += info.Quantity;
                    }
                    else
                    {
                        entry = new PmxStorageLocationCanItemBeStoredInfo(info.Quantity, null, null);
                        canItemBeStoredInfoPerItemCode.Add(info.ItemCode, entry);
                    }

                    int? itri = sboProviderService.InvokeMethodWithDbConnection<int?>(false, false, null, null, new DelegateWithPmxDbConnection<int?>(
                        delegate(PmxDbConnection conn, object[] parameters)
                        {
                            PmxItemTransactionalInfoProvider prov = new PmxItemTransactionalInfoProvider(conn);
                            return prov.GetItemTransactionalInfoKey(info.ItemCode, info.BatchNumber1, info.BatchNumber2, info.BestBeforeDate);
                        }));

                    if (!itri.HasValue &&
                        (!string.IsNullOrEmpty(info.BatchNumber1) ||
                        !string.IsNullOrEmpty(info.BatchNumber2) ||
                        info.BestBeforeDate.HasValue))
                    {
                        //itri not known yet, but item has batch or BBD, so set a default itri
                        itri = -1;
                    }

                    if (itri.HasValue)
                    {
                        if (entry.ItriKeys == null)
                        {
                            entry.ItriKeys = new List<int>();
                        }
                        entry.ItriKeys.Add(itri.Value);
                    }

                }

                //get zonetypes
                Collection<string> itemCodes = new Collection<string>();
                foreach (string tempItemCode in canItemBeStoredInfoPerItemCode.Keys)
                {
                    itemCodes.Add(tempItemCode);
                }
                query = BuildQuery.GetZoneTypesForItems(itemCodes);
                dsZoneTypes = sboProviderService.RunView(false, null, null, query);

                Collection<string> listOfZoneTypes = new Collection<string>();
                if (this.GetNumberOfRows(dsZoneTypes) > 0)
                {
                    foreach (DataRow row in dsZoneTypes.Tables[0].Rows)
                    {
                        listOfZoneTypes.Add(row[PmxItemZoneTypeTable.Columns.ZoneTypeCode.NAME] as string);
                    }
                }

                string whsCodeToUse = whsInfo.PmxWarehouseCode;

                query = BuildQuery.GetStorageLocationForZoneTypes(enteredDestinationLocationCode, whsCodeToUse, listOfZoneTypes,
                buttonKeyIdentifyDestinationLocationScreen == "MSG_BUTTON_SELECT_EMPTY_LOCATION");

                DataSet dsDestinationLocations = sboProviderService.RunView(false, null, null, query);

                if (this.GetNumberOfRows(dsDestinationLocations) == 0)
                {
                    // Inform the user with the error
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "MessageKey", "MSG_ERROR_NO_LOCATION_FOUND",
                            "NoTranslationOfMessageKey", false,
                            "ShowButton", true));
                    WaitForMessage();

                    goto Step_IdentifyDestinationLocation;
                }
                //if ( !String.IsNullOrEmpty( enteredDestinationLocationCode )
                //    && SystemInt32Convertor.ObjectToInt( dsDestinationLocations.Tables[ 0 ].Rows[ 0 ][ LocationDataSet.Columns.FREE_SPACE_FOR_LOG_UNITS.Name ], 1, 1 ) < 1 )
                //{
                //    // Inform the user with the error
                //    session.ShowScreen( typeof( Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen ),
                //        DefaultCultureInfo.Get(), BuildParamCollection(
                //            "MessageKey", "MSG_ERROR_LOCATION_NOT_AVAILABLE",
                //            "NoTranslationOfMessageKey", false,
                //            "ShowButton", true ) );
                //    WaitForMessage();

                //    goto Step_IdentifyDestinationLocation;
                //}

                //locations found
                if (!string.IsNullOrEmpty(enteredDestinationLocationCode) &&
                    this.GetNumberOfRows(dsDestinationLocations) == 1)
                {
                    destinationLocation = Convert.ToString(dsDestinationLocations.Tables[0].Rows[0][LocationDataSet.Columns.CODE.Name]);
                    goto Step_CheckLocation;
                }

                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectLocationScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_SELECT_DESTINATION_LOCATION",
                    "LocationDS", dsDestinationLocations,
                    "ShowStopButton", false));

                msg = WaitForMessage();
                // Reset latest error
                initialErrorKey = null;

                if (msg.Name.EndsWith(".LocationSelected"))
                {
                    destinationLocation = ExtractParameter<string>(msg.Parameters, "locationCode");

                    goto Step_CheckLocation;
                }
                else
                {
                    //back requested
                    goto Step_IdentifyDestinationLocation;
                }

                #endregion

            Step_CheckLocation:

                #region CHECK LOCATION

                try
                {
                    if (sboProviderService.InvokeMethodWithDbConnection<bool>(false, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteIsLocationLocked), destinationLocation))
                    {
                        // Inform the user with the error
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "MessageKey", "MSG_ERROR_DESTINATION_LOCATION_LOCKED",
                                "NoTranslationOfMessageKey", false,
                                "IsError", true,
                                "ShowButton", true));
                        WaitForMessage();

                        goto Step_IdentifyDestinationLocation;

                    }


                    //check if items can be stored on location
                    bool canBeStored = sboProviderService.InvokeMethodWithDbConnection<bool>(false, false, null, null, delegate(PmxDbConnection conn, object[] parameters)
                    {
                        PmxOseStorageLocationProvider prov = new PmxOseStorageLocationProvider(conn);
                        return prov.CanItemsBeStoredOnStorageLocation(destinationLocation, canItemBeStoredInfoPerItemCode);
                    });
                    if (!canBeStored)
                    {
                        // Inform the user with the error
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "MessageKey", "MSG_ERROR_STORAGE_LOCATION_NOT_ALLOWED_FOR_ITEM",
                                "IsError", true,
                                "ShowButton", true));
                        WaitForMessage();


                        goto Step_IdentifyDestinationLocation;

                    }
                    foreach (KeyValuePair<string, PmxStorageLocationCanItemBeStoredInfo> kv in canItemBeStoredInfoPerItemCode)
                    {
                        if (kv.Value.Status != PmxStorageLocationCanItemBeStored.Yes)
                        {
                            // Warn user and ask to continue
                            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                                DefaultCultureInfo.Get(), BuildParamCollection(
                                    "TitleKey", "MSG_TITLE_CONFIRM_MOVE",
                                    "MessageKey", "MSG_CONFIRM_ADDING_DIFFERENT_ITEM_OR_BATCH"));
                            msg = WaitForMessage();

                            if (!msg.Name.EndsWith("IDecisionScreenReply.Yes"))
                            {
                                goto Step_IdentifyDestinationLocation;
                            }
                            break;
                        }
                    }

                    //Check if move is to warehouse automation location
                    if (listOfLocationsForWA.Contains(destinationLocation))
                    {
                        //This is not allowed for move to WA locations
                        initialErrorKey = "MSG_ERROR_MOVE_TO_WA_LOCATION_NOT_ALLOWED";

                        goto Step_IdentifyDestinationLocation;
                    }


                    currentLogUnit.SpecificLocationCode = destinationLocation;

                }
                catch (Exception ex)
                {
                    s_log.Error("", ex);
                    if (!(ex is ProdumexException) || ((ProdumexException)ex).Error == null)
                    {
                        // Inform the user with the error
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "MessageKey", ExceptionHelper.Format(ExceptionHelper.Content.InnerExceptions, ex, DefaultCultureInfo.Get()),
                                "NoTranslationOfMessageKey", true,
                                "IsError", true,
                                "ShowButton", true));
                        WaitForMessage();

                    }
                    else
                    {
                        // Inform the user with the error
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "PmxError", ((ProdumexException)ex).Error,
                                "ShowButton", true));
                        WaitForMessage();
                    }
                    goto Step_IdentifyDestinationLocation;
                }

                #endregion

            }


            //currentLogUnit.SpecificLocationCode = null;

            Collection<PmxDictionary<string, object>> listOfListOfParameters = new Collection<PmxDictionary<string, object>>();

            // Check for possibility of splitting received quantity over multiple LogUnits with DefaultQuantityOnLogisticUnit
            string splitItemCode = null;
            double splitQty = 0.0;
            int splitInNrOfLogUnits = 1;
            double qtyOnLogUnitInPurchaseUom = double.MaxValue;
            if (splitQtyInLogUnitsOfItemDefQtyOnLogUnit && itemInfo.DefaultQuantityOnLogisticUnit > 0)
            {
                if (currentLogUnit.ItemsOnLogisticUnit.Count <= 2)
                {
                    foreach (LogisticUnitItemGoodReceipt item in currentLogUnit.ItemsOnLogisticUnit)
                    {
                        if (!item.IsLogisticCarrier && !item.IsLogisticCarrierForLogisticUnit)
                        {
                            if (splitItemCode != null ||
                                (item.ListOfSerialNumbers != null && item.ListOfSerialNumbers.Count > 0))
                            {
                                splitItemCode = null;  // Failure, cannot have more than 1 splitItem, serial numbers are also not allowed.
                                break;
                            }
                            splitItemCode = item.ItemCode;
                            splitQty += item.Quantity;

                            itemInfo = sboProviderService.InvokeMethodWithDbConnection<PmxItemInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxItemInfo>(ExecuteGetItemInfo), splitItemCode);
                            qtyOnLogUnitInPurchaseUom = Math.Round(itemInfo.DefaultQuantityOnLogisticUnit / item.QuantityPerUom, 6);
                        }
                    }
                }
                if (splitItemCode != null)
                {
                    splitInNrOfLogUnits = (int)SboQuantity.Ceil(splitQty / qtyOnLogUnitInPurchaseUom, 0);
                }
            }

            LogisticUnitGoodsReceipt logUnitTemplate = currentLogUnit;

            for (int splitLogUnitIdx = 0; splitLogUnitIdx < splitInNrOfLogUnits; splitLogUnitIdx++)
            {
                if (splitInNrOfLogUnits > 1)
                {
                    // We change an item (splitItem) in currentLogUnit.ItemsOnLogisticUnit and the last one can be different, so make a copy
                    // Also, maybe some other properties of currentLogUnit are modified
                    currentLogUnit = RuntimeHelper.DeepCopy<LogisticUnitGoodsReceipt>(logUnitTemplate);

                    foreach (LogisticUnitItemGoodReceipt item in currentLogUnit.ItemsOnLogisticUnit)
                    {
                        if (item.ItemCode == splitItemCode)
                        {
                            item.Quantity = Math.Min(splitQty, qtyOnLogUnitInPurchaseUom);
                            splitQty = Math.Round(splitQty - item.Quantity, itemInfo.UomDecimals);
                            break;
                        }
                    }
                }

                for (int iLoop = 0; iLoop < batchReceivingNumber; iLoop++)
                {
                    //check if there is locked stock (not when splitting over multiple LogUnits)
                    if ((!splitQtyInLogUnitsOfItemDefQtyOnLogUnit || SboQuantity.IsZeroOrLess(itemInfo.DefaultQuantityOnLogisticUnit, itemInfo.UomDecimals))  // Currently only supported for non-splitting
                        && purchaseDocRef != null
                        && string.IsNullOrEmpty(currentLogUnit.SSCC))
                    {
                        Collection<string> listOfItemCodes = new Collection<string>();
                        foreach (LogisticUnitItemGoodReceipt item in currentLogUnit.ItemsOnLogisticUnit)
                        {
                            if (!listOfItemCodes.Contains(item.ItemCode))
                            {
                                listOfItemCodes.Add(item.ItemCode);
                            }
                        }
                        query = BuildQuery.GetLockedStockForBaseOrder(listOfItemCodes, purchaseDocRef);
                        dsSSCC = sboProviderService.RunView(true, null, null, query);

                        if (this.GetNumberOfRows(dsSSCC) > 0)
                        {
                            //we found stock, so we ask user what to do
                            //ask user if he wants to add another item to the list
                            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IIdentifySSCCListScreen),
                                DefaultCultureInfo.Get(), BuildParamCollection(
                                    "TitleKey", "MSG_TITLE_FOUND_STOCK_FOR_SAME_ORDER",
                                    "SSCCDS", dsSSCC,
                                    "ButtonKey", "MSG_BUTTON_MAKE_NEW_SSCC"
                                    ));
                            msg = WaitForMessage();

                            if (msg.Name.EndsWith(".SSCCEntered"))
                            {
                                int scannedLUID = ExtractParameter<int>(msg.Parameters, "luid");

                                DataRow[] rows = dsSSCC.Tables[0].Select(SSCCDataSet.Columns.LUID.Name + " = " + scannedLUID);
                                if (rows.Length > 0)
                                {
                                    currentLogUnit.SpecificLocationCode = Convert.ToString((rows[0][SSCCDataSet.Columns.STORAGE_LOCATION_CODE.Name]));
                                    currentLogUnit.SSCC = ExtractParameter<string>(msg.Parameters, "sscc");
                                    currentLogUnit.LogisticUnitId = scannedLUID;

                                    currentLogUnit.IsMoveToLockedStockLocation = true;
                                }

                                //if logistic carrier was defined, we need to set IsLogisticCarrier to false,
                                //otherwise the system will try to add it as the logistic carrier for the logistic unit.
                                //But it is possible the logistic unit to move the items to already has a logistic carrier linked to it.
                                foreach (LogisticUnitItemGoodReceipt tempItem in currentLogUnit.ItemsOnLogisticUnit)
                                {
                                    if (tempItem.IsLogisticCarrierForLogisticUnit)
                                    {
                                        tempItem.IsLogisticCarrierForLogisticUnit = false;
                                        //there should be only one logistic carrier
                                        break;
                                    }
                                }

                            }

                        }

                    }

                    LogisticUnitGoodsReceipt logUnitToAdd = new LogisticUnitGoodsReceipt();

                    logUnitToAdd.SSCC = currentLogUnit.SSCC;
                    logUnitToAdd.LogisticUnitId = currentLogUnit.LogisticUnitId;
                    logUnitToAdd.SupplierPalletNumber = currentLogUnit.SupplierPalletNumber;
                    logUnitToAdd.SpecificLocationCode = currentLogUnit.SpecificLocationCode;

                    logUnitToAdd.ItemsOnLogisticUnit = currentLogUnit.ItemsOnLogisticUnit;

                    if (!logUnitToAdd.LogisticUnitId.HasValue)
                    {
                        //add luid
                        try
                        {
                            logUnitToAdd.LogisticUnitId = sboProviderService.InvokeMethodWithDbConnection<int>(false, false, null, null, new DelegateWithPmxDbConnection<int>(ExecuteGenerateLuid), logUnitToAdd.SSCC, logUnitToAdd.SupplierPalletNumber);

                            //get the sscc
                            if (string.IsNullOrEmpty(logUnitToAdd.SSCC) &&
                                logUnitToAdd.LogisticUnitId.HasValue)
                            {
                                logUnitToAdd.SSCC = sboProviderService.InvokeMethodWithDbConnection<string>(false, false, null, null, new DelegateWithPmxDbConnection<string>(ExecuteGetSSCCByLUID), logUnitToAdd.LogisticUnitId.Value);
                            }

                        }
                        catch (Exception ex)
                        {
                            if (!(ex is ProdumexException))
                            {
                                // Inform the user with the error
                                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                                    DefaultCultureInfo.Get(), BuildParamCollection(
                                        "MessageKey", ExceptionHelper.Format(ExceptionHelper.Content.InnerExceptions, ex, DefaultCultureInfo.Get()),
                                        "NoTranslationOfMessageKey", true,
                                        "IsError", true,
                                        "ShowButton", true));
                                WaitForMessage();

                            }
                            else
                            {
                                // Inform the user with the error
                                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                                    DefaultCultureInfo.Get(), BuildParamCollection(
                                        "PmxError", ((ProdumexException)ex).Error,
                                        "ShowButton", true));
                                WaitForMessage();
                            }

                        }
                    }

                    //only print if not moving to locked stock location

                    if (!currentLogUnit.IsMoveToLockedStockLocation &&
                        logUnitToAdd.LogisticUnitId.HasValue)
                    {

                        try
                        {
                            PmxDictionary<string, object> listOfParameters = new PmxDictionary<string, object>();

                            string tempObjType = SboObjectTypes.PurchaseOrder;
                            int tempDocEntry = -1;

                            if (purchaseDocRef != null)
                            {
                                tempObjType = purchaseDocRef.DocType;
                                tempDocEntry = purchaseDocRef.DocEntry;
                            }
                            else
                            {
                                if (containerDocEntry.HasValue)
                                {
                                    tempObjType = Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxContainer;
                                    tempDocEntry = containerDocEntry.Value;
                                }
                            }

                            listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.CardCode.NAME, cardCode);
                            listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.PurchaseDocObjType.NAME, tempObjType);
                            listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.PurchaseDocEntry.NAME, tempDocEntry);
                            listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.SSCC.NAME, logUnitToAdd.SSCC);
                            listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.InternalLUID.NAME, logUnitToAdd.LogisticUnitId);
                            listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.LocationCode.NAME, string.IsNullOrEmpty(logUnitToAdd.SpecificLocationCode) ? currentDockCode : logUnitToAdd.SpecificLocationCode);


                            string tempItemCode = null;
                            string tempBatch = null;
                            string tempBatch2 = null;
                            DateTime? tempBestBeforeDate = null;
                            double? tempQuantity = 0;
                            Collection<PackagingTypeInfo> tempListOfPackagingTypes = null;
                            bool isFirst = true;

                            foreach (LogisticUnitItemGoodReceipt temp in logUnitToAdd.ItemsOnLogisticUnit)
                            {
                                if (isFirst)
                                {
                                    if (!temp.IsLogisticCarrierForLogisticUnit || temp.Quantity > 1)
                                    {
                                        //we need to fill the current data
                                        tempItemCode = temp.ItemCode;
                                        tempBatch = temp.BatchNumber1;
                                        tempBatch2 = temp.BatchNumber2;
                                        tempBestBeforeDate = temp.BestBeforeDate;
                                        tempQuantity = temp.Quantity;
                                        tempListOfPackagingTypes = temp.FullListOfPackagingTypes;

                                        isFirst = false;
                                    }
                                }
                                else if (tempItemCode != temp.ItemCode && (!temp.IsLogisticCarrierForLogisticUnit || temp.Quantity > 1))
                                {
                                    tempItemCode = null;
                                    tempBatch = null;
                                    tempBatch2 = null;
                                    tempBestBeforeDate = null;
                                    tempQuantity = null;
                                    tempListOfPackagingTypes = null;
                                    break;
                                }
                                else if (!temp.IsLogisticCarrierForLogisticUnit)
                                {
                                    //check if bestbefore date and batchnum correspond
                                    if (tempBatch != temp.BatchNumber1 ||
                                        tempBatch2 != temp.BatchNumber2)
                                    {
                                        tempBatch = null;
                                        tempBatch2 = null;
                                    }

                                    if (tempBestBeforeDate != temp.BestBeforeDate)
                                    {
                                        tempBestBeforeDate = null;
                                    }

                                    tempQuantity += temp.Quantity;
                                }
                            }


                            listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.Quantity.NAME, tempQuantity);
                            listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.BatchNumber.NAME, tempBatch);
                            listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.BestBeforeDate.NAME, tempBestBeforeDate);
                            listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.ItemCode.NAME, tempItemCode);
                            listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.BatchNumber2.NAME, tempBatch2);

                            string tempPackagingTypeText = null;
                            string tempQuantityByPackText = null;
                            if (tempListOfPackagingTypes != null &&
                                tempQuantity.HasValue)
                            {
                                tempPackagingTypeText = this.GetTransactionalPackagingTypesText(tempQuantity.Value, null, tempListOfPackagingTypes);
                                tempQuantityByPackText = this.GetQuantityInPackagingTypesText(tempListOfPackagingTypes);
                            }

                            listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.PackagingTypeText.NAME, tempPackagingTypeText);
                            listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.QuantityByPackagingTypeText.NAME, tempQuantityByPackText);


                            listOfListOfParameters.Add(listOfParameters);

                        }
                        catch (Produmex.Foundation.ProdumexException ex)
                        {
                            s_log.Error(ex.ToString());
                            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                                DefaultCultureInfo.Get(), BuildParamCollection(
                                    "InitialErrorKey", initialErrorKey,
                                    "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                                    "MessageAddendum", ex.Message,
                                    "PmxError", ex.Error,
                                    "ShowButton", true));

                            msg = WaitForMessage();
                        }
                        catch (Exception ex)
                        {
                            s_log.Error(ex.ToString());
                            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                                DefaultCultureInfo.Get(), BuildParamCollection(
                                    "InitialErrorKey", initialErrorKey,
                                    "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                                    "MessageAddendum", ex.Message,
                                    "PmxError", Produmex.Sbo.Logex.Data.ProdumexErrors.UnexpectedError(s_log, ex),
                                    "ShowButton", true));

                            msg = WaitForMessage();
                        }

                    }

                    purchaseDeliveryNoteList.Add(logUnitToAdd);

                }
            }

            //only print if not moving to locked stock location
            //When no parameters are filled in, stock will be moved to locked stock location
            if (listOfListOfParameters.Count > 0)
            {
                //print the label
                bool proceed = false;
                while (!proceed)
                {
                    numberOfReports = 0;

                    try
                    {

                        //trigger event
                        numberOfReports += sboProviderService.InvokeMethodWithDbConnection<int>(false, false, null, null,
                         delegate(PmxDbConnection conn, object[] parameters2)
                         {
                             PmxPrintReportProvider printProv = new PmxPrintReportProvider(conn);
                             return printProv.PrintReportsForEventWithParametersCollection(PmxPrintReportEventType.ReceptionNewLogisticUnitIdentified,
                             currentDockCode, deviceID, listOfListOfParameters, false, out askReprint);
                         });

                    }
                    catch (Produmex.Foundation.ProdumexException ex)
                    {
                        s_log.Error(ex.ToString());
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "InitialErrorKey", initialErrorKey,
                                "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                                "MessageAddendum", ex.Message,
                                "PmxError", ex.Error,
                                "ShowButton", true));

                        msg = WaitForMessage();
                    }
                    catch (Exception ex)
                    {
                        s_log.Error(ex.ToString());
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "InitialErrorKey", initialErrorKey,
                                "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                                "MessageAddendum", ex.Message,
                                "PmxError", Produmex.Sbo.Logex.Data.ProdumexErrors.UnexpectedError(s_log, ex),
                                "ShowButton", true));

                        msg = WaitForMessage();
                    }

                    if (numberOfReports > 0 && askReprint)
                    {
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "MessageKey", "MSG_QUESTION_REPRINT_LABEL",
                                "TitleKey", "MSG_TITLE_REPRINT_LABEL"));

                        msg = WaitForMessage();

                        if (msg.Name.EndsWith(".No"))
                        {
                            proceed = true;
                        }

                    }
                    else
                    {
                        proceed = true;
                    }

                }
            }

            currentLogUnit = null;

            if (gotoReceiveItem)
            {
                goto Step_ReceiveItems;
            }

            if (receiveAllItemsOnOnePurchaseDelivery)
            {
                if (purchaseDocRef != null || containerDocEntry.HasValue)
                {
                    //check if there are still items to receive
                    query = BuildQuery.GetCodeNameItemsOrderByName(null, null, purchaseDocRef, cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing, true, false, crossDocking, containerDocEntry, sboProviderService.GetDbTool());
                    dsCheckItems = sboProviderService.RunView(true, null, null, query);

                    RemoveReceivedItems(purchaseDeliveryNoteList, dsCheckItems, currentLogUnit);

                    if (this.GetNumberOfRows(dsCheckItems) == 0)
                    {
                        //no more rows, so receive the data
                        goto Step_ReceiveItems;
                    }
                }

                if (filterButtonKey == "MSG_BUTTON_PO_FILTER_NO_PO")
                {
                    goto Step_ReceiveItems;
                }

                goto Step_ShowMessageNextLogisticUnit;
            }
            else
            {
                goto Step_ReceiveItems;
            }

            #endregion

        Step_ReceiveItems:

            #region RECEIVE ITEMS

            listOfGeneratedDocEntry = new KeyValuePair<Collection<DocumentRef>, Collection<int>>();
            gotoReceiveItem = false;
            //add current pallet, if it was not added yet
            if (currentLogUnit != null &&
                currentLogUnit.ItemsOnLogisticUnit.Count > 0 &&
                !goBack)
            {
                gotoReceiveItem = true;
                goto Step_EnterDataIntoListToReceive;
            }

            try
            {
                listOfGeneratedDocEntry = sboProviderService.InvokeMethodWithDbConnection<KeyValuePair<Collection<DocumentRef>, Collection<int>>>(true, false, null, null, new DelegateWithPmxDbConnection<KeyValuePair<Collection<DocumentRef>, Collection<int>>>(
                    delegate(PmxDbConnection conn, object[] parameters)
                    {
                        PmxPurchaseDeliveryNoteProvider prov = new PmxPurchaseDeliveryNoteProvider((SboConnection)conn);

                        Dictionary<string, PmxParameterValue> overruleParams = null;
                        if (crossDocking && crossDockingPickListType != null)
                        {
                            overruleParams = new Dictionary<string, PmxParameterValue>();
                            overruleParams.Add("PickListType", crossDockingPickListType);
                        }
                        return prov.AddPurchaseDeliveryNoteListOfLogisticUnits(cardCode, currentDockCode, purchaseDeliveryNoteList, supplierRef, containerDocEntry, null, overruleParams);
                    }));

                purchaseDeliveryNoteList = new Collection<LogisticUnitGoodsReceipt>();
                listOfReasonCodeByItem = new Dictionary<string, ReasonInfo>();
            }
            catch (Exception ex)
            {
                s_log.Error("", ex);
                if (ex is ProdumexException)
                {
                    // Inform the user with the error
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "PmxError", ((ProdumexException)ex).Error,
                            "ShowButton", true));
                    WaitForMessage();
                }
                else
                {
                    // Inform the user with the error
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "MessageKey", ExceptionHelper.Format(ex, this.DefaultCultureInfo),
                            "NoTranslationOfMessageKey", true,
                            "IsError", true,
                            "ShowButton", true));
                    WaitForMessage();
                }

                //ask user if he wants to try again after error
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "TitleKey", "MSG_TITLE_ERROR_TRY_AGAIN",
                        "MessageKey", "MSG_QUESTION_ERROR_TRY_AGAIN"));
                msg = WaitForMessage();

                if (msg.Name.EndsWith(".Yes"))
                {
                    goto Step_ReceiveItems;
                }
                goto Step_SelectPOFilter;
            }

            goto Step_PrintDeliveryDocument;


            #endregion

        Step_PrintDeliveryDocument:

            #region PRINT DELIVERY DOCUMENT

            numberOfReports = 0;
            try
            {
                foreach (DocumentRef docRef in listOfGeneratedDocEntry.Key)
                {
                    //trigger event
                    numberOfReports += sboProviderService.InvokeMethodWithDbConnection<int>(false, false, null, null,
                         delegate(PmxDbConnection conn, object[] parameters2)
                         {
                             PmxPrintReportProvider printProv = new PmxPrintReportProvider(conn);
                             return printProv.PrintReportsForEvent(PmxPrintReportEventType.ReceptionPurchaseDeliveryNoteCreated,
                             currentDockCode, deviceID, docRef.DocEntry, out askReprint);
                         });
                }

            }
            catch (Produmex.Foundation.ProdumexException ex)
            {
                s_log.Error(ex.ToString());
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                        "MessageAddendum", ex.Message,
                        "PmxError", ex.Error,
                        "ShowButton", true));

                msg = WaitForMessage();
            }
            catch (Exception ex)
            {
                s_log.Error(ex.ToString());
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                        "MessageAddendum", ex.Message,
                        "PmxError", Produmex.Sbo.Logex.Data.ProdumexErrors.UnexpectedError(s_log, ex),
                        "ShowButton", true));

                msg = WaitForMessage();
            }

            goto Step_DocumentsPrinted;

            #endregion

        Step_DocumentsPrinted:

            #region DOCUMENTS PRINTED

            if (numberOfReports > 0 && askReprint)
            {
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "MessageKey", "MSG_QUESTION_REPRINT_DOCUMENT",
                        "TitleKey", "MSG_TITLE_REPRINT_DOCUMENT"));

                msg = WaitForMessage();

                if (msg.Name.EndsWith(".Yes"))
                {
                    goto Step_PrintDeliveryDocument;
                }

            }

            goto Step_GeneratePutAway;


            #endregion

        Step_GeneratePutAway:

            #region GENERATE PUT AWAY

            try
            {
                foreach (DocumentRef docRef in listOfGeneratedDocEntry.Key)
                {
                    sboProviderService.InvokeMethodWithDbConnection<object>(false, false, null, null, new DelegateWithPmxDbConnection<object>(ExecuteGeneratePutAwayOrder), docRef.DocEntry, currentDockCode);
                }
            }
            catch (Produmex.Foundation.ProdumexException ex)
            {
                s_log.Error(ex.ToString());
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                        "MessageAddendum", ex.Message,
                        "PmxError", ex.Error,
                        "ShowButton", true));

                msg = WaitForMessage();
            }
            catch (Exception ex)
            {
                s_log.Error(ex.ToString());
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                        "MessageAddendum", ex.Message,
                        "PmxError", Produmex.Sbo.Logex.Data.ProdumexErrors.UnexpectedError(s_log, ex),
                        "ShowButton", true));

                msg = WaitForMessage();
            }

            goto Step_MoveForLogisticUnitsWithOnlyLogicCarriers;

            #endregion

        Step_MoveForLogisticUnitsWithOnlyLogicCarriers:

            #region MOVE LOGISTIC CARRIERS

            try
            {
                sboProviderService.InvokeMethodWithDbConnection<bool>(false, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteCreateMoveForLogisticUnitsWithOnlyLogicCarriersIfConfigured), currentDockCode);
            }
            catch (Produmex.Foundation.ProdumexException ex)
            {
                s_log.Error(ex.ToString());
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                        "MessageAddendum", ex.Message,
                        "PmxError", ex.Error,
                        "ShowButton", true));

                msg = WaitForMessage();
            }
            catch (Exception ex)
            {
                s_log.Error(ex.ToString());
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                        "MessageAddendum", ex.Message,
                        "PmxError", Produmex.Sbo.Logex.Data.ProdumexErrors.UnexpectedError(s_log, ex),
                        "ShowButton", true));

                msg = WaitForMessage();
            }

            //// Inform the user the items are received
            //session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
            //    DefaultCultureInfo.Get(), BuildParamCollection(
            //        "MessageKey", "MSG_ITEMS_ARE_RECEIVED",
            //        "ShowButton", true));
            //WaitForMessage();


            if (goBack)
            {
                cardCode = null;
                goBack = false;
                if (filterButtonKey == "MSG_BUTTON_PO_FILTER_NO_PO")
                {
                    goto Step_SelectPOFilter;
                }
                else if (filterButtonKey == "MSG_BUTTON_PO_FILTER_EAN")
                {
                    goto Step_FilterOnEAN;
                }
                else if (isContainer)
                {
                    goto Step_SelectContainer;
                }
                else
                {
                    goto Step_SelectOrder;
                }
            }


            if (purchaseDocRef != null || containerDocEntry.HasValue)
            {
                //check if there are still items to receive
                query = BuildQuery.GetCodeNameItemsOrderByName(null, null, purchaseDocRef, cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing, true, false, crossDocking, containerDocEntry, sboProviderService.GetDbTool());
                dsCheckItems = sboProviderService.RunView(true, null, null, query);

                RemoveReceivedItems(purchaseDeliveryNoteList, dsCheckItems, currentLogUnit);

                if (this.GetNumberOfRows(dsCheckItems) > 0)
                {
                    //same purchase order, so enter next item
                    goto Step_ShowMessageNextLogisticUnit;
                }
            }


            goto Step_SelectPOFilter;

            #endregion


        }

        private bool ExecuteCrossDocking(int? purchaseOrderDocEntry, PmxOseWarehouseInfo whsInfo, string dockCode, PmxParameterValue crossDockingPickListType, Session session, ISboProviderService sboProviderService)
        {
            string initialErrorKey = null;

            DataSet dsPendingLogUnits = sboProviderService.InvokeMethodWithDbConnection<DataSet>(false, false, null, null, delegate(PmxDbConnection conn, object[] parameters)
            {
                DataSet ds = new DataSet();
                DataTable tbl = ds.Tables.Add();

                DbCommand dbCmd = conn.CreateCommand(BuildQuery.GetReceivedButUnfinishedOrders(dockCode, conn.DbCultureInfo));
                using (DbDataReader rdr = dbCmd.ExecuteReader())
                {
                    tbl.Load(rdr);
                }

                return ds;
            });

            int? purchaseOrderToCrossDock = null;
            if (purchaseOrderDocEntry.HasValue && dsPendingLogUnits.Tables[0].Select(PurchaseOrderDataSet.Columns.PO_ID.Name + " = " + purchaseOrderDocEntry.Value.ToString()).Length > 0)
            {
                purchaseOrderToCrossDock = purchaseOrderDocEntry;
            }
            else if (dsPendingLogUnits.Tables[0].Rows.Count > 0)
            {
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Reception.ISelectPOScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_SELECT_RECEIVED_PO_FOR_CROSS_DOCKING",
                    "PODS", dsPendingLogUnits
                    ));
                Message msg = WaitForMessage();

                if (msg.Name.EndsWith("ISelectPOScreenReply.BackRequested"))
                {
                    return false;
                }

                if (msg.Name.EndsWith("ISelectPOScreenReply.POSelected"))
                {
                    purchaseOrderToCrossDock = ExtractParameter<int>(msg.Parameters, "poDocEntry");
                }
            }
            if (!purchaseOrderToCrossDock.HasValue)
            {
                return true;
            }

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                "MessageKey", "MSG_PROCESSING_CROSS_DOCKING"));

            DataRow[] selectedPoRows = dsPendingLogUnits.Tables[0].Select(PurchaseOrderDataSet.Columns.PO_ID.Name + " = " + purchaseOrderToCrossDock.Value.ToString());

            int salesOrderDocEntry = Convert.ToInt32(selectedPoRows[0]["ORDR_DocEntry"]);
            int? generatedPickListDocEntry = null;
            int? generatedWaveKey = null;

            sboProviderService.InvokeMethodWithDbConnection<object>(false, false, null, null, delegate(PmxDbConnection dbConn, object[] parameters)
            {
                PmxPurchaseDeliveryNoteProvider pdnProv = new PmxPurchaseDeliveryNoteProvider();
                PmxPickListProposalProvider plpProv = new PmxPickListProposalProvider(dbConn);
                PmxPickListProvider plProv = new PmxPickListProvider(dbConn);

                Collection<DocumentRef> salesOrderDocEntries = new Collection<DocumentRef>();
                salesOrderDocEntries.Add(new DocumentRef(SboObjectType.SalesOrder, salesOrderDocEntry));
                Dictionary<string, PmxParameterValue> overruleParams = null;
                if (crossDockingPickListType != null)
                {
                    overruleParams = new Dictionary<string, PmxParameterValue>();
                    overruleParams.Add("PickListType", crossDockingPickListType);
                }
                Collection<DocumentRef> salesOrdersInError = new Collection<DocumentRef>();

                Collection<int> generatedPickListProposalDocEntries = plpProv.GeneratePickListProposalsForSalesOrders(salesOrderDocEntries, whsInfo.PmxWarehouseCode, dockCode, null, overruleParams, out salesOrdersInError);
                if (generatedPickListProposalDocEntries.Count > 0)
                {
                    Collection<int> generatedPickListDocEntries = plProv.GeneratePickListWave(generatedPickListProposalDocEntries);

                    if (generatedPickListDocEntries.Count > 0)
                    {
                        generatedPickListDocEntry = generatedPickListDocEntries[0];

                        foreach (int plDocEntry in generatedPickListDocEntries)
                        {
                            plProv.MakePicklistReadyFromDocEntry(plDocEntry);
                        }

                        // DbCommand dbCmd = dbConn.CreateCommand( BuildQuery.GetPurchaseOrderReceivedStock( purchaseOrderToCrossDock.Value, dbConn.DbCultureInfo ) );
                        DbCommand dbCmd = dbConn.CreateCommand(BuildQuery.GetSalesOrderAndPickListLockedStock(purchaseOrderToCrossDock.Value, -1 /*salesOrderDocEntry*/, generatedPickListDocEntry.Value, dbConn.DbCultureInfo));
                        DataTable tblPurchaseOrderReceivedStock = new DataTable();
                        using (DbDataReader rdr = dbCmd.ExecuteReader())
                        {
                            tblPurchaseOrderReceivedStock.Load(rdr);
                        }

                        // Build key column for row comparison
                        tblPurchaseOrderReceivedStock.Columns.Add("key", typeof(string));
                        foreach (DataRow row in tblPurchaseOrderReceivedStock.Rows)
                        {
                            row["key"] = String.Format("{0}/{1}/{2}/{3}",
                                row[PmxInventoryLockingDetailTable.Columns.ItemCode.NAME],
                                row[PmxInventoryLockingDetailTable.Columns.ItemTransactionalInfoKey.NAME],
                                row[PmxInventoryLockingDetailTable.Columns.LogUnitIdentKey.NAME],
                                row[PmxInventoryLockingDetailTable.Columns.QualityStatusCode.NAME]);
                        }

                        List<int> fullPalletPickedLuids = new List<int>();
                        foreach (int plDocEntry in generatedPickListDocEntries)
                        {
                            using (PmxPickList pl = plProv.GetBO(plDocEntry))
                            {
                                generatedWaveKey = pl.WaveKey;

                                foreach (PmxPickListLine line in pl.Lines)
                                {
                                    // if ( line.LogisticUnitIdentKey.HasValue )
                                    {
                                        foreach (DataRow row in tblPurchaseOrderReceivedStock.Rows)
                                        {
                                            if ((string)row[PmxInventoryLockingDetailTable.Columns.BaseType.NAME] == Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxPickList
                                                && (int)row[PmxInventoryLockingDetailTable.Columns.BaseEntry.NAME] == plDocEntry
                                                && (int)row[PmxInventoryLockingDetailTable.Columns.BaseLine.NAME] == line.LineNum)
                                            {
                                                double stockQty = Convert.ToDouble(row[PmxInventoryDetailTable.Columns.Quantity.NAME]);
                                                // Add quantity from sales-order (not picklist) locked rows
                                                //foreach ( DataRow salesOrderLockedRow in tblPurchaseOrderReceivedStock.Rows )
                                                //{
                                                //    if ( (string)salesOrderLockedRow[ PmxInventoryLockingDetailTable.Columns.BaseType.NAME ] == SboObjectTypes.SalesOrder
                                                //        && (string)salesOrderLockedRow[ "key" ] == (string)row[ "key" ] )
                                                //    {
                                                //        double lockQty = Convert.ToDouble( salesOrderLockedRow[ PmxInventoryLockingDetailTable.Columns.Quantity.NAME ] );
                                                //        if ( lockQty > 0.0 )
                                                //        {
                                                //            stockQty += lockQty;
                                                //            salesOrderLockedRow[ PmxInventoryLockingDetailTable.Columns.Quantity.NAME ] = 0.0;
                                                //        }
                                                //    }
                                                //}
                                                // if ( stockQty > 0.0 )
                                                {
                                                    int rxdStockLuid = Convert.ToInt32(row[PmxInventoryLockingDetailTable.Columns.LogUnitIdentKey.NAME]);
                                                    string itemCode = Convert.ToString(row[PmxInventoryLockingDetailTable.Columns.ItemCode.NAME]);
                                                    int? itriKey = SystemInt32Convertor.ObjectToIntOrNull(row[PmxInventoryLockingDetailTable.Columns.ItemTransactionalInfoKey.NAME]);
                                                    //if ( line.LogisticUnitIdentKey.Value == rxdStockLuid
                                                    //    && line.ItemCode == itemCode
                                                    //    && line.ItemTransactionalInfoKey == itriKey )  // Do more matching?
                                                    {
                                                        PickingItemInfo pickItemInfo = new PickingItemInfo();
                                                        pickItemInfo.PickListDocEntry = line.DocEntry.Value;
                                                        pickItemInfo.PickListLineID = line.LineNum.Value;
                                                        pickItemInfo.ItemCode = line.ItemCode;
                                                        pickItemInfo.ItemDescription = line.ItemDescription;
                                                        pickItemInfo.ItemTransactionalInfoKey = line.ItemTransactionalInfoKey;
                                                        pickItemInfo.QualityStatusCode = line.QualityStatusCode;
                                                        pickItemInfo.Quantity = Math.Max(line.Quantity, stockQty);  // Get everything
                                                        pickItemInfo.QuantityPerUom = line.QuantityPerUom;
                                                        pickItemInfo.Uom = line.Uom;
                                                        pickItemInfo.LocationCode = dockCode;  // Must be on cross-docking dock
                                                        pickItemInfo.LogisticUnitIdentKey = rxdStockLuid;

                                                        bool fullPallet = !fullPalletPickedLuids.Contains(rxdStockLuid);
                                                        if (fullPallet) fullPalletPickedLuids.Add(rxdStockLuid);

														plProv.PickItem(pickItemInfo, plDocEntry, pickItemInfo.LogisticUnitIdentKey, dockCode, null, fullPallet, false, null, false, null, false);

                                                        row[PmxInventoryDetailTable.Columns.Quantity.NAME] = 0.0;
                                                    }
                                                }
                                            }
                                        } // foreach ( DataRow row in tblPurchaseOrderReceivedStock.Rows )
                                    }
                                }  // foreach ( PmxPickListLine line in pl.Lines )
                            }  // Using ( PmxPickList pl = plProv.GetBO( plDocEntry ) )
                        }
                    }
                }

                return null;
            });

            if (generatedWaveKey.HasValue)
            {
                WorkflowInstanceBase pickFlow = this.Create("PickingScript");

                pickFlow.BindParameters(
                    this.DefaultCultureInfo,
                    this.PmxOseCompany,
                    new ReadOnlyBinder<int>("CrossDockingPickListDocEntry", generatedPickListDocEntry.Value),
                    new ReadOnlyBinder<int>("CrossDockingWaveKey", generatedWaveKey.Value));

                this.StartSubFlowAndWait(pickFlow, true);
            }

            return true;
        }

        #endregion

        #region HELPERS

        private static bool ExecuteIsLocationLocked(PmxDbConnection conn, object[] parameters)
        {
            PmxOseStorageLocationProvider prov = new PmxOseStorageLocationProvider(conn);
            return prov.IsLocationLocked((string)parameters[0]);
        }

        private string GetTransactionalPackagingTypesText(double quantity, string uom, Collection<PackagingTypeInfo> listOfTransactionalPackagingTypes)
        {

            if (listOfTransactionalPackagingTypes == null ||
                listOfTransactionalPackagingTypes.Count == 0)
            {
                return string.Format("# {0} {1}", quantity.ToString(), uom);
            }

            //we found packagingTypes
            double currentQty = quantity;
            StringBuilder sb = new StringBuilder();
            string separator = "";
            //loop from end
            for (int iLoop = 0; iLoop < listOfTransactionalPackagingTypes.Count; iLoop++)
            {
                double qty = currentQty / listOfTransactionalPackagingTypes[iLoop].QuantityPerPack;

                qty = Math.Floor(qty);


                sb.AppendFormat("{0}{1} {2}",
                    separator, qty.ToString(), listOfTransactionalPackagingTypes[iLoop].PackagingTypeName);

                currentQty -= qty * listOfTransactionalPackagingTypes[iLoop].QuantityPerPack;

                separator = Definitions.SEPARATOR;

            }

            return sb.ToString();


        }


        private string GetQuantityInPackagingTypesText(Collection<PackagingTypeInfo> listOfTransactionalPackagingTypes)
        {

            if (listOfTransactionalPackagingTypes == null ||
                listOfTransactionalPackagingTypes.Count == 0)
            {
                return null;
            }

            //we found packagingTypes
            StringBuilder sb = new StringBuilder();
            string separator = "";



            for (int iLoop = 0; iLoop < listOfTransactionalPackagingTypes.Count - 1; iLoop++)
            {

                sb.AppendFormat("{0}1 {1} = {2} {3}", separator, listOfTransactionalPackagingTypes[iLoop].PackagingTypeName, listOfTransactionalPackagingTypes[iLoop].QuantityPerPack / listOfTransactionalPackagingTypes[iLoop + 1].QuantityPerPack, listOfTransactionalPackagingTypes[iLoop + 1].PackagingTypeName);


                separator = Definitions.SEPARATOR;

            }

            return sb.ToString();

        }

        private static string GetPackTypeName(string packagingTypeCode, Collection<PmxItemPackagingTypeInfo> listOfPackagingTypes)
        {
            if (listOfPackagingTypes != null)
            {
                foreach (PmxItemPackagingTypeInfo packType in listOfPackagingTypes)
                {
                    if (packType.PackagingTypeCode == packagingTypeCode)
                    {
                        return packType.PackagingTypeName;
                    }
                }
            }

            return null;
        }

        /// <summary>
        /// Gets the pack barcode.
        /// </summary>
        /// <param name="packagingTypeCode">The packaging type code.</param>
        /// <param name="listOfPackagingTypes">The list of packaging types.</param>
        /// <returns></returns>
        private static Collection<string> GetPackBarcode(string packagingTypeCode, Collection<PmxItemPackagingTypeInfo> listOfPackagingTypes)
        {
            if (listOfPackagingTypes != null)
            {
                foreach (PmxItemPackagingTypeInfo packType in listOfPackagingTypes)
                {
                    if (packType.PackagingTypeCode == packagingTypeCode)
                    {
                        if (packType.Barcodes.Count > 0)
                        {
                            return packType.Barcodes;
                        }
                        else
                        {
                            return null;
                        }
                    }
                }
            }

            return null;
        }


        private static bool GetHideDuringEnteringQuantity(string packagingTypeCode, Collection<PmxItemPackagingTypeInfo> listOfPackagingTypes)
        {
            if (listOfPackagingTypes != null)
            {
                foreach (PmxItemPackagingTypeInfo packType in listOfPackagingTypes)
                {
                    if (packType.PackagingTypeCode == packagingTypeCode)
                    {
                        return packType.HideDuringEnteringQuantity;
                    }
                }
            }

            return true;
        }

        ///// <summary>
        ///// Executes the print events.
        ///// </summary>
        ///// <param name="conn">The conn.</param>
        ///// <param name="parameters">The parameters.</param>
        ///// <returns></returns>
        //private static int ExecutePrintEvents(PmxDbConnection conn, object[] parameters)
        //{
        //    PmxPrintReportProvider prov = new PmxPrintReportProvider(conn);

        //    return prov.PrintReportsForEvent((PmxPrintReportEventType)parameters[0], (string)parameters[1], (string)parameters[2], (int)parameters[3]);
        //}


        private static int ExecuteGenerateLuid(PmxDbConnection conn, object[] parameters)
        {
            PmxLogisticUnitIDProvider logUnitProv = new PmxLogisticUnitIDProvider(conn);
            string sscc = (string)parameters[0];
            string supplierPalletNumber = (string)parameters[1];
            int logisticUnitId = -1;
            if (string.IsNullOrEmpty(sscc))
            {
                logisticUnitId = logUnitProv.GenerateNewLogisticUnit(supplierPalletNumber);
            }
            else
            {
                //generate for sscc
                logisticUnitId = logUnitProv.NewLogisticUnitID(sscc, supplierPalletNumber);
            }

            return logisticUnitId;
        }


        private static int? ExecuteGetCreateItemTransactionalInfoKey(PmxDbConnection conn, object[] parameters)
        {
            PmxItemTransactionalInfoProvider prov = new PmxItemTransactionalInfoProvider(conn);
            string itemCode = (string)parameters[0];
            string batchNumber = (string)parameters[1];
            string batchNumber2 = (string)parameters[2];
            DateTime? bbd = (DateTime?)parameters[3];

            return prov.GetCreateItemTransactionalInfoKey(itemCode, batchNumber, batchNumber2, bbd);
        }

        /// <summary>
        /// Executes the get receive all items on one purchase delivery.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static bool ExecuteGetReceiveAllItemsOnOnePurchaseDelivery(PmxDbConnection conn, object[] parameters)
        {
            PmxPurchaseDeliveryNoteProvider prov = new PmxPurchaseDeliveryNoteProvider((SboConnection)conn);
            return prov.ReceiveAllItemsOnOnePurchaseDelivery();
        }

        /// <summary>
        /// Executes the get allow to select batches.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static bool ExecuteGetAllowToSelectBatches(PmxDbConnection conn, object[] parameters)
        {
            PmxPurchaseDeliveryNoteProvider prov = new PmxPurchaseDeliveryNoteProvider((SboConnection)conn);

            return prov.AllowToSelectBatches();
        }


        /// <summary>
        /// Executes the generate put away order.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static object ExecuteGeneratePutAwayOrder(PmxDbConnection conn, object[] parameters)
        {
            PmxMoveOrderProvider prov = new PmxMoveOrderProvider(conn);
            PmxPriorityProvider prioProv = new PmxPriorityProvider(conn);

            prov.GeneratePutAwayOrder((int)parameters[0], prioProv.GetDefaultPriority().Sequence, null, true, (string)parameters[1]);

            return null;
        }

        /// <summary>
        /// Executes the create move for logistic units with only logic carriers if configured.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static bool ExecuteCreateMoveForLogisticUnitsWithOnlyLogicCarriersIfConfigured(PmxDbConnection conn, object[] parameters)
        {
            PmxMoveProvider prov = new PmxMoveProvider(conn);

            return prov.CreateMoveForLogisticUnitsWithOnlyLogicCarriersIfConfigured((string)parameters[0]);
        }


        ///// <summary>
        ///// Executes the print reports for event collection.
        ///// </summary>
        ///// <param name="conn">The conn.</param>
        ///// <param name="parameters">The parameters.</param>
        ///// <returns></returns>
        //private static int ExecutePrintReportsForEventWithParametersCollection(PmxDbConnection conn, object[] parameters)
        //{
        //    PmxPrintReportProvider prov = new PmxPrintReportProvider(conn);

        //    return prov.PrintReportsForEventWithParametersCollection((PmxPrintReportEventType)parameters[0], (string)parameters[1], (string)parameters[2], (Collection<Dictionary<string, object>>)parameters[3], (bool)parameters[4]);
        //}

        ///// <summary>
        ///// Executes the print reports for event.
        ///// </summary>
        ///// <param name="conn">The conn.</param>
        ///// <param name="parameters">The parameters.</param>
        ///// <returns></returns>
        //private static int ExecutePrintReportsForEventWithParameters(PmxDbConnection conn, object[] parameters)
        //{
        //    PmxPrintReportProvider prov = new PmxPrintReportProvider(conn);

        //    return prov.PrintReportsForEventWithParameters((PmxPrintReportEventType)parameters[0], (string)parameters[1], (string)parameters[2], (Dictionary<string, object>)parameters[3], (bool)parameters[4]);
        //}

        ///// <summary>
        ///// Executes the add purchase delivery note list of logistic units.
        ///// </summary>
        ///// <param name="conn">The conn.</param>
        ///// <param name="parameters">The parameters.</param>
        ///// <returns></returns>
        //private KeyValuePair<int, Collection<int>> ExecuteAddPurchaseDeliveryNoteListOfLogisticUnits(PmxDbConnection conn, object[] parameters)
        //{
        //    PmxPurchaseDeliveryNoteProvider prov = new PmxPurchaseDeliveryNoteProvider((SboConnection)conn);

        //    return prov.AddPurchaseDeliveryNoteListOfLogisticUnits((string)parameters[0], (string)parameters[1], (Collection<LogisticUnitGoodsReceipt>)parameters[2], (string)parameters[3]);
        //}

        /// <summary>
        /// Sets the item transactional packaging type info list.
        /// </summary>
        /// <param name="itemInfo">The item info.</param>
        /// <returns></returns>
        private Collection<ItemTransactionalPackagingTypeInfo> SetItemTransactionalPackagingTypeInfoList(PmxItemInfo itemInfo)
        {
            //get the packaging types qty from item
            Collection<ItemTransactionalPackagingTypeInfo> listOfTransactionalPackagingTypeInfos = new Collection<ItemTransactionalPackagingTypeInfo>();

            foreach (PmxItemPackagingTypeInfo packInfo in itemInfo.ListOfPackagingTypes)
            {
                ItemTransactionalPackagingTypeInfo newPackInfo = new ItemTransactionalPackagingTypeInfo();

                newPackInfo.PackagingTypeCode = packInfo.PackagingTypeCode;
                newPackInfo.Quantity = packInfo.Quantity;
                newPackInfo.ItemCode = itemInfo.ItemCode;

                listOfTransactionalPackagingTypeInfos.Add(newPackInfo);

            }

            return listOfTransactionalPackagingTypeInfos;
        }


        /// <summary>
        /// Gets the transactional packaging info.
        /// </summary>
        /// <param name="purchaseDeliveryNoteList">The purchase delivery note list.</param>
        /// <param name="batchNumber">The batch number.</param>
        /// <param name="secondBatchNumber">The second batch number.</param>
        /// <param name="bestBeforeDate">The best before date.</param>
        /// <param name="itemCode">The item code.</param>
        /// <returns></returns>
        private static Collection<ItemTransactionalPackagingTypeInfo> GetTransactionalPackagingInfo(Collection<LogisticUnitGoodsReceipt> purchaseDeliveryNoteList, string batchNumber, string secondBatchNumber, DateTime? bestBeforeDate, string itemCode)
        {
            //does it exist in the just received items?
            foreach (LogisticUnitGoodsReceipt receipt in purchaseDeliveryNoteList)
            {
                foreach (LogisticUnitItemGoodReceipt receiptItem in receipt.ItemsOnLogisticUnit)
                {
                    if (batchNumber == receiptItem.BatchNumber1 &&
                        secondBatchNumber == receiptItem.BatchNumber2 &&
                        bestBeforeDate == receiptItem.BestBeforeDate &&
                        itemCode == receiptItem.ItemCode)
                    {
                        //we found the packagingData
                        return receiptItem.ListOfPackagingTypes;
                    }
                }
            }
            return null;
        }

        private static GeneratedBatchNumberReception ExecuteGenerateBatchNumber1ForReception(PmxDbConnection conn, object[] parameters)
        {
            PmxBatchNumberReceptionProvider prov = new PmxBatchNumberReceptionProvider(conn);
            if ((bool)parameters[4])
            {
                return prov.GenerateBatchNumber1ForReception((DocumentRef)parameters[0], (int?)parameters[1], (string)parameters[2], (string)parameters[3]);
            }
            else
            {
                return prov.GenerateBatchNumber2ForReception((DocumentRef)parameters[0], (int?)parameters[1], (string)parameters[2], (string)parameters[3]);
            }
        }


        /// <summary>
        /// Removes the received items.
        /// </summary>
        /// <param name="purchaseDeliveryNoteList">The purchase delivery note list.</param>
        /// <param name="dsProducts">The ds products.</param>
        private void RemoveReceivedItems(Collection<LogisticUnitGoodsReceipt> purchaseDeliveryNoteList, DataSet dsProducts, LogisticUnitGoodsReceipt currentUnit)
        {
            foreach (LogisticUnitGoodsReceipt logUnit in purchaseDeliveryNoteList)
            {
                foreach (LogisticUnitItemGoodReceipt logUnitItem in logUnit.ItemsOnLogisticUnit)
                {
                    if (dsProducts != null &&
                        dsProducts.Tables[0].Columns.Contains(SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME))
                    {
                        DataRow[] rows = dsProducts.Tables[0].Select(ProductDataSet.Columns.PRODUCT_CODE.Name + "= '" + logUnitItem.ItemCode + "'");
                        double alreadyReceived = logUnitItem.Quantity;
                        for (int iLoop = 0; iLoop < rows.Length; iLoop++)
                        {
                            if (alreadyReceived <= 0)
                            {
                                break;
                            }


                            double stillToReceive = Convert.ToInt32(rows[iLoop][SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME]);

                            double qtyReduced = 0;

                            if (stillToReceive <= alreadyReceived)
                            {
                                //no more quantity to receive, so delete the entry
                                rows[iLoop].Delete();
                                qtyReduced = stillToReceive;
                            }
                            else
                            {
                                //reduce the quantity
                                rows[iLoop][SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME] = stillToReceive - alreadyReceived;
                                qtyReduced = alreadyReceived;

                            }

                            alreadyReceived -= qtyReduced;
                        }
                        dsProducts.AcceptChanges();
                    }
                }
            }

            if (currentUnit != null)
            {
                foreach (LogisticUnitItemGoodReceipt logUnitItem in currentUnit.ItemsOnLogisticUnit)
                {
                    if (dsProducts != null &&
                        dsProducts.Tables[0].Columns.Contains(SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME))
                    {
                        DataRow[] rows = dsProducts.Tables[0].Select(ProductDataSet.Columns.PRODUCT_CODE.Name + "= '" + logUnitItem.ItemCode + "'");
                        double alreadyReceived = logUnitItem.Quantity;
                        for (int iLoop = 0; iLoop < rows.Length; iLoop++)
                        {
                            double stillToReceive = Convert.ToInt32(rows[iLoop][SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME]);
                            if (stillToReceive <= alreadyReceived)
                            {
                                //no more quantity to receive, so delete the entry
                                rows[iLoop].Delete();

                                alreadyReceived -= stillToReceive;

                            }
                            else
                            {
                                //reduce the quantity
                                rows[iLoop][SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME] = stillToReceive - alreadyReceived;
                                break;
                            }
                        }
                        dsProducts.AcceptChanges();
                    }
                }
            }

        }

        /// <summary>
        /// Gets the still to receive.
        /// </summary>
        /// <param name="dsProducts">The ds products.</param>
        /// <param name="itemCode">The item code.</param>
        /// <returns></returns>
        private double GetStillToReceive(DataSet dsProducts, string itemCode)
        {
            double stillToReceive = 0;
            if (dsProducts != null &&
                    dsProducts.Tables[0].Columns.Contains(SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME))
            {
                DataRow[] rows = dsProducts.Tables[0].Select(ProductDataSet.Columns.PRODUCT_CODE.Name + "= '" + itemCode + "'");
                stillToReceive = 0;
                for (int iLoop = 0; iLoop < rows.Length; iLoop++)
                {
                    stillToReceive += Convert.ToDouble(rows[iLoop][SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME]);
                }
            }
            return stillToReceive;
        }




        /// <summary>
        /// Executes the can item be stored on storage location.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static bool ExecuteCanItemBeStoredOnStorageLocation(PmxDbConnection conn, object[] parameters)
        {
            PmxOseStorageLocationProvider prov = new PmxOseStorageLocationProvider(conn);
            return prov.CanItemBeStoredOnStorageLocation((string)parameters[0], (string)parameters[1], new PmxStorageLocationCanItemBeStoredInfo());
        }

        /// <summary>
        /// Executes the is SSCC valid.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static bool ExecuteIsSSCCValid(PmxDbConnection conn, object[] parameters)
        {
            PmxSSCCProvider ssccProv = new PmxSSCCProvider(conn);
            return ssccProv.IsValidChecksumSSCC((string)parameters[0]);
        }

        /// <summary>
        /// Executes the get LUID by SSCC.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static int ExecuteGetLUIDBySSCC(PmxDbConnection conn, object[] parameters)
        {
            PmxLogisticUnitIDProvider prov = new PmxLogisticUnitIDProvider(conn);
            return prov.GetLUIDBySSCC((string)parameters[0]);
        }

        /// <summary>
        /// Executes the get SSCC by LUID.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static string ExecuteGetSSCCByLUID(PmxDbConnection conn, object[] parameters)
        {
            PmxLogisticUnitIDProvider prov = new PmxLogisticUnitIDProvider(conn);
            return prov.GetSSCCByLUID((int)parameters[0]);
        }

        /// <summary>
        /// Gets the number of rows.
        /// </summary>
        /// <param name="ds">The ds.</param>
        /// <returns></returns>
        private int GetNumberOfRows(DataSet ds)
        {
            if (ds != null &&
                ds.Tables.Count > 0)
            {
                return ds.Tables[0].Rows.Count;
            }

            return 0;
        }

        /// <summary>
        /// Checks if there are Products the on barcode.
        /// </summary>
        /// <param name="BarcodeContainerObject">The barcode container object.</param>
        /// <returns>
        /// True, if there is a product on the barcode, false if not
        /// </returns>
        public bool IsProductOnBarcode(BarcodeContainer BarcodeContainerObject)
        {
            if (BarcodeContainerObject != null &&
                !string.IsNullOrEmpty(BarcodeHelper.GetProductIdentification(BarcodeContainerObject)))
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// Checks if there is a LU the on barcode.
        /// </summary>
        /// <param name="barcodeContainerObject">The barcode container object.</param>
        /// <returns>
        /// True, if there is a LU on the barcode, false if not
        /// </returns>
        public bool IsLUOnBarcode(BarcodeContainer barcodeContainerObject)
        {
            if (barcodeContainerObject != null &&
                barcodeContainerObject.GS1DataObject != null &&
                barcodeContainerObject.GS1DataObject.GTINLU != null)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// Checks if there is an SSCC the on barcode.
        /// </summary>
        /// <param name="GS1DataScanned">The G s1 data scanned.</param>
        /// <returns>
        /// True, if there is an sscc on the barcode, false if not
        /// </returns>
        public bool IsSSCCOnBarcode(GS1Data GS1DataScanned)
        {
            if (GS1DataScanned != null &&
                (GS1DataScanned.Sscc != null))
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// Checks if there is a best before Date the on barcode.
        /// </summary>
        /// <param name="GS1DataScanned">The G s1 data scanned.</param>
        /// <returns>
        /// True, if there is an best before date on the barcode, false if not
        /// </returns>
        public bool IsBestBeforeDateOnBarcode(GS1Data GS1DataScanned)
        {
            if (GS1DataScanned != null &&
                (GS1DataScanned.BestBeforeDate != null))
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// Checks if there is a quantity the on barcode.
        /// </summary>
        /// <param name="GS1DataScanned">The G s1 data scanned.</param>
        /// <returns>
        /// True, if there is a quantity on the barcode, false if not
        /// </returns>
        public bool IsQuantityOnBarcode(BarcodeContainer barcode)
        {
            if (barcode != null &&
            barcode.GS1DataObject != null &&
                barcode.GS1DataObject.Count != null)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// Checks if there is a batch number the on barcode.
        /// </summary>
        /// <param name="GS1DataScanned">The G s1 data scanned.</param>
        /// <returns>
        /// True, if there is a batch number on the barcode, false if not
        /// </returns>
        public bool IsBatchNumberOnBarcode(GS1Data GS1DataScanned)
        {
            if (GS1DataScanned != null &&
                (GS1DataScanned.LotNumber != null))
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// Executes the get item info.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static PmxItemInfo ExecuteGetItemInfo(PmxDbConnection conn, object[] parameters)
        {
            PmxItemAllConnectionsProvider prov = new PmxItemAllConnectionsProvider(conn);
            return prov.GetItemInfo((string)parameters[0]);
        }


        /// <summary>
        /// Executes the get PMX warehouse code.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static PmxOseWarehouseInfo ExecuteGetPmxWarehouseCode(PmxDbConnection conn, object[] parameters)
        {
            PmxOseProvider oseProv = new PmxOseProvider(conn);
            return oseProv.GetPmxWarehouseInfo((string)parameters[0]);
        }

        /// <summary>
        /// Executes the need to enter supplier pallet number.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static bool ExecuteNeedToEnterSupplierPalletNumber(PmxDbConnection conn, object[] parameters)
        {
            PmxBusinessPartnerProvider prov = new PmxBusinessPartnerProvider((SboConnection)conn);
            return prov.NeedToEnterSupplierPalletNumber((string)parameters[0]);
        }
        /// <summary>
        /// Executes the check if labels are allowed to be printed on reception for a vendor
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static bool ExecuteCheckIfLabelScanningAllowedOnReception(PmxDbConnection conn, object[] parameters)
        {
            PmxBusinessPartnerProvider prov = new PmxBusinessPartnerProvider((SboConnection)conn);
            return prov.CheckIfLabelScanningAllowedOnReception((string)parameters[0]);
        }

        /// <summary>
        /// Executes the check if logistic carriers are allowed on reception for a vendor
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static bool ExecuteCheckIfLogisticCarriersAreAllowedOnReception(PmxDbConnection conn, object[] parameters)
        {
            PmxBusinessPartnerProvider prov = new PmxBusinessPartnerProvider((SboConnection)conn);
            return prov.CheckIfLogisticCarriersAreAllowedOnReception((string)parameters[0]);
        }

        /// <summary>
        /// Executes the generate BBD for reception.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static GeneratedBestBeforeDateReception ExecuteGenerateBBDForReception(PmxDbConnection conn, object[] parameters)
        {
            PmxGeneralProvider genProv = new PmxGeneralProvider(conn);
            return genProv.GenerateBestBeforeDateForReception((string)parameters[0], null);
        }


        /// <summary>
        /// Executes the check allow multiple identical log units.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static PmxBusinessPartnerInfo ExecuteGetBusinessPartnerInfo(PmxDbConnection conn, object[] parameters)
        {
            PmxBusinessPartnerProvider prov = new PmxBusinessPartnerProvider((SboConnection)conn);
            return prov.GetBusinessPartnerInfo((string)parameters[0]);
        }


        #endregion

        #region BUILD QUERY

        /// <summary>
        /// Static class grouping our native queries
        /// </summary>
        internal static class BuildQuery
        {
            private static SboBooleanConvertor m_sboBooleanConvertor = null;
            private static SboBooleanConvertor BooleanConvertor
            {
                get
                {
                    if (m_sboBooleanConvertor == null)
                    {
                        m_sboBooleanConvertor = new SboBooleanConvertor();
                    }
                    return m_sboBooleanConvertor;
                }
            }

            /// <summary>
            /// Gets the name and the code of the  location, ordered by name.
            /// </summary>
            /// <param name="isLoading">Is the dock for loading? When null, no check will be done on this value</param>
            /// <param name="isUnloading">Is the dock for unloading? When null, no check will be done on this value</param>
            /// <param name="useAnd">if set to <c>true</c> the operand between Loading and Unloading is 'AND'.
            /// Otherwise it is 'OR'.</param>
            /// <param name="pmxWarehouseCode">The PMX warehouse code.</param>
            /// <param name="deviceID">The device ID.</param>
            /// <returns>The sql statement to get the dock</returns>
            public static string GetCodeNameDockOrderByName(bool? isLoading, bool? isUnloading, bool useAnd, string pmxWarehouseCode, string deviceID)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT ");

                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Code.NAME, LocationDataSet.Columns.CODE.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Name.NAME, LocationDataSet.Columns.DESCRIPTION.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME, LocationDataSet.Columns.WAREHOUSECODE.Name);

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseWarehouseTable.NAME, PmxOseWarehouseTable.Columns.Name.NAME, LocationDataSet.Columns.WAREHOUSENAME.Name);


                strBuilder.Append("\r\n FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseDockTable.NAME));

                //inner join PmxOseDock - PmxOse
                strBuilder.Append("\r\n INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseGeneralTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.Code.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Code.NAME);

                //inner join PmxOseDock - PmxOseStorageLocation
                strBuilder.Append("\r\n INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseStorageLocationGeneralTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseStorageLocationGeneralTable.NAME, PmxOseStorageLocationGeneralTable.Columns.Code.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Code.NAME);

                strBuilder.Append("\r\n INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseWarehouseTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseWarehouseTable.NAME, PmxOseWarehouseTable.Columns.Code.NAME);


                strBuilder.Append("\r\n WHERE ");

                //Dock must be active
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseStorageLocationGeneralTable.NAME, PmxOseStorageLocationGeneralTable.Columns.IsActive.NAME);
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

                if (!String.IsNullOrEmpty(pmxWarehouseCode) || !String.IsNullOrEmpty(deviceID))
                {
                    strBuilder.Append(" AND ( ");
                    if (!String.IsNullOrEmpty(pmxWarehouseCode))
                    {
                        SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME);
                        strBuilder.Append(" = ");
                        strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(pmxWarehouseCode, CultureInfo.InvariantCulture));
                    }
                    if (!String.IsNullOrEmpty(deviceID))
                    {
                        if (!String.IsNullOrEmpty(pmxWarehouseCode)) strBuilder.Append(" OR ");

                        strBuilder.AppendFormat("{0} IN ( SELECT {1} FROM {2} WHERE {3} = {4} )",
                            SqlCommandHelper.EscapeTableColumnName(PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME),
                            SqlCommandHelper.EscapeTableColumnName(PmxThinClientWarehouseTable.NAME, PmxThinClientWarehouseTable.Columns.PmxWarehouseCode.NAME),
                            SqlCommandHelper.EscapeTableName(PmxThinClientWarehouseTable.NAME),
                            SqlCommandHelper.EscapeTableColumnName(PmxThinClientWarehouseTable.NAME, PmxThinClientWarehouseTable.Columns.ParentCode.NAME),
                            SqlCommandHelper.FormatAndEscapeColumnValue(deviceID, CultureInfo.InvariantCulture));
                    }
                    strBuilder.Append(" )");
                }

                if (isUnloading.HasValue || isLoading.HasValue)
                {
                    strBuilder.Append(" AND (");

                    if (isUnloading.HasValue)
                    {
                        SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.IsUnloadingDock.NAME);
                        strBuilder.Append(" = ");
                        strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(BooleanConvertor.ConvertBOPropertyToColumn(isUnloading.Value), CultureInfo.InvariantCulture));
                    }

                    if (isLoading.HasValue)
                    {
                        if (isUnloading.HasValue)
                        {
                            strBuilder.Append(useAnd ? " AND " : " OR ");
                        }

                        SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.IsLoadingDock.NAME);
                        strBuilder.Append(" = ");
                        strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(BooleanConvertor.ConvertBOPropertyToColumn(isLoading.Value), CultureInfo.InvariantCulture));
                    }

                    strBuilder.Append(" )");
                }

                strBuilder.Append("\r\n ORDER BY ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Name.NAME);

                return strBuilder.ToString();
            }




            /// <summary>
            /// Gets all batches in stock.
            /// </summary>
            /// <param name="itemCode">The item code.</param>
            /// <returns></returns>
            public static string GetAllBatchesInStock(string itemCode)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT DISTINCT ");

                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BatchNumber1.NAME, TextDataSet.Columns.TEXT.Name);

                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));


                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxInventoryTotalTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemTransactionalInfoKey.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.InternalKey.NAME);


                strBuilder.Append(" WHERE ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.ItemCode.NAME);
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, CultureInfo.InvariantCulture));


                return strBuilder.ToString();
            }


            /// <summary>
            /// Gets all internal batches in stock.
            /// </summary>
            /// <param name="itemCode">The item code.</param>
            /// <returns></returns>
            public static string GetAllInternalBatchesInStock(string itemCode, string batchNumber)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT DISTINCT ");

                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BatchNumber2.NAME, TextDataSet.Columns.TEXT.Name);

                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));


                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxInventoryTotalTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemTransactionalInfoKey.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.InternalKey.NAME);


                strBuilder.Append(" WHERE ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.ItemCode.NAME);
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, CultureInfo.InvariantCulture));

                strBuilder.Append(" AND ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BatchNumber1.NAME);
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(batchNumber, CultureInfo.InvariantCulture));



                return strBuilder.ToString();
            }



            /// <summary>
            /// Command for getting all PO's order by PO Number
            /// </summary>
            /// <param name="cardCode">The card code.</param>
            /// <param name="gtin">The gtin.</param>
            /// <param name="crossDocking">if set to <c>true</c> [cross docking].</param>
            /// <param name="includeReserveInvoices">if set to <c>true</c> [include reserve invoices].</param>
            /// <param name="sboWarehouseCode">The sbo warehouse code.</param>
            /// <param name="dbTool">The database tool.</param>
            /// <returns>
            /// Command for getting all PO's order by PO Number
            /// </returns>
            public static string GetPOsOrderByPONumber(string cardCode, string gtin, bool crossDocking, bool includeReserveInvoices, string sboWarehouseCode, DbTool dbTool)
            {
                DbQueryBuilder strBuilder = dbTool.GetQueryBuilder();
                strBuilder.AppendFormat("SELECT DISTINCT {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseOrderTable.NAME, "ObjType", PurchaseOrderDataSet.Columns.DOC_OBJ_TYPE.Name));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.DocNum.NAME, PurchaseOrderDataSet.Columns.PO_NUMBER.Name));
                strBuilder.AppendFormat(", CAST( {0} AS NVARCHAR ) AS {1}",
                    SqlCommandHelper.EscapeTableColumnName(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.DocNum.NAME),
                    SqlCommandHelper.EscapeColumnName(PurchaseOrderDataSet.Columns.PO_NUMBER_ASSTRING.Name));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.DocEntry.NAME, PurchaseOrderDataSet.Columns.PO_ID.Name));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.CardCode.NAME, PurchaseOrderDataSet.Columns.SUPPLIER_CODE.Name));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.CardName.NAME, PurchaseOrderDataSet.Columns.SUPPLIER_NAME.Name));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.NumAtCard.NAME, PurchaseOrderDataSet.Columns.SUPPLIER_REFERENCE.Name));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.SupplierLineRef.NAME, PurchaseOrderDataSet.Columns.SUPPLIER_LINE_REF.Name));

                strBuilder.AppendFormat("\r\n FROM {0}",
                    SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));

                strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                    SqlCommandHelper.EscapeTableName(PmxPurchaseOrderLineTable.NAME));
                strBuilder.AppendFormat(" ON {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.DocEntry.NAME),
                    SqlCommandHelper.EscapeTableColumnName(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.DocEntry.NAME));

                strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                    SqlCommandHelper.EscapeTableName(SboItemTable.NAME));
                strBuilder.AppendFormat(" ON {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.ItemCode.NAME));

                if (crossDocking)
                {
                    strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                        SqlCommandHelper.EscapeTableName(SboSalesOrderTable.NAME));
                    strBuilder.AppendFormat(" ON {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(SboSalesOrderTable.NAME, SboSalesOrderTable.Columns.ObjType.NAME),
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME));
                    strBuilder.AppendFormat(" AND {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(SboSalesOrderTable.NAME, SboSalesOrderTable.Columns.DocEntry.NAME),
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseEntry.NAME));
                    strBuilder.AppendFormat(" AND {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(SboSalesOrderTable.NAME, SboSalesOrderTable.Columns.Confirmed.NAME),
                        SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));
                }

                strBuilder.AppendFormat("\r\n WHERE {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.DocStatus.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture));

                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.Canceled.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.N.VALUE, CultureInfo.InvariantCulture));

                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.Confirmed.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderLineTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.LineStatus.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture));

                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.InventoryItem.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

                if (cardCode != null &&
                    cardCode.Trim() != "")
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.CardCode.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(cardCode, CultureInfo.InvariantCulture));
                }

                if (gtin != null &&
                    gtin.Trim() != "")
                {
                    strBuilder.Append(" AND ");
                    Produmex.Sbo.Logex.Data.SboCommands.AddWhereClauseSearchForBarcodePackagingType(strBuilder, gtin);
                }

                if (!string.IsNullOrEmpty(sboWarehouseCode))
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderLineTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.WarehouseCode.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(sboWarehouseCode, CultureInfo.InvariantCulture));
                }


                if (crossDocking)
                {
                    strBuilder.AppendFormat(" AND {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME),
                        SqlCommandHelper.FormatAndEscapeColumnValue(SboObjectTypes.SalesOrder, CultureInfo.InvariantCulture));
                }
                else  // Cross-docking not yet supported for reserve invoice, remove this "else" when completed
                    if (includeReserveInvoices)
                    {
                        strBuilder.AppendFormat("\r\n UNION ALL SELECT DISTINCT {0}",
                            SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseInvoiceTable.NAME, "ObjType", PurchaseOrderDataSet.Columns.DOC_OBJ_TYPE.Name));
                        strBuilder.AppendFormat(", {0}",
                            SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseInvoiceTable.NAME, SboPurchaseInvoiceTable.Columns.DocNum.NAME, PurchaseOrderDataSet.Columns.PO_NUMBER.Name));
                        strBuilder.AppendFormat(", CAST( {0} AS NVARCHAR ) AS {1}",
                            SqlCommandHelper.EscapeTableColumnName(SboPurchaseInvoiceTable.NAME, SboPurchaseInvoiceTable.Columns.DocNum.NAME),
                            SqlCommandHelper.EscapeColumnName(PurchaseOrderDataSet.Columns.PO_NUMBER_ASSTRING.Name));
                        strBuilder.AppendFormat(", {0}",
                            SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseInvoiceTable.NAME, SboPurchaseInvoiceTable.Columns.DocEntry.NAME, PurchaseOrderDataSet.Columns.PO_ID.Name));
                        strBuilder.AppendFormat(", {0}",
                            SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseInvoiceTable.NAME, SboPurchaseInvoiceTable.Columns.CardCode.NAME, PurchaseOrderDataSet.Columns.SUPPLIER_CODE.Name));
                        strBuilder.AppendFormat(", {0}",
                            SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseInvoiceTable.NAME, SboPurchaseInvoiceTable.Columns.CardName.NAME, PurchaseOrderDataSet.Columns.SUPPLIER_NAME.Name));
                        strBuilder.AppendFormat(", {0}",
                            SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseInvoiceTable.NAME, SboPurchaseInvoiceTable.Columns.NumAtCard.NAME, PurchaseOrderDataSet.Columns.SUPPLIER_REFERENCE.Name));
                        strBuilder.AppendFormat(", {0}",
                            SqlCommandHelper.EscapeTableColumnNameWithAlias(PmxPurchaseInvoiceLineTable.NAME, PmxPurchaseInvoiceLineTable.Columns.SupplierLineRef.NAME, PurchaseOrderDataSet.Columns.SUPPLIER_LINE_REF.Name));

                        strBuilder.AppendFormat("\r\n FROM {0}",
                            SqlCommandHelper.EscapeTableName(SboPurchaseInvoiceTable.NAME));

                        strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                            SqlCommandHelper.EscapeTableName(PmxPurchaseInvoiceLineTable.NAME));
                        strBuilder.AppendFormat(" ON {0} = {1}",
                            SqlCommandHelper.EscapeTableColumnName(PmxPurchaseInvoiceLineTable.NAME, PmxPurchaseInvoiceLineTable.Columns.DocEntry.NAME),
                            SqlCommandHelper.EscapeTableColumnName(SboPurchaseInvoiceTable.NAME, SboPurchaseInvoiceTable.Columns.DocEntry.NAME));

                        strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                            SqlCommandHelper.EscapeTableName(SboItemTable.NAME));
                        strBuilder.AppendFormat(" ON {0} = {1}",
                            SqlCommandHelper.EscapeTableColumnName(SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME),
                            SqlCommandHelper.EscapeTableColumnName(PmxPurchaseInvoiceLineTable.NAME, PmxPurchaseInvoiceLineTable.Columns.ItemCode.NAME));

                        strBuilder.AppendFormat("\r\n WHERE {0} = {1}",
                            SqlCommandHelper.EscapeTableColumnName(SboPurchaseInvoiceTable.NAME, SboPurchaseInvoiceTable.Columns.DocStatus.NAME),
                            SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture));

                        strBuilder.AppendFormat(" AND {0} = {1}",
                            SqlCommandHelper.EscapeTableColumnName(SboPurchaseInvoiceTable.NAME, SboPurchaseInvoiceTable.Columns.InventoryStatus.NAME),
                            SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture));

                        strBuilder.AppendFormat(" AND {0} = {1}",
                            SqlCommandHelper.EscapeTableColumnName(SboPurchaseInvoiceTable.NAME, SboPurchaseInvoiceTable.Columns.Canceled.NAME),
                            SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.N.VALUE, CultureInfo.InvariantCulture));

                        strBuilder.AppendFormat(" AND {0} = {1}",
                            SqlCommandHelper.EscapeTableColumnName(SboPurchaseInvoiceTable.NAME, SboPurchaseInvoiceTable.Columns.IsReserveInvoice.NAME),
                            SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

                        strBuilder.AppendFormat(" AND {0} = {1}",
                            SqlCommandHelper.EscapeTableColumnName(PmxPurchaseInvoiceLineTable.NAME, PmxPurchaseInvoiceLineTable.Columns.LineStatus.NAME),
                            SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture));

                        strBuilder.AppendFormat(" AND {0} = {1}",
                            SqlCommandHelper.EscapeTableColumnName(PmxPurchaseInvoiceLineTable.NAME, PmxPurchaseInvoiceLineTable.Columns.InventoryStatus.NAME),
                            SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture));

                        strBuilder.AppendFormat(" AND {0} = {1}",
                            SqlCommandHelper.EscapeTableColumnName(PmxItemTable.NAME, PmxItemTable.Columns.InventoryItem.NAME),
                            SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

                        if (cardCode != null && cardCode.Trim() != "")
                        {
                            strBuilder.AppendFormat(" AND {0} = {1}",
                                SqlCommandHelper.EscapeTableColumnName(SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.CardCode.NAME),
                                SqlCommandHelper.FormatAndEscapeColumnValue(cardCode, CultureInfo.InvariantCulture));
                        }

                        if (gtin != null && gtin.Trim() != "")
                        {
                            strBuilder.Append(" AND ");
                            Produmex.Sbo.Logex.Data.SboCommands.AddWhereClauseSearchForBarcodePackagingType(strBuilder, gtin);
                        }
                    }

                strBuilder.AppendFormat("\r\n ORDER BY {0}",
                    SqlCommandHelper.EscapeColumnName(PurchaseOrderDataSet.Columns.DOC_OBJ_TYPE.Name));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeColumnName(PurchaseOrderDataSet.Columns.PO_NUMBER.Name));

                return strBuilder.ToString();
            }



            /// <summary>
            /// Gets the containers.
            /// </summary>
            /// <returns></returns>
            public static string GetContainers()
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT DISTINCT ");

                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxContainerTable.NAME, PmxContainerTable.Columns.DocEntry.NAME, ContainerDataSet.Columns.DOC_ENTRY.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxContainerTable.NAME, PmxContainerTable.Columns.ContainerCode.NAME, ContainerDataSet.Columns.CONTAINER_CODE.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxContainerTable.NAME, PmxContainerTable.Columns.ContainerDescription.NAME, ContainerDataSet.Columns.DESCRIPTION.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxContainerTable.NAME, PmxContainerTable.Columns.EstimatedDateOfArrival.NAME, ContainerDataSet.Columns.ETA.Name);


                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxContainerTable.NAME));

                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxContainerLineTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxContainerLineTable.NAME, PmxContainerLineTable.Columns.DocEntry.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxContainerTable.NAME, PmxContainerTable.Columns.DocEntry.NAME);


                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderLineTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxContainerLineTable.NAME, PmxContainerLineTable.Columns.BaseEntry.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, SboPurchaseOrderLineTable.NAME, SboPurchaseOrderLineTable.Columns.DocEntry.NAME);
                strBuilder.Append(" AND ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxContainerLineTable.NAME, PmxContainerLineTable.Columns.BaseLine.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, SboPurchaseOrderLineTable.NAME, SboPurchaseOrderLineTable.Columns.LineNum.NAME);
                strBuilder.Append(" AND ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxContainerLineTable.NAME, PmxContainerLineTable.Columns.BaseType.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, SboPurchaseOrderLineTable.NAME, SboPurchaseOrderLineTable.Columns.ObjectType.NAME);


                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboItemTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, SboPurchaseOrderLineTable.NAME, SboPurchaseOrderLineTable.Columns.ItemCode.NAME);

                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.DocEntry.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, SboPurchaseOrderLineTable.NAME, SboPurchaseOrderLineTable.Columns.DocEntry.NAME);


                strBuilder.Append(" WHERE ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.InventoryItem.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));


                strBuilder.Append(" AND ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxContainerTable.NAME, PmxContainerTable.Columns.ContainerType.NAME);
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(PmxContainerTypeColumnValues.Purchase.VALUE, CultureInfo.InvariantCulture));

                strBuilder.Append(" AND ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxContainerTable.NAME, PmxContainerTable.Columns.ContainerStatus.NAME);
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(PmxContainerStatusColumnValues.InTransit.VALUE, CultureInfo.InvariantCulture));


                //only for open lines
                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderLineTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.LineStatus.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture));

                //only approved orders
                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.Confirmed.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));


                strBuilder.Append(" ORDER BY ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxContainerTable.Columns.EstimatedDateOfArrival.NAME));
                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxContainerTable.Columns.ContainerCode.NAME));

                return strBuilder.ToString();
            }

            /// <summary>
            /// Gets the existing ITRI.
            /// </summary>
            /// <param name="itemCode">The item code.</param>
            /// <param name="batchNumber">The batch number.</param>
            /// <param name="batchNumber2">The batch number2.</param>
            /// <param name="bestBeforeDate">The best before date.</param>
            /// <returns></returns>
            public static string GetExistingITRI(string itemCode, string batchNumber, string batchNumber2, DateTime? bestBeforeDate)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT ");

                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.InternalKey.NAME));

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.PackagingTypeCode.NAME));

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.Quantity.NAME));


                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));

                strBuilder.Append(" ON ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.ItemTransactionalInfoKey.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.InternalKey.NAME));



                strBuilder.Append(" WHERE ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.ItemCode.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, CultureInfo.InvariantCulture));

                if (!string.IsNullOrEmpty(batchNumber))
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.BatchNumber1.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(batchNumber, CultureInfo.InvariantCulture));
                }

                if (!string.IsNullOrEmpty(batchNumber2))
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.BatchNumber2.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(batchNumber2, CultureInfo.InvariantCulture));
                }

                if (bestBeforeDate.HasValue)
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(bestBeforeDate.Value, CultureInfo.InvariantCulture));
                }

                strBuilder.Append(" ORDER BY ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.Quantity.NAME));


                return strBuilder.ToString();
            }


            /// <summary>
            /// Command for getting all suppliers order by name
            /// </summary>
            /// <returns>Command for getting all suppliers order by name</returns>
            public static string GetSuppliersOrderByName()
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT ");

                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboBusinessPartnerTable.Columns.CardCode.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(SupplierDataSet.Columns.SUPPLIER_CODE.Name);

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboBusinessPartnerTable.Columns.CardName.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(SupplierDataSet.Columns.SUPPLIER_NAME.Name);

                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboBusinessPartnerTable.NAME));

                strBuilder.Append(" WHERE ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboBusinessPartnerTable.Columns.CardType.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBusinessPartnerTypeColumnValues.Vendor.VALUE, CultureInfo.InvariantCulture));

                strBuilder.Append(" ORDER BY ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboBusinessPartnerTable.Columns.CardName.NAME));
                return strBuilder.ToString();
            }


            /// <summary>
            /// Command for getting all products order by name
            /// </summary>
            /// <param name="vendorCode">The vendor code.</param>
            /// <param name="gtin">The gtin.</param>
            /// <param name="purchaseDocRef">The purchase doc ref.</param>
            /// <param name="cardCode">The card code.</param>
            /// <param name="packagingUnit">The packaging unit.</param>
            /// <param name="filterOutFrozenItems">if set to <c>true</c> [filter out frozen items].</param>
            /// <param name="distinct">if set to <c>true</c> [distinct].</param>
            /// <param name="crossDocking">if set to <c>true</c> [cross docking].</param>
            /// <param name="containerDocEntry">The container doc entry.</param>
            /// <param name="dbTool">The database tool.</param>
            /// <returns>
            /// Command for getting all products order by name
            /// </returns>
            /// <exception cref="System.ArgumentException">Only PurchaseOrder or Purchase(Reserve)Invoice supported;purDocEntry.DocType</exception>
            public static string GetCodeNameItemsOrderByName(string vendorCode, string gtin, DocumentRef purchaseDocRef, string cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit packagingUnit, bool filterOutFrozenItems, bool distinct, bool crossDocking, int? containerDocEntry, DbTool dbTool)
            {
                DbQueryBuilder strBuilder = dbTool.GetQueryBuilder();
                string purchaseDocTable = SboPurchaseOrderTable.NAME;
                string purchaseLineTable = SboPurchaseOrderLineTable.NAME;
                if (purchaseDocRef != null)
                {
                    switch (purchaseDocRef.DocType)
                    {
                        case SboObjectTypes.PurchaseOrder:
                            purchaseDocTable = SboPurchaseOrderTable.NAME;
                            purchaseLineTable = SboPurchaseOrderLineTable.NAME;
                            break;
                        case SboObjectTypes.PurchaseInvoice:
                            purchaseDocTable = SboPurchaseInvoiceTable.NAME;
                            purchaseLineTable = SboPurchaseInvoiceLineTable.NAME;
                            break;
                        default:
                            throw new ArgumentException("Only PurchaseOrder or Purchase(Reserve)Invoice supported", "purDocEntry.DocType");
                    }
                }

                strBuilder.Append("SELECT ");
                if (distinct)
                {
                    strBuilder.Append(" DISTINCT ");
                }

                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.Columns.ItemCode.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(ProductDataSet.Columns.PRODUCT_CODE.Name);



                strBuilder.Append(",  CASE");
                if (purchaseDocRef != null || !String.IsNullOrEmpty(cardCode))
                {
                    strBuilder.AppendFormat(" WHEN {0} <> '' THEN {0} + ' - ' + {1} + ' - ' + {2} ",
                        SqlCommandHelper.EscapeTableColumnName(PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.SubstituteItemDescr.NAME),
                        SqlCommandHelper.EscapeTableColumnName(PmxItemTable.NAME, PmxItemTable.Columns.CustomItemDescr.NAME),
                        SqlCommandHelper.EscapeTableColumnName(PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.Substitute.NAME));
                }
                strBuilder.AppendFormat(" WHEN {0} <> '' THEN {0} + ' - ' + {1} ",
                    SqlCommandHelper.EscapeTableColumnName(PmxItemTable.NAME, PmxItemTable.Columns.VendorItemDescr.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxItemTable.NAME, PmxItemTable.Columns.CustomItemDescr.NAME));
                strBuilder.AppendFormat(" ELSE {0} END",
                    SqlCommandHelper.EscapeTableColumnName(PmxItemTable.NAME, PmxItemTable.Columns.CustomItemDescr.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name);

                strBuilder.Append(", ");
                Produmex.Sbo.Logex.Data.SboCommands.AddBarcodeUsingPackagingUnit(strBuilder, packagingUnit, ProductDataSet.Columns.GTIN.Name);

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.HasBestBeforeDate.NAME));

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.PrintItemLabelReception.NAME));


                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.Columns.ManBtchNum.NAME));

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.IsLogisticUnit.NAME));

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnName(strBuilder, SboItemTable.NAME, SboItemTable.Columns.NumberOfItemsPerPurchaseUnit.NAME);

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnName(strBuilder, SboItemTable.NAME, SboItemTable.Columns.PurchaseUom.NAME);

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnName(strBuilder, SboItemTable.NAME, SboItemTable.Columns.InventoryUom.NAME);

                strBuilder.Append(", ");
                Produmex.Sbo.Logex.Data.SboCommands.AddBarcodeUsingPackagingUnit(strBuilder, packagingUnit, SboItemTable.Columns.CodeBars.NAME);
                //SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.PurchaseBarcode.NAME);

                if ((purchaseDocRef != null || containerDocEntry.HasValue) && !distinct)
                {
                    strBuilder.Append(", ");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(purchaseLineTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME));

                    strBuilder.Append(", ");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(purchaseLineTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME));

                }

                //if (poDocEntry.HasValue && !distinct)
                //{

                //    strBuilder.Append(", ");
                //    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.NAME));
                //    strBuilder.Append(".");
                //    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.DocEntry.NAME));

                //    strBuilder.Append(", ");
                //    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.NAME));
                //    strBuilder.Append(".");
                //    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.LineNum.NAME));

                //}

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.Columns.ItemName.NAME));

                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboItemTable.NAME));

                if (purchaseDocRef != null || containerDocEntry.HasValue)
                {
                    //inner join Product - PO Line
                    strBuilder.Append(" INNER JOIN ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(purchaseLineTable));
                    strBuilder.Append(" ON ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(purchaseLineTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderLineTable.Columns.ItemCode.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(SboItemTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(SboItemTable.Columns.ItemCode.NAME));

                    //inner join PO - PO Line
                    strBuilder.Append(" INNER JOIN ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(purchaseDocTable));
                    strBuilder.Append(" ON ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(purchaseDocTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.Columns.DocEntry.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(purchaseLineTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderLineTable.Columns.DocEntry.NAME));

                    strBuilder.Append(" LEFT JOIN ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxAlternateCatNumTable.NAME));
                    strBuilder.AppendFormat(" ON {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.CardCode.NAME),
                        SqlCommandHelper.EscapeTableColumnName(purchaseDocTable, SboPurchaseOrderTable.Columns.CardCode.NAME));
                    strBuilder.AppendFormat(" AND {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.ItemCode.NAME),
                        SqlCommandHelper.EscapeTableColumnName(SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME));

                    if (containerDocEntry.HasValue)
                    {
                        //inner join Container line - PO Line
                        strBuilder.Append(" INNER JOIN ");
                        strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxContainerLineTable.NAME));
                        strBuilder.Append(" ON ");
                        strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxContainerLineTable.NAME));
                        strBuilder.Append(".");
                        strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxContainerLineTable.Columns.BaseEntry.NAME));
                        strBuilder.Append(" = ");
                        strBuilder.Append(SqlCommandHelper.EscapeTableName(purchaseLineTable));
                        strBuilder.Append(".");
                        strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderLineTable.Columns.DocEntry.NAME));
                        strBuilder.Append(" AND ");
                        strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxContainerLineTable.NAME));
                        strBuilder.Append(".");
                        strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxContainerLineTable.Columns.BaseLine.NAME));
                        strBuilder.Append(" = ");
                        strBuilder.Append(SqlCommandHelper.EscapeTableName(purchaseLineTable));
                        strBuilder.Append(".");
                        strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderLineTable.Columns.LineNum.NAME));
                        strBuilder.Append(" AND ");
                        strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxContainerLineTable.NAME));
                        strBuilder.Append(".");
                        strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxContainerLineTable.Columns.BaseType.NAME));
                        strBuilder.Append(" = ");
                        strBuilder.Append(SqlCommandHelper.EscapeTableName(purchaseLineTable));
                        strBuilder.Append(".");
                        strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderLineTable.Columns.ObjectType.NAME));
                    }


                }
                else if (!String.IsNullOrEmpty(cardCode))
                {
                    strBuilder.Append(" LEFT JOIN ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxAlternateCatNumTable.NAME));
                    strBuilder.AppendFormat(" ON {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.CardCode.NAME),
                        SqlCommandHelper.FormatAndEscapeColumnValue(cardCode, CultureInfo.InvariantCulture));
                    strBuilder.AppendFormat(" AND {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.ItemCode.NAME),
                        SqlCommandHelper.EscapeTableColumnName(SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME));
                }

                string operand = " WHERE ";
                if (!string.IsNullOrEmpty(vendorCode))
                {
                    strBuilder.Append(operand);
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.Columns.CardCode.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(vendorCode, CultureInfo.InvariantCulture));
                    operand = " AND ";
                }


                if (!string.IsNullOrEmpty(gtin))
                {
                    strBuilder.Append(operand);
                    Produmex.Sbo.Logex.Data.SboCommands.AddWhereClauseSearchForBarcodePackagingType(strBuilder, gtin);
                    operand = " AND ";
                }

                if (purchaseDocRef != null)
                {
                    strBuilder.Append(operand);
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(purchaseDocTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.DocEntry.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(purchaseDocRef.DocEntry, CultureInfo.InvariantCulture));
                    operand = " AND ";

                    strBuilder.Append(operand);
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(purchaseLineTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.LineStatus.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture));
                    operand = " AND ";

                    if (purchaseDocRef.DocType == SboObjectTypes.PurchaseInvoice)  // Is this also valid for SboPurchaseOrderLineTable ??
                    {
                        strBuilder.Append(operand);
                        strBuilder.Append(SqlCommandHelper.EscapeColumnName(purchaseLineTable));
                        strBuilder.Append(".");
                        strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseInvoiceLineTable.Columns.InventoryStatus.NAME));
                        strBuilder.Append(" = ");
                        strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture));
                        operand = " AND ";
                    }
                }

                if (containerDocEntry.HasValue)
                {

                    strBuilder.Append(operand);
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(purchaseLineTable));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.LineStatus.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture));
                    operand = " AND ";


                    strBuilder.Append(operand);
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxContainerLineTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxContainerLineTable.Columns.DocEntry.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(containerDocEntry.Value, CultureInfo.InvariantCulture));
                    operand = " AND ";
                }


                strBuilder.Append(operand);
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.Columns.InventoryItem.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));
                operand = " AND ";

                switch (packagingUnit)
                {
                    case Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing:
                        strBuilder.Append(operand);
                        SqlCommandHelper.AddTableColumnName(strBuilder, SboItemTable.NAME, SboItemTable.Columns.PurchaseItem.NAME);
                        strBuilder.Append(" = ");
                        strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));
                        operand = " AND ";
                        break;
                    case Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Sales:
                        strBuilder.Append(operand);
                        SqlCommandHelper.AddTableColumnName(strBuilder, SboItemTable.NAME, SboItemTable.Columns.SalesItem.NAME);
                        strBuilder.Append(" = ");
                        strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));
                        operand = " AND ";
                        break;
                    default:
                        strBuilder.Append(operand);
                        SqlCommandHelper.AddTableColumnName(strBuilder, SboItemTable.NAME, SboItemTable.Columns.InventoryItem.NAME);
                        strBuilder.Append(" = ");
                        strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));
                        operand = " AND ";
                        break;
                }

                if (filterOutFrozenItems)
                {
                    Logex.Data.SboCommands.GetFrozenItemFilterSQLWherePart(strBuilder, " AND ");
                }

                if (crossDocking && purchaseDocRef.DocType == SboObjectTypes.PurchaseOrder)
                {
                    strBuilder.AppendFormat(" AND {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME),
                        SqlCommandHelper.FormatAndEscapeColumnValue(SboObjectTypes.SalesOrder, CultureInfo.InvariantCulture));
                }

                strBuilder.Append(" ORDER BY ");
                //strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboItemTable.NAME ) );
                //strBuilder.Append( "." );
                //strBuilder.Append( SqlCommandHelper.EscapeColumnName( PmxItemTable.Columns.CustomItemDescr.NAME ) );
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name));
                return strBuilder.ToString();
            }

            /// <summary>
            /// Command for getting all logistic carriers order by name
            /// </summary>
            /// <param name="onlyInStock">if set to <c>true</c> the system will get the logistic carriers that are in stock and have no products on it (LUID IS NULL)</param>
            /// <param name="filterOutFrozenItems">if set to <c>true</c> [filter out frozen items].</param>
            /// <param name="dbTool">The database tool.</param>
            /// <returns>
            /// Command for getting all logistic carriers order by name
            /// </returns>
            public static string GetLogisticCarriersOrderByName(bool onlyInStock, bool filterOutFrozenItems, DbTool dbTool)
            {

                DbQueryBuilder strBuilder = dbTool.GetQueryBuilder();
                strBuilder.Append("SELECT DISTINCT ");

                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.Columns.ItemCode.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(ProductDataSet.Columns.PRODUCT_CODE.Name);

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.CustomItemDescr.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name);

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.Columns.CodeBars.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(ProductDataSet.Columns.GTIN.Name);

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.IsLogisticCarrier.NAME));



                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboItemTable.NAME));

                if (onlyInStock)
                {
                    strBuilder.Append(" INNER JOIN ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxInventoryTotalTable.NAME));
                    strBuilder.Append(" ON ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemCode.NAME);
                    strBuilder.Append(" = ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME);
                    strBuilder.Append(" AND ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.LogUnitIdentKey.NAME);
                    strBuilder.Append(" IS NULL ");
                }




                strBuilder.Append(" WHERE ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.Columns.InventoryItem.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.IsLogisticCarrier.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

                if (filterOutFrozenItems)
                {
                    Logex.Data.SboCommands.GetFrozenItemFilterSQLWherePart(strBuilder, " AND ");
                }


                strBuilder.Append(" ORDER BY ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.CustomItemDescr.NAME));
                return strBuilder.ToString();

            }


            /// <summary>
            /// Gets the locked stock for base order.
            /// </summary>
            /// <param name="itemCodes">The item codes.</param>
            /// <param name="purchaseDocRef">The purchase doc ref.</param>
            /// <returns></returns>
            public static string GetLockedStockForBaseOrder(Collection<string> itemCodes, DocumentRef purchaseDocRef)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT DISTINCT ");

                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.SSCC.NAME, SSCCDataSet.Columns.SSCC.Name);

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.LogUnitIdentKey.NAME, SSCCDataSet.Columns.LUID.Name);

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.StorLocCode.NAME, SSCCDataSet.Columns.STORAGE_LOCATION_CODE.Name);

                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME, SSCCDataSet.Columns.PMX_WAREHOUSE_CODE.Name));

                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(PmxOseWarehouseTable.NAME, PmxOseWarehouseTable.Columns.Name.NAME, SSCCDataSet.Columns.PMX_WAREHOUSE_NAME.Name));

                if (purchaseDocRef.DocType == SboObjectTypes.PurchaseOrder)
                {
                    strBuilder.AppendFormat("\r\n FROM {0}",
                        SqlCommandHelper.EscapeTableName(PmxPurchaseOrderLineTable.NAME));
                }
                else if (purchaseDocRef.DocType == SboObjectTypes.PurchaseInvoice)
                {
                    strBuilder.AppendFormat("\r\n FROM {0}",
                        SqlCommandHelper.EscapeTableName(PmxPurchaseInvoiceLineTable.NAME));

                    strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                        SqlCommandHelper.EscapeTableName(PmxPurchaseOrderLineTable.NAME));
                    strBuilder.AppendFormat(" ON {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.ObjectType.NAME),
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseInvoiceLineTable.NAME, PmxPurchaseInvoiceLineTable.Columns.BaseType.NAME));
                    strBuilder.AppendFormat(" AND {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.DocEntry.NAME),
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseInvoiceLineTable.NAME, PmxPurchaseInvoiceLineTable.Columns.BaseEntry.NAME));
                    strBuilder.AppendFormat(" AND {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.LineNum.NAME),
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseInvoiceLineTable.NAME, PmxPurchaseInvoiceLineTable.Columns.BaseLine.NAME));
                }

                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxInventoryLockingDetailTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.BaseType.NAME);
                strBuilder.Append(" = CAST(");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME);
                strBuilder.Append(" AS nvarchar(20)) AND ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.BaseEntry.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseEntry.NAME);

                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxInventoryTotalTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.LogUnitIdentKey.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.LogUnitIdentKey.NAME);


                strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                    SqlCommandHelper.EscapeTableName(PmxOseGeneralTable.NAME));
                strBuilder.AppendFormat(" ON {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.Code.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.StorLocCode.NAME));


                strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                    SqlCommandHelper.EscapeTableName(PmxOseWarehouseTable.NAME));
                strBuilder.AppendFormat(" ON {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxOseWarehouseTable.NAME, PmxOseWarehouseTable.Columns.Code.NAME));


                if (purchaseDocRef.DocType == SboObjectTypes.PurchaseOrder)
                {
                    strBuilder.AppendFormat("\r\n WHERE {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.DocEntry.NAME),
                        SqlCommandHelper.FormatAndEscapeColumnValue(purchaseDocRef.DocEntry, CultureInfo.InvariantCulture));
                    strBuilder.AppendFormat(" AND {0} IN ( {1} )",
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.ItemCode.NAME),
                        SqlCommandHelper.FormatAndEscapeColumnValue(itemCodes, CultureInfo.InvariantCulture));
                }
                else if (purchaseDocRef.DocType == SboObjectTypes.PurchaseInvoice)
                {
                    strBuilder.AppendFormat("\r\n WHERE {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseInvoiceLineTable.NAME, PmxPurchaseInvoiceLineTable.Columns.DocEntry.NAME),
                        SqlCommandHelper.FormatAndEscapeColumnValue(purchaseDocRef.DocEntry, CultureInfo.InvariantCulture));
                    strBuilder.AppendFormat(" AND {0} IN ( {1} )",
                        SqlCommandHelper.EscapeTableColumnName(PmxPurchaseInvoiceLineTable.NAME, PmxPurchaseInvoiceLineTable.Columns.ItemCode.NAME),
                        SqlCommandHelper.FormatAndEscapeColumnValue(itemCodes, CultureInfo.InvariantCulture));
                }

                strBuilder.Append(" ORDER BY ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.StorLocCode.NAME);


                return strBuilder.ToString();

            }




            /// <summary>
            /// Gets the stock with later BBD.
            /// </summary>
            /// <param name="itemCode">The item code.</param>
            /// <param name="bbd">The BBD.</param>
            /// <returns></returns>
            public static string GetStockWithLaterBBD(string itemCode, DateTime bbd)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT ");

                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME, PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME);

                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxInventoryTotalTable.NAME));


                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemTransactionalInfoKey.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.InternalKey.NAME);

                strBuilder.Append(" WHERE ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemCode.NAME);
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, CultureInfo.InvariantCulture));


                strBuilder.Append(" AND ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME);
                strBuilder.Append(" > ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboHelper.ConvertDateToSboDate(bbd), CultureInfo.InvariantCulture));




                strBuilder.Append(" ORDER BY ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME);
                strBuilder.Append(" DESC ");


                return strBuilder.ToString();

            }

            internal static string GetReceivedButUnfinishedOrders(string currentDockCode, CultureInfo dbCulture)
            {
                StringBuilder strBuilder = new StringBuilder();

                strBuilder.AppendFormat("SELECT DISTINCT {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(PmxPurchaseOrderTable.NAME, PmxPurchaseOrderTable.Columns.DocEntry.NAME, PurchaseOrderDataSet.Columns.PO_ID.Name));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(PmxPurchaseOrderTable.NAME, PmxPurchaseOrderTable.Columns.DocNum.NAME, PurchaseOrderDataSet.Columns.PO_NUMBER.Name));
                strBuilder.AppendFormat(", CAST( {0} AS NVARCHAR ) AS {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderTable.NAME, PmxPurchaseOrderTable.Columns.DocNum.NAME),
                    SqlCommandHelper.EscapeColumnName(PurchaseOrderDataSet.Columns.PO_NUMBER_ASSTRING.Name));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(PmxPurchaseOrderTable.NAME, PmxPurchaseOrderTable.Columns.CardCode.NAME, PurchaseOrderDataSet.Columns.SUPPLIER_CODE.Name));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(PmxPurchaseOrderTable.NAME, PmxPurchaseOrderTable.Columns.CardName.NAME, PurchaseOrderDataSet.Columns.SUPPLIER_NAME.Name));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(PmxPurchaseOrderTable.NAME, PmxPurchaseOrderTable.Columns.NumAtCard.NAME, PurchaseOrderDataSet.Columns.SUPPLIER_REFERENCE.Name));

                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseEntry.NAME, "ORDR_DocEntry"));

                strBuilder.AppendFormat("\r\n FROM {0}",
                    SqlCommandHelper.EscapeTableName(PmxInventoryTotalTable.NAME));

                strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                    SqlCommandHelper.EscapeTableName(PmxInventoryDetailTable.NAME));
                strBuilder.AppendFormat(" ON {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.ItemCode.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemCode.NAME));
                strBuilder.AppendFormat(" AND ( {0} = {1} OR ( {0} IS NULL AND {1} IS NULL ) )",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.ItemTransactionalInfoKey.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemTransactionalInfoKey.NAME));
                strBuilder.AppendFormat(" AND {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.StorLocCode.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.StorLocCode.NAME));
                strBuilder.AppendFormat(" AND {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.LogUnitIdentKey.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.LogUnitIdentKey.NAME));

                strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                    SqlCommandHelper.EscapeTableName(PmxPurchaseOrderLineTable.NAME));
                strBuilder.AppendFormat(" ON {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.DocEntry.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.BaseEntry.NAME));

                strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                    SqlCommandHelper.EscapeTableName(PmxPurchaseOrderTable.NAME));
                strBuilder.AppendFormat(" ON {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderTable.NAME, PmxPurchaseOrderTable.Columns.DocEntry.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.DocEntry.NAME));

                strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                    SqlCommandHelper.EscapeTableName(PmxSalesOrderTable.NAME));
                strBuilder.AppendFormat(" ON {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderTable.NAME, PmxSalesOrderTable.Columns.DocEntry.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseEntry.NAME));

                strBuilder.AppendFormat("\r\n LEFT JOIN {0}",
                    SqlCommandHelper.EscapeTableName(PmxPickListProposalLineTable.NAME));
                strBuilder.AppendFormat(" ON {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxPickListProposalLineTable.NAME, PmxPickListProposalLineTable.Columns.BaseType.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME));
                strBuilder.AppendFormat(" AND {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxPickListProposalLineTable.NAME, PmxPickListProposalLineTable.Columns.BaseEntry.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseEntry.NAME));
                strBuilder.AppendFormat(" AND {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxPickListProposalLineTable.NAME, PmxPickListProposalLineTable.Columns.BaseLine.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseLine.NAME));
                strBuilder.AppendFormat(" AND {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxPickListProposalLineTable.NAME, PmxPickListProposalLineTable.Columns.LineStatus.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue("O", dbCulture));

                strBuilder.AppendFormat("\r\n WHERE {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.StorLocCode.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(currentDockCode, dbCulture));
                strBuilder.AppendFormat(" AND {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.TransType.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(SboObjectTypes.PurchaseDelivery, dbCulture));
                strBuilder.AppendFormat(" AND {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.BaseType.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(SboObjectTypes.PurchaseOrder, dbCulture));
                strBuilder.AppendFormat(" AND {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue((int)SboObjectType.SalesOrder, dbCulture));
                strBuilder.AppendFormat(" AND {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxSalesOrderTable.NAME, PmxSalesOrderTable.Columns.DocStatus.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, dbCulture));
                strBuilder.AppendFormat(" AND {0} IS NULL",
                    SqlCommandHelper.EscapeTableColumnName(PmxPickListProposalLineTable.NAME, PmxPickListProposalLineTable.Columns.DocEntry.NAME));

                return strBuilder.ToString();
            }

            /// <summary>
            /// Gets the sales order and pick list locked stock.
            /// Locked for:
            /// * SalesOrder -> used for auto-overpicking
            /// * PickList -> used for auto-picking, only returns stock locked on LUID's which are received on the given PurchaseOrder
            /// </summary>
            /// <param name="purchaseOrderDocEntry">The purchase order doc entry.</param>
            /// <param name="salesOrderDocEntry">The sales order doc entry.</param>
            /// <param name="pickListDocEntry">The pick list doc entry.</param>
            /// <param name="dbCulture">The db culture.</param>
            /// <returns></returns>
            internal static string GetSalesOrderAndPickListLockedStock(int purchaseOrderDocEntry, int salesOrderDocEntry, int pickListDocEntry, CultureInfo dbCulture)
            {
                StringBuilder strBuilder = new StringBuilder();

                strBuilder.AppendFormat("SELECT {0}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.BaseType.NAME));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.BaseEntry.NAME));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.BaseLine.NAME));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.ItemCode.NAME));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.ItemTransactionalInfoKey.NAME));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.Quantity.NAME));
                //strBuilder.AppendFormat( ", {0}",
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryDetailTable.NAME, PmxInventoryTotalTable.Columns.QuantityPerUom.NAME ) );
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.StorLocCode.NAME));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.LogUnitIdentKey.NAME));
                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.QualityStatusCode.NAME));
                //strBuilder.AppendFormat( ", {0}",
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.Quantity.NAME ) );
                //strBuilder.AppendFormat( ", {0}",
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.StorLocCode.NAME ) );

                strBuilder.AppendFormat("\r\n FROM {0}",
                    SqlCommandHelper.EscapeTableName(PmxInventoryLockingDetailTable.NAME));

                //strBuilder.AppendFormat( "\r\n INNER JOIN {0}",
                //    SqlCommandHelper.EscapeTableName( PmxInventoryTotalTable.NAME ) );
                //strBuilder.AppendFormat( " ON {0} = {1}",
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemCode.NAME ),
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.ItemCode.NAME ) );
                //strBuilder.AppendFormat( " AND ( {0} = {1} OR ( {0} IS NULL AND {1} IS NULL ) )",
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemTransactionalInfoKey.NAME ),
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.ItemTransactionalInfoKey.NAME ) );
                //strBuilder.AppendFormat( " AND {0} = {1}",
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.LogUnitIdentKey.NAME ),
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.LogUnitIdentKey.NAME ) );
                //strBuilder.AppendFormat( " AND {0} = {1}",
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.QualityStatusCode.NAME ),
                //    SqlCommandHelper.EscapeTableColumnName( PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.QualityStatusCode.NAME ) );

                strBuilder.AppendFormat("\r\n WHERE ( {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(SboObjectTypes.SalesOrder, dbCulture));
                strBuilder.AppendFormat(" AND {0} = {1} )",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.BaseEntry.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(salesOrderDocEntry, dbCulture));

                strBuilder.AppendFormat(" OR ( {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxPickList, dbCulture));
                strBuilder.AppendFormat(" AND {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.BaseEntry.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(pickListDocEntry, dbCulture));
                strBuilder.AppendFormat(" AND {0} IN ( SELECT {1} FROM {2} WHERE {3} = {4} AND {5} = {6} ) )",
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.LogUnitIdentKey.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.LogUnitIdentKey.NAME),
                    SqlCommandHelper.EscapeTableName(PmxInventoryDetailTable.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.BaseType.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(SboObjectTypes.PurchaseOrder, dbCulture),
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.BaseEntry.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(purchaseOrderDocEntry, dbCulture));

                return strBuilder.ToString();
            }

            //internal static string GetPurchaseOrderReceivedStock( int purchaseOrderDocEntry, CultureInfo dbCulture )
            //{
            //    StringBuilder strBuilder = new StringBuilder();

            //    strBuilder.AppendFormat( "SELECT {0}",
            //        SqlCommandHelper.EscapeTableColumnName( PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.ItemCode.NAME ) );
            //    strBuilder.AppendFormat( ", {0}",
            //        SqlCommandHelper.EscapeTableColumnName( PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.ItemTransactionalInfoKey.NAME ) );
            //    strBuilder.AppendFormat( ", {0}",
            //        SqlCommandHelper.EscapeTableColumnName( PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.QualityStatusCode.NAME ) );
            //    strBuilder.AppendFormat( ", {0}",
            //        SqlCommandHelper.EscapeTableColumnName( PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.Quantity.NAME ) );
            //    strBuilder.AppendFormat( ", {0}",
            //        SqlCommandHelper.EscapeTableColumnName( PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.QuantityPerUom.NAME ) );
            //    strBuilder.AppendFormat( ", {0}",
            //        SqlCommandHelper.EscapeTableColumnName( PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.StorLocCode.NAME ) );
            //    strBuilder.AppendFormat( ", {0}",
            //        SqlCommandHelper.EscapeTableColumnName( PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.LogUnitIdentKey.NAME ) );

            //    strBuilder.AppendFormat( "\r\n FROM {0}",
            //        SqlCommandHelper.EscapeTableName( PmxInventoryTotalTable.NAME ) );

            //    strBuilder.AppendFormat( "\r\n INNER JOIN {0}",
            //        SqlCommandHelper.EscapeTableName( PmxInventoryDetailTable.NAME ) );
            //    strBuilder.AppendFormat( " ON {0} = {1}",
            //        SqlCommandHelper.EscapeTableColumnName( PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.ItemCode.NAME ),
            //        SqlCommandHelper.EscapeTableColumnName( PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemCode.NAME ) );
            //    strBuilder.AppendFormat( " AND ( {0} = {1} OR ( {0} IS NULL AND {1} IS NULL ) )",
            //        SqlCommandHelper.EscapeTableColumnName( PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.ItemTransactionalInfoKey.NAME ),
            //        SqlCommandHelper.EscapeTableColumnName( PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemTransactionalInfoKey.NAME ) );
            //    strBuilder.AppendFormat( " AND {0} = {1}",
            //        SqlCommandHelper.EscapeTableColumnName( PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.StorLocCode.NAME ),
            //        SqlCommandHelper.EscapeTableColumnName( PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.StorLocCode.NAME ) );
            //    strBuilder.AppendFormat( " AND {0} = {1}",
            //        SqlCommandHelper.EscapeTableColumnName( PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.LogUnitIdentKey.NAME ),
            //        SqlCommandHelper.EscapeTableColumnName( PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.LogUnitIdentKey.NAME ) );

            //    strBuilder.AppendFormat( "\r\n INNER JOIN {0}",
            //        SqlCommandHelper.EscapeTableName( PmxPurchaseOrderLineTable.NAME ) );
            //    strBuilder.AppendFormat( " ON {0} = {1}",
            //        SqlCommandHelper.FormatAndEscapeColumnValue( SboObjectTypes.PurchaseOrder, dbCulture ),
            //        SqlCommandHelper.EscapeTableColumnName( PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.BaseType.NAME ) );
            //    strBuilder.AppendFormat( " AND {0} = {1}",
            //        SqlCommandHelper.EscapeTableColumnName( PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.DocEntry.NAME ),
            //        SqlCommandHelper.EscapeTableColumnName( PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.BaseEntry.NAME ) );
            //    strBuilder.AppendFormat( " AND {0} = {1}",
            //        SqlCommandHelper.EscapeTableColumnName( PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.LineNum.NAME ),
            //        SqlCommandHelper.EscapeTableColumnName( PmxInventoryDetailTable.NAME, PmxInventoryDetailTable.Columns.BaseLine.NAME ) );

            //    strBuilder.AppendFormat( "\r\n WHERE {0} = {1}",
            //        SqlCommandHelper.EscapeTableColumnName( PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.DocEntry.NAME ),
            //        SqlCommandHelper.FormatAndEscapeColumnValue( purchaseOrderDocEntry, dbCulture ) );

            //    return strBuilder.ToString();
            //}


            /// <summary>
            /// Gets the zone types for items.
            /// </summary>
            /// <param name="itemCodes">The item codes.</param>
            /// <returns></returns>
            public static string GetZoneTypesForItems(Collection<string> itemCodes)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT DISTINCT");

                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemZoneTypeTable.NAME, PmxItemZoneTypeTable.Columns.ZoneTypeCode.NAME, PmxItemZoneTypeTable.Columns.ZoneTypeCode.NAME);

                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemZoneTypeTable.NAME));


                string operand = "";
                strBuilder.Append(" WHERE ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemZoneTypeTable.NAME, PmxItemZoneTypeTable.Columns.ItemCode.NAME);
                strBuilder.Append(" IN ( ");

                foreach (string itemCode in itemCodes)
                {
                    strBuilder.Append(operand);
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, CultureInfo.InvariantCulture));
                    operand = ", ";
                }
                strBuilder.Append(") ");


                return strBuilder.ToString();
            }

            /// <summary>
            /// Gets the name and the code of the  location, ordered by name.
            /// </summary>
            /// <param name="locationCode">The location code.</param>
            /// <param name="warehouseCode">The warehouse code.</param>
            /// <param name="zoneTypeCodes">The zone type codes.</param>
            /// <param name="emptyLocations">if set to <c>true</c> [empty locations].</param>
            /// <returns>The sql statement to get the location</returns>
            public static string GetStorageLocationForZoneTypes(string locationCode, string warehouseCode, Collection<string> zoneTypeCodes, bool emptyLocations)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT ");

                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseStorageLocationGeneralTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseStorageLocationGeneralTable.Columns.Code.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(LocationDataSet.Columns.CODE.Name);

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseStorageLocationGeneralTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseStorageLocationGeneralTable.Columns.Name.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(LocationDataSet.Columns.DESCRIPTION.Name);

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseGeneralTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(LocationDataSet.Columns.WAREHOUSECODE.Name);


                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseWarehouseTable.NAME, PmxOseWarehouseTable.Columns.Name.NAME, LocationDataSet.Columns.WAREHOUSENAME.Name);


                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseStorageLocationGeneralTable.NAME));
                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseGeneralTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.Code.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseStorageLocationGeneralTable.NAME, PmxOseStorageLocationGeneralTable.Columns.Code.NAME);

                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseWarehouseTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseWarehouseTable.NAME, PmxOseWarehouseTable.Columns.Code.NAME);

                if (emptyLocations)
                {
                    strBuilder.Append(" LEFT JOIN ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxInventoryTotalTable.NAME));
                    strBuilder.Append(" ON ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.StorLocCode.NAME);
                    strBuilder.Append(" = ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseStorageLocationGeneralTable.NAME, PmxOseStorageLocationGeneralTable.Columns.Code.NAME);

                }

                strBuilder.Append(" WHERE ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseStorageLocationGeneralTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseStorageLocationGeneralTable.Columns.IsActive.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));


                if (!string.IsNullOrEmpty(locationCode))
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseStorageLocationGeneralTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseStorageLocationGeneralTable.Columns.Code.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(locationCode, CultureInfo.InvariantCulture));
                }

                if (warehouseCode != null &&
                    warehouseCode.Trim() != "")
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseGeneralTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(warehouseCode, CultureInfo.InvariantCulture));

                }

                if (zoneTypeCodes != null &&
                    zoneTypeCodes.Count > 0)
                {
                    foreach (string zoneTypeCode in zoneTypeCodes)
                    {
                        strBuilder.Append(" AND ");
                        strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseStorageLocationGeneralTable.NAME));
                        strBuilder.Append(".");
                        strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseStorageLocationGeneralTable.Columns.Code.NAME));
                        strBuilder.Append(" IN ( ");

                        strBuilder.Append("SELECT ");

                        strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseStorageLocationGeneralTable.NAME));
                        strBuilder.Append(".");
                        strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseStorageLocationGeneralTable.Columns.Code.NAME));


                        strBuilder.Append(" FROM ");
                        strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseStorageLocationGeneralTable.NAME));
                        strBuilder.Append(" INNER JOIN ");
                        strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseGeneralTable.NAME));
                        strBuilder.Append(" ON ");
                        SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.Code.NAME);
                        strBuilder.Append(" = ");
                        SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseStorageLocationGeneralTable.NAME, PmxOseStorageLocationGeneralTable.Columns.Code.NAME);
                        strBuilder.Append(" RIGHT OUTER JOIN ");
                        strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxLinkZoneZoneTypeTable.NAME));
                        strBuilder.Append(" ON ");
                        SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxZoneCode.NAME);
                        strBuilder.Append(" = ");
                        SqlCommandHelper.AddTableColumnName(strBuilder, PmxLinkZoneZoneTypeTable.NAME, PmxLinkZoneZoneTypeTable.Columns.ParentCode.NAME);


                        strBuilder.Append(" WHERE ");


                        strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxLinkZoneZoneTypeTable.NAME));
                        strBuilder.Append(".");
                        strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxLinkZoneZoneTypeTable.Columns.ZoneTypeCode.NAME));
                        strBuilder.Append(" = ");
                        strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(zoneTypeCode, CultureInfo.InvariantCulture));


                        strBuilder.Append(") ");

                    }
                }

                if (emptyLocations)
                {
                    //If there is no link to the inventory, the location is empty
                    strBuilder.Append(" AND ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.StorLocCode.NAME);
                    strBuilder.Append(" IS NULL ");

                }

                strBuilder.Append(" ORDER BY ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseStorageLocationGeneralTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseStorageLocationGeneralTable.Columns.Name.NAME));


                return strBuilder.ToString();
            }


            /// <summary>
            /// Gets the reasons.
            /// </summary>
            /// <returns></returns>
            public static string GetReasons()
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT  ");

                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxReasonTable.NAME, PmxReasonTable.Columns.Code.NAME, ReasonDataSet.Columns.REASON_CODE.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxReasonTable.NAME, PmxReasonTable.Columns.Name.NAME, ReasonDataSet.Columns.REASON_NAME.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxReasonTable.NAME, PmxReasonTable.Columns.RequiresFreeText.NAME, ReasonDataSet.Columns.REASON_REQUIRES_FREE_TEXT.Name);

                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxReasonTable.NAME));

                strBuilder.Append(" WHERE ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxReasonTable.Columns.UseForPurchaseReceipt.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

                strBuilder.AppendFormat(
              " ORDER BY CASE WHEN {0} IS NULL THEN 1 ELSE 0 END, {0} ",
               SqlCommandHelper.EscapeTableColumnName(PmxReasonTable.NAME, PmxReasonTable.Columns.SequenceNumber.NAME));

                return strBuilder.ToString();
            }

            /// <summary>
            /// Gets the reasons for zonetypes
            /// </summary>
            /// <returns></returns>
            public static string GetReasonsForZoneTypes()
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT  ");

                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxReasonTable.NAME, PmxReasonTable.Columns.Code.NAME, ReasonDataSet.Columns.REASON_CODE.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxReasonTable.NAME, PmxReasonTable.Columns.Name.NAME, ReasonDataSet.Columns.REASON_NAME.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxReasonTable.NAME, PmxReasonTable.Columns.RequiresFreeText.NAME, ReasonDataSet.Columns.REASON_REQUIRES_FREE_TEXT.Name);

                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxReasonTable.NAME));

                strBuilder.Append(" WHERE ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxReasonTable.Columns.UseForZoneType.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

                strBuilder.AppendFormat(
              " ORDER BY CASE WHEN {0} IS NULL THEN 1 ELSE 0 END, {0} ",
               SqlCommandHelper.EscapeTableColumnName(PmxReasonTable.NAME, PmxReasonTable.Columns.SequenceNumber.NAME));

                return strBuilder.ToString();
            }


            /// <summary>
            /// Gets the zone types on Item
            /// </summary>
            /// <returns></returns>
            public static string GetZoneTypesOnItem(
                // string itemCode, 
                CultureInfo dbCulture)
            {
                /*
                 * SELECT [PMX_ITZT].[ItemCode], PMX_ITZT.ZoneTypeCode, PMX_ZOTY.CODE, PMX_ZOTY.Name 
FROM PMX_ITZT 
INNER JOIN PMX_ZOTY 
ON 
PMX_ITZT.[ZoneTypeCode] = PMX_ZOTY.[Code]
 WHERE PMX_ZOTY.ShowZoneTYpe = 'N'
                AND
PMX_ITZT = 'itemCode'
                 */
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemZoneTypeTable.NAME, PmxItemZoneTypeTable.Columns.ItemCode.NAME);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemZoneTypeTable.NAME, PmxItemZoneTypeTable.Columns.ZoneTypeCode.NAME);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxZoneTypeTable.NAME, PmxZoneTypeTable.Columns.Code.NAME);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxZoneTypeTable.NAME, PmxZoneTypeTable.Columns.Name.NAME);

                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemZoneTypeTable.NAME));

                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxZoneTypeTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemZoneTypeTable.NAME, PmxItemZoneTypeTable.Columns.ZoneTypeCode.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxZoneTypeTable.NAME, PmxZoneTypeTable.Columns.Code.NAME);

                strBuilder.AppendFormat(" WHERE {0} = {1}",
                SqlCommandHelper.EscapeTableColumnName(PmxZoneTypeTable.NAME, PmxZoneTypeTable.Columns.ShowZoneType.NAME),
                SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, dbCulture));
                //strBuilder.AppendFormat(" AND {0} = {1}",
                //SqlCommandHelper.EscapeTableColumnName(PmxItemZoneTypeTable.NAME, PmxItemZoneTypeTable.Columns.ItemCode.NAME),
                //SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, dbCulture));

                return strBuilder.ToString();
            }

            public static string GetZoneTypesOnItemCodeAndPossibleReasons(string itemCode, bool mustHaveReasons, CultureInfo dbCulture)
            {
                /*                 
SELECT [PMX_ITZT].[ItemCode], [PMX_ITZT].[ZoneTypeCode], [PMX_ZOTY].[Name],
[PMX_QLOG].[QualityLogOperationCode], 
[PMX_REAS].[Code], 
[PMX_REAS].[Name]
FROM [PMX_ITZT] 
                 */

                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemZoneTypeTable.NAME, PmxItemZoneTypeTable.Columns.ItemCode.NAME);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemZoneTypeTable.NAME, PmxItemZoneTypeTable.Columns.ZoneTypeCode.NAME, ZoneTypeDataSet.Columns.ZONETYPE_CODE.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxZoneTypeTable.NAME, PmxZoneTypeTable.Columns.Name.NAME, ZoneTypeDataSet.Columns.ZONETYPE_NAME.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxReasonTable.NAME, PmxReasonTable.Columns.Code.NAME, ZoneTypeDataSet.Columns.REASON_CODE.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxReasonTable.NAME, PmxReasonTable.Columns.Name.NAME, ZoneTypeDataSet.Columns.REASON_NAME.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxZoneTypeTable.NAME, PmxZoneTypeTable.Columns.NeedsReason.NAME, ZoneTypeDataSet.Columns.NEEDS_REASON.Name);


                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemZoneTypeTable.NAME));

                /*
                 * 
INNER JOIN [PMX_ZOTY] 
ON [PMX_ITZT].[ZoneTypeCode] = [PMX_ZOTY].[Code] 
INNER JOIN [PMX_QLOG]
ON [PMX_QLOG].[QualityLogOperationType] = [PMX_ZOTY].[Code]
FULL OUTER JOIN[PMX_REAS]
ON [PMX_REAS].[Code] = [PMX_QLOG].[ReasonCode]
                 */

                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxZoneTypeTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemZoneTypeTable.NAME, PmxItemZoneTypeTable.Columns.ZoneTypeCode.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxZoneTypeTable.NAME, PmxZoneTypeTable.Columns.Code.NAME);

                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxQualityLogTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxQualityLogTable.NAME, PmxQualityLogTable.Columns.QualityLogOperationType.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxZoneTypeTable.NAME, PmxZoneTypeTable.Columns.Code.NAME);

                strBuilder.Append(" FULL OUTER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxReasonTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxReasonTable.NAME, PmxReasonTable.Columns.Code.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxQualityLogTable.NAME, PmxQualityLogTable.Columns.ReasonCode.NAME);


                /*
                 * WHERE 
[PMX_ITZT].[ItemCode] = N'RWU001'
AND
[PMX_ZOTY].[ShowZoneType] = N'Y'
AND
[PMX_ZOTY].[NeedsReason] = N'Y'
                 */

                strBuilder.AppendFormat(" WHERE {0} = {1}",
                SqlCommandHelper.EscapeTableColumnName(PmxZoneTypeTable.NAME, PmxZoneTypeTable.Columns.ShowZoneType.NAME),
                SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, dbCulture));

                strBuilder.AppendFormat(" AND {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxItemZoneTypeTable.NAME, PmxItemZoneTypeTable.Columns.ItemCode.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, dbCulture));

                if (mustHaveReasons)
                {
                    strBuilder.AppendFormat(" AND {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxZoneTypeTable.NAME, PmxZoneTypeTable.Columns.NeedsReason.NAME),
                    SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, dbCulture));
                }

                return strBuilder.ToString();
            }


            public static string GetZoneTypesOnItemCode(string itemCode, CultureInfo dbCulture)
            {
                /*
                SELECT [PMX_ZOTY].[Code] AS [ZoneTypeCode], [PMX_ZOTY].[Name] AS [ZoneTypeName], 
 '' AS [ReasonCode],  '' AS [ReasonName], [PMX_ZOTY].[NeedsReason] AS [NeedsReason] 
FROM [OITM] 
INNER JOIN [PMX_ITZT] 
ON [PMX_ITZT].[ItemCode] = [OITM].[ItemCode]
INNER JOIN [PMX_ZOTY]
ON [PMX_ZOTY].[Code] = [PMX_ITZT].[ZoneTypeCode]
WHERE [PMX_ZOTY].[ShowZoneType] = N'Y' AND [PMX_ITZT].[ItemCode] = N'RWU001'
                 */
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxZoneTypeTable.NAME, PmxZoneTypeTable.Columns.Code.NAME, ZoneTypeDataSet.Columns.ZONETYPE_CODE.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxZoneTypeTable.NAME, PmxZoneTypeTable.Columns.Name.NAME, ZoneTypeDataSet.Columns.ZONETYPE_NAME.Name);
                //strBuilder.Append(", ");
                //SqlCommandHelper.AddEmptyStringColumnWithName(strBuilder, ZoneTypeDataSet.Columns.REASON_CODE.Name);
                //strBuilder.Append(", ");
                //SqlCommandHelper.AddEmptyStringColumnWithName(strBuilder, ZoneTypeDataSet.Columns.REASON_NAME.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxZoneTypeTable.NAME, PmxZoneTypeTable.Columns.NeedsReason.NAME, ZoneTypeDataSet.Columns.NEEDS_REASON.Name);

                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTable.NAME));

                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemZoneTypeTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemZoneTypeTable.NAME, PmxItemZoneTypeTable.Columns.ItemCode.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.ItemCode.NAME);

                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxZoneTypeTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemZoneTypeTable.NAME, PmxItemZoneTypeTable.Columns.ZoneTypeCode.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxZoneTypeTable.NAME, PmxZoneTypeTable.Columns.Code.NAME);

                strBuilder.AppendFormat(" WHERE {0} = {1}",
                   SqlCommandHelper.EscapeTableColumnName(PmxZoneTypeTable.NAME, PmxZoneTypeTable.Columns.ShowZoneType.NAME),
                   SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, dbCulture));

                strBuilder.AppendFormat(" AND {0} = {1}",
                   SqlCommandHelper.EscapeTableColumnName(PmxItemZoneTypeTable.NAME, PmxItemZoneTypeTable.Columns.ItemCode.NAME),
                   SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, dbCulture));
                return strBuilder.ToString();
            }

        }




        #endregion

    }


}
